dseg     segment para public 'data'
;
;
;
; windows start here
;  menu structure is:
;    db height
;    db width
;    db x loc
;    db y loc
;    db color
;    db lines of data
;    db 0
;
error0  db 03,22,30,06,0f1h
        db  ' Field is in error',0
;
;
wait0   db 03,38,22,06,0f1h
        db  'Please wait while Optiks is branded  ',0
;
errorsave dw 5*42 dup(0)
;
helpsave  dw 20*42 dup(0) ; for all helps

help0   db 08,55,10,15,07h
 db  ' To Serialize OPTIKS, you will have to enter you ',13,10
 db  ' first and last name as it will appear on the OPTIKS',13,10
 db  ' start up screen. Make sure that the name of the',13,10
 db  ' of the OPTIKS program is correct. Press F10 when',13,10
 db  ' the screen is correct.',13,10
 db  '      Press the ESC key if you wish to quit.',0
help1   db 05,40,20,13,70h
     db  ' First name is your first name of the',13,10
     db  ' first word of your company name.',13,10
     db  '     press any key to continue',0
;
help2   db 07,40,20,15,70h
     db  ' Last Name is your last name or the',13,10
     db  ' last words of your comapny name.',13,10
     db  ' First name + last name cannot be',13,10
     db  ' longer than 39 characters.',13,10
     db  '     press any key to continue',0
;
;
help3   db 06,40,20,15,70h
     db  ' OPTIKS FILE is the name of the .EXE',13,10
     db  ' file. It should be OKPRIV.EXE or',13,10
     db  ' OKFREE.EXE.',13,10
     db  '     press any key to continue',0
;
;
;
;
;
; fl types
fl1    db "D",46,0,16,1,071h,017h,' '
     dw  head1
head1     db '     OVBRAND.EXE OPTIKS Program Serializer               '
fl2    db "D",44,0,17,2,071h,017h,' '
     dw  head2
head2     db "Vers 1.00 Copyright 1989 by Keith P. Graham   "
fl3    db "D",14,0,05,06,041h,017h,' '
     dw  title1
title1    db "First Name:     "
fl4    db "C",17,0,21,06,70h,07h,' '
     dw  fname
fname   db 50 dup(20h)
fl5    db "D",14,0,05,08,41h,17h,' '
     dw  title2
title2    db "Last Name:      "
fl6    db "C",32,0,21,08,70h,07h,' '
     dw  lname
lname     db 50 dup(20h)
fl7    db "D",14,0,05,10,41h,17h,' '
     dw  title3
title3    db "OPTIKS FILE:    "
fl8    db "C",54,0,21,10,70h,07h,' '
     dw  oname
oname     db 65 dup(' ')
;
; structure for fl stuff
;
enterline  dw  (end_tst-$-2)/2
     dw  fl1,fl2,fl3,fl4,fl5,fl6,fl7,fl8
;    dw  fl8,fl9,fl10,fl9a,fl10a,fl11,fl12,fl13,fl14
end_tst equ this byte
clearscreen dw 1,cls
cls    db "D",1,0,16,1,070h,007h,' '
     dw  cls1
cls1      db ' '
;
;
eflag  db  0
handle dw 0
public handle,lname,oname,fname
;
;
serialno  dw  0
tname   db  44 dup(20h)
;
;
extrn exit_phase:word,buffer:word
dseg ends
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:dseg,es:dseg
extrn forms:near,reset_segs:near
main     proc     near
brand:
public brand
;
;  ah has the attribute if we clear screen
;  al has the fl to get if we want to get just 1 fl
;  al has a 0ffh if we want to get all fls
;  al is 0 if we just want to display
;  bx has the fl to start phase cronology from
     lea     si,enterline
     mov     ax,1700h
     mov     bx,0
     call     forms
     lea   si,help0
     lea   di,helpsave
     call  do_window
     mov     bx,3   ; start with field 4
enter_loop:
     lea     si,enterline
     mov     ax,0ffh
     call     forms
     cmp     al,3bh     ; F1
     je     help_fields
     cmp     al,44h     ; F10
     je     check_fields
     cmp     ah,27
     je     exit_prog
     lea     si,enterline
     mov     ax,0ffh
     mov     bx,exit_phase
     jmp     enter_loop
exit_prog:
; clear the screen
     jmp   go_home
check_fields:
    jmp  check_fields0
help_fields:
extrn  do_window:near,undo_window:near

     mov     bx,exit_phase
     sub   bx,3
     jmp   cs:helps[bx]
helps dw do_help1,do_help2,do_help3
set_window:
     cmp   eflag,1
     jne   no_error_check
     push  si
     push  di
     mov   bx,exit_phase
     inc   bx
     shl   bx,1
     mov   si,word ptr enterline[bx]
     mov   al,byte ptr ds:[si]+4
     inc   al
     mov   error0+3,al
     mov   al,byte ptr ds:[si]+3
     mov   error0+2,al
     lea   si,error0
     lea   di,errorsave
     call  do_window
     pop   di
     pop   si
no_error_check:
     push  si
     push  di
     call  do_window
     mov   ah,0
     int   16h
     pop   di
     pop   si
     call  undo_window
     cmp   eflag,1
     jne   exit_help
     mov   eflag,0
     lea   si,error0
     lea   di,errorsave
     call  undo_window
exit_help:
     mov     bx,exit_phase
     jmp     enter_loop
do_help1:
     lea   si,help1
     lea   di,helpsave
     jmp   set_window
do_help2:
     lea   si,help2
     lea   di,helpsave
     jmp   set_window
do_help3:
     lea   si,help3
     lea   di,helpsave
     jmp   set_window
check_fields0:
; check each field
; check field 3, density first
     cmp    fname,' '
     je     bad_c1
     jmp    good_field1
bad_c1:
     mov    eflag,1
     mov    exit_phase,3
     jmp    do_help1
good_field1:
     cmp    lname,' '
     je     bad_c2
     jmp    good_field2
bad_c2:
     mov    eflag,1
     mov    exit_phase,5
     jmp    do_help2
good_field2:
     cmp    oname,' '
     je     bad_c3
     jmp    good_field2a
bad_c3:
     mov    eflag,1
     mov    exit_phase,7
     jmp    do_help3
good_field2a:
; here we have to open the input file
     lea   di,oname
     cld
     mov   al,20h
     mov   cx,54
repne  scasb
    jne   bad_c3
     dec  di
     mov  al,0
     stosb
; have the end of the guy
    mov   cx,di
    sub   cx,offset oname
    dec   cx
; cx has the length of the file name
    cmp   cx,0
    jle   bad_c3
; scan for '.'
    lea   di,oname
    mov   al,'.'
repne scasb
    jne   bad_c3
; have to determine if it is one of us
    mov   si,di
    lodsw
    or   ax,6060h
;   cmp  ax,'xe'
;   jne   bad_c3
do_open_in:
    lea   dx,oname
    call  open_input
    jnc   good_field3
    jmp   bad_c3
; ok to act, do good stuff here
good_field3:
;
; upper the names
    lea  si,fname
    lea  di,tname
    mov  bx,0
    mov  cx,16
    mov  ah,0
gf1:
    lodsb
    cmp  al,'a'
    jl   gf2
    cmp  al,'z'
    jg   gf2
    sub  al,32
gf2:
    stosb
    add  bx,ax
    cmp  al,' '
    je   gf3
    loop gf1
gf3:
    lea si,lname
    mov ax,41
    sub ax,cx
    mov cx,ax
gf4:
    lodsb
    cmp  al,'a'
    jl   gf5
    cmp  al,'z'
    jg   gf5
    sub  al,32
gf5:
    stosb
    add  bx,ax
    loop gf4
    mov  serialno,bx
;
    mov  bx,handle
    mov  cx,0fff0h
    mov  dx,0
    push  ds
    mov  ds,buffer
    mov  ah,3fh
    int  21h
    pop  ds
;
; search for guy
    mov  al,'B'
    mov  cx,ax
    push  es
    mov  di,0
    mov  es,buffer
sb1:
repne  scasb
    jne   no_find
    cmp word ptr es:[di],'Ar'
    jne sb1
    inc  di
    inc  di
    cmp word ptr es:[di],'Dn'
    jne sb1
    inc  di
    inc  di
    cmp byte ptr es:[di],'='
    jne sb1
    inc   di
    cmp word ptr es:[di+2],'U '
    jne sb1
; found what we is looking for!
; di has the seek offset for the new serial number
    pop   es
; seek to di
    mov   ax,4200h
    mov   dx,di
    mov   cx,0
    mov   bx,handle
    int   21h
; write out the 41 bytes
    mov   ah,40h
    lea   dx,serialno
    mov   bx,handle
    mov   cx,42
    int   21h
    mov   bx,handle
    mov   ah,3eh
    int   21h
    jmp   go_home
no_find:
    pop   es
    mov   bx,handle
    mov   ah,3eh
    int   21h
    jmp    bad_c3
;
;
go_home:
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
     ret
;
open_input:
; open a file for i/o
     mov   cx,0
     mov   ax,3d02h
     int   21h
     jnc   good_open_in
     stc
     ret
good_open_in:
     mov   handle,ax
     clc
     ret
;
main  endp
cseg     ends
     end
