print macro string
lea dx,string
mov ah,9
int 21h
endm
;
; this is a skeleton for passthrough  or resident programs
;
; when compiled as a pass through program it will use a little over
; 5K of system memory. When compiled as resident program it takes
; about 1.5k. When you add your own routines an work areas this
; will increase.
;
passthru = 0  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
        db  'Next 4 bytes are scan1,shift1,scan2,shift2:'
scan1   db 2ch     ; these are the hot key combinations
shift1  db 10      ; scan being the scan code and shift being
scan2   db 83h     ; the shift state.
shift2  db 12      ;
sig1   dw  'Kg'
sig2   dw  'Ea'
sig3   dw  '3#'
sig4   dw  '=0'
; this is the area for the font names
inputfile db  'CONFIG.ZEP',0
fontnames db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
          db  80 dup(0)
buffer   db 2048 dup(0)  ; file buffer
handle  dw  0
bytes_read dw 0
bytes_printed dw 0
;
;
;
; data
upleft  equ  201
upright equ  187
loleft  equ  200
loright equ  188
horiz   equ  205
vert    equ  186
must_res   db 0
cursor  dw  0
;
;  This is printer set up strings
printport db 0  ; printer number if entered on command line
;
font_delete db 27,'*c0F',0
id0 db 27,'*c0D',0
id1 db 27,'*c1D',0
id2 db 27,'*c2D',0
id3 db 27,'*c3D',0
id4 db 27,'*c4D',0
id5 db 27,'*c5D',0
id6 db 27,'*c6D',0
id7 db 27,'*c7D',0
id8 db 27,'*c8D',0
id9 db 27,'*c9D',0
fontid dw id0,id1,id2,id3,id4,id5,id6,id7,id8,id9
fontperm db 27,'*c5F',0
;
;
;
save    dw   24*72 dup(0)
; this is the sample window
menu    db   11 ;height
        db   37   ;width
        db   20   ;x location
        db   2     ;y location
        db   17h  ; color
; menu text
        db   "  ZEP Resident Soft Font Control",13
        db   " Copyright 1987 by Keith P. Graham",13
        db   '        Press Esc to exit',13
        db   '   F1 = Soft Font Loading Menu',13
        db   '   F2 = Translation Modes',13
        db   '   F3 = Paper Control',13
        db   '   F4 = Font Selection',13
        db   '   F5 = Show Fonts',13
        db   '          TANSTAAFL'
        db   0  ; screens end with a zero
;
menu11  db   14 ;height
        db   26   ;width
        db   30   ;x location
        db   5     ;y location
        db   27h  ; color
; menu text
        db   "  Load Soft Font Menu",13
        db   '   Press Esc to exit',13
        db   ' F1 = Load Soft Font 1',13
        db   ' F2 = Load Soft Font 2',13
        db   ' F3 = Load Soft Font 3',13
        db   ' F4 = Load Soft Font 4',13
        db   ' F5 = Load Soft Font 5',13
        db   ' F6 = Load Soft Font 6',13
        db   ' F7 = Load Soft Font 7',13
        db   ' F8 = Load Soft Font 8',13
        db   ' F9 = Load Soft Font 9',13
        db   ' F10= Load Soft Font 0',13
        db   0  ; screens end with a zero
;
wind11x db   5  ;height
        db   67   ;width
        db   5    ;x location
        db   3     ;y location
        db   07h  ; color
; menu text
        db   "  Font Number "
fontloadn dw '  '
        db  ' scheduled for loading',13
dsfont  db  64 dup(' ')
        db  13
        db   '        Press any key to continue'
        db   0  ; screens end with a zero
;
wind12x db   4  ;height
        db   41   ;width
        db   15   ;x location
        db   05    ;y location
        db   07h  ; color
; menu text
        db   "  All fonts are"
        db  ' scheduled for loading',13
        db   '        Press any key to continue'
        db   0  ; screens end with a zero
;
wind13x db   4  ;height
        db   33   ;width
        db   20   ;x location
        db   08    ;y location
        db   06h  ; color
; menu text
        db   ' All LaserJet Soft Fonts Reset ',13
        db   '  Press any key to continue'
        db   0  ; screens end with a zero
;
wind14x db   4  ;height
        db   38   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   ' All Scheduled Font Loads Cancelled',13
        db   '    Press any key to continue'
        db   0  ; screens end with a zero
;
menu1   db   8  ;height
        db   30   ;width
        db   10   ;x location
        db   2     ;y location
        db   37h  ; color
; menu text
        db   "   Soft Font Loading Menu",13
        db   '     Press Esc to exit',13
        db   ' F1 = Load a Soft Font',13
        db   ' F2 = Load ALL Fonts',13
        db   ' F3 = Delete all Fonts',13
        db   ' F4 = Cancel Font Loads',13
        db   0  ; screens end with a zero
;
menu2   db   6  ;height
        db   31   ;width
        db   22   ;x location
        db   7     ;y location
        db   37h  ; color
; menu text
        db   "  Translation Mode Settings",13
        db   '     Press Esc to exit',13
        db   ' F1 = Enable Change Strings',13
        db   ' F2 = Disable Change Strings',13
        db   0  ; screens end with a zero
wind21  db   4  ;height
        db   29   ;width
        db   20   ;x location
        db   08    ;y location
        db   06h  ; color
; menu text
        db   '  Translation Mode is Set ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
wind22  db   4  ;height
        db   29   ;width
        db   20   ;x location
        db   08    ;y location
        db   06h  ; color
; menu text
        db   ' Translation Mode is Reset ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
;
menu3   db   10 ;height
        db   34   ;width
        db   22   ;x location
        db   1     ;y location
        db   5fh  ; color
; menu text
        db   "   LaserJet Paper Controls",13
        db   '     Press Esc to exit',13
        db   ' F1 = Number of original copies',13
        db   ' F2 = Page eject',13
        db   ' F3 = Automatic feed from tray',13
        db   ' F4 = Manual feed',13
        db   ' F5 = Manual feed envelope',13
        db   ' F6 = Reset LaserJet',13
        db   0  ; screens end with a zero
menu31  db   14  ;height
        db   33   ;width
        db   20   ;x location
        db   08    ;y location
        db   06h  ; color
; menu text
        db   ' Set Number of Original Copies',13
        db   '     Press Esc to exit',13
        db   '  F1 =  1 original copy',13
        db   '  F2 =  2 original copies',13
        db   '  F3 =  3 original copies',13
        db   '  F4 =  4 original copies',13
        db   '  F5 =  5 original copies',13
        db   '  F6 =  6 original copies',13
        db   '  F7 =  7 original copies',13
        db   '  F8 =  8 original copies',13
        db   '  F9 =  9 original copies',13
        db   '  F10= 10 original copies',13
        db   0  ; screens end with a zero
wind31  db   4  ;height
        db   39   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   ' Number of original copies set to '
orig_x  db   '  ',13
        db   '    Press any key to continue'
        db   0  ; screens end with a zero
wind32  db   4  ;height
        db   32   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   ' Page-eject sent to LaserJet ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
wind33  db   4  ;height
        db   30   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   '       Tray Feed set ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
wind34  db   4  ;height
        db   30   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   '     Manual Feed set ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
wind36  db   4  ;height
        db   30   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   '      LaserJet Reset ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
wind35  db   4  ;height
        db   30   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   '    Envelope Feed set ',13
        db   ' Press any key to continue'
        db   0  ; screens end with a zero
;
menu4   db   14 ;height
        db   27   ;width
        db   10   ;x location
        db   3     ;y location
        db   5fh  ; color
; menu text
        db   "  Activate a Soft Font",13
        db   '    Press Esc to exit',13
        db   ' F1 = Select Soft Font 0',13
        db   ' F2 = Select Soft Font 1',13
        db   ' F3 = Select Soft Font 2',13
        db   ' F4 = Select Soft Font 3',13
        db   ' F5 = Select Soft Font 4',13
        db   ' F6 = Select Soft Font 5',13
        db   ' F7 = Select Soft Font 6',13
        db   ' F8 = Select Soft Font 7',13
        db   ' F9 = Select Soft Font 8',13
        db   ' F10= Select Soft Font 9',13
        db   0  ; screens end with a zero
wind4   db   4  ;height
        db   31   ;width
        db   20   ;x location
        db   08    ;y location
        db   05h  ; color
; menu text
        db   ' Soft Font number '
soft_x  db   '  selected',13
        db   '    Press any key to continue'
        db   0  ; screens end with a zero
menu5   db   14 ;height
        db   70   ;width
        db   4    ;x location
        db   3     ;y location
        db   07h  ; color
; menu text
        db   "  List of Soft Font Files",13
ds0     db   ' 0= ',60 dup(' '),13
        db   ' 1= ',60 dup(' '),13
        db   ' 2= ',60 dup(' '),13
        db   ' 3= ',60 dup(' '),13
        db   ' 4= ',60 dup(' '),13
        db   ' 5= ',60 dup(' '),13
        db   ' 6= ',60 dup(' '),13
        db   ' 7= ',60 dup(' '),13
        db   ' 8= ',60 dup(' '),13
        db   ' 9= ',60 dup(' '),13
        db   '    Press any key to continue'
        db   0  ; screens end with a zero
; stuff for the screen?
h       db  0
w       db  0
he      db  0
we      db  0
x       db  0
xe      db  0
y       db  0
ye      db  0
color   db  0
hide    dw  0
savesi  dw  0
t       dw  0
window_off  dw 0
jmp_line dw do_menu1,do_menu2,do_menu3,do_menu4,do_menu5
         dw exit_w,exit_w,exit_w,exit_w
         dw exit_w,exit_w
jmp_line1 dw do_menu11,do_menu12,do_menu13,do_menu14
         dw exit_w,exit_w,exit_w,exit_w
         dw exit_w,exit_w
jmp_line11 dw sched1,sched2,sched3,sched4
           dw sched5,sched6,sched7,sched8
           dw sched9,sched10
jmp_line2  dw set_translate,reset_translate
         dw exit_w,exit_w,exit_w,exit_w
         dw exit_w,exit_w,exit_w,exit_w
jmp_line3  dw do_menu31,page_eject,tray_feed,man_feed,env_feed
         dw  reset_print
         dw exit_w,exit_w,exit_w,exit_w
         dw exit_w,exit_w,exit_w,exit_w
jmp_line31 dw copy1,copy2,copy3,copy4
           dw copy5,copy6,copy7,copy8
           dw copy9,copy10
jmp_line4 dw do_wind4,do_wind4,do_wind4,do_wind4,do_wind4
          dw do_wind4,do_wind4,do_wind4,do_wind4,do_wind4
; escape codes for 3
esc3_1 db 27,'&l'
esc3_1x db '1X',0
esc3_10 db 27,'&l10X',0
esc3_2  db 27,'&l0H',0
esc3_3  db 27,'&l1H',0
esc3_4  db 27,'&l2H',0
esc3_5  db 27,'&l3H',0
esc3_6  db 27,'E',0
;
;
; this area is used by the resident and passthrough versions
;
stack   dw   256  dup(0)
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
int17     dd  0
int17ip   equ word ptr int17
int17cs   equ word ptr int17 + 2
int1c     dd  0
int1cip   equ word ptr int1c
int1ccs   equ word ptr int1c + 2
int23     dd  0
int23ip   equ word ptr int23
int23cs   equ word ptr int23 + 2
int24     dd  0
int24ip   equ word ptr int24
int24cs   equ word ptr int24 + 2
int28     dd  0
int28ip   equ word ptr int28
int28cs   equ word ptr int28 + 2
psp   dw  0
indos   equ this dword
indosip  dw  0
indoscs  dw  0
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
semaphore db  0
cursmode  dw  0
bhpage    db  0
translate db 0
tphase   db 0
ticks    dw 0
estage   db 0
efont    db 0
eventsw  db 0
event0   db 0
event1   db 0
event2   db 0
event3   db 0
event4   db 0
event5   db 0
event6   db 0
event7   db 0
event8   db 0
event9   db 0
mess1    db  "Execution completed",13,10,10,'$'
font0   db  27,'(0X',0
font1   db  27,'(1X',0
font2   db  27,'(2X',0
font3   db  27,'(3X',0
font4   db  27,'(4X',0
font5   db  27,'(5X',0
font6   db  27,'(6X',0
font7   db  27,'(7X',0
font8   db  27,'(8X',0
font9   db  27,'(9X',0
fontcodes  dw  font0,font1,font2,font3,font4,font5
           dw  font6,font7,font8,font9
estage_line dw estage0,estage1,estage2,estage3,estage4,estage5,estage6
;
; this data is used by the passthru program only
;
if passthru
command_line db 257 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
           dw  128 dup(0)
endif
START        PROC        NEAR
do_event:
; there is an event in the works and we have to figure out what it
; is.
; first save it all
        sti
        mov   cs:savessl,ss
        mov   cs:savespl,sp
        mov   ax,cs
        mov   ss,ax
        lea   sp,stack+510  ; double duty out of the local stack
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        push ds
        push es
        cli
        cld
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
; we can event to our hearts content here
;
; set 23 and 24
        call  set_psp
        call  set_crit
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
; there are 6 different event stages (ESTAGE)
;
; efont = the font we are doing
; found the evnet to check out
        mov  bl,estage
        mov  bh,0
        shl  bx,1
        jmp  estage_line[bx]
estage0:
; estage = 0 - we have done nothing
; here we are ready to find a font that needs sending out
        mov  estage,1
        mov   cx,10
        mov   bx,0
        lea   si,event0
        cld
lf_loop:
        lodsb
        cmp  al,1
        je   found_event
        inc  bx
        loop lf_loop
; no event was found
        mov  estage,0
        mov  efont,0
        mov  eventsw,0
        call  blip
        call  blop
        jmp  event_return
found_event:
        mov  efont,bl
        mov  bh,0
        shl  bx,1
        mov  si,fontid[bx]
        call print_string  ; sets up the event_id
        jnc good_fontid
        call blop
        call blop
        mov  estage,0
        mov  eventsw,0
good_fontid:
        jmp  event_return
estage1:
; estage = 1 - we have completed the font id string can open the file
       mov   estage,2
     mov  al,efont
     mov  ah,0
     mov  dx,0
     mov  cx,80
     mul  cx
     lea  dx,fontnames
     add  dx,ax
     mov  ah,3dh
     mov  al,0
     int  21h
     jnc  by_opene
bad_opene:
     call  blop
     jmp   end_game
by_opene:
     mov   handle,ax
      jmp  event_return
estage2:
; estage = 2 - opened the file can read in a buffer
       mov  estage,3
       mov  ah,3fh
       mov  bx,handle
       mov  cx,2048
       lea  dx,buffer
       int  21h
       cmp  ax,0
       jne  good_reade
;      jmp   done_reading
done_reading:
       mov  estage,4
       jmp   event_return
good_reade:
       mov   bytes_read,ax
       mov   bytes_printed,0
       jmp   event_return
estage3:
; estage = 3 - have a buffer must print it out
; this must loop through the data and print it
      mov  estage,2
       mov   cx,bytes_read
       lea   si,buffer
       add   si,bytes_printed
;
       add   bytes_printed,cx
       sub   bytes_read,cx
       cld
       cmp   cx,128
       jle   pbuff_loop
       sub   bytes_printed,cx
       add   bytes_read,cx
       mov   cx,128
       sub   bytes_read,128
       add   bytes_printed,128
      mov  estage,3
pbuff_loop:
      push  cx
      lodsb
      call  print_byte
      jc   bad_printer
      pop  cx
      loop  pbuff_loop
      cmp   bytes_read,0
      jg   more_to_print
      mov   estage,2
      jmp  event_return
more_to_print:
      mov   estage,3
      jmp  event_return
bad_printer:
      pop   cx
; error with the printer
; close the file and leave
;    jmp   close_and_leave
close_and_leave:
; bad read, close the file and exit
       mov   ah,3eh
       mov   bx,handle
       int   21h
       mov   handle,0
       jmp   bad_opene
estage4:
; estage = 4 - have finished printing, must close
       mov   estage,5
       mov   ah,3eh
       mov   bx,handle
       int   21h
       mov   handle,0
      jmp  event_return
estage5:
; estage = 5 - close successful must print out ending string
      lea   si,fontperm
      call  print_string
      call  blip
end_game:
      mov   estage,0
      mov   bl,efont
      mov   bh,0
      mov   event0[bx],0
      mov  efont,0
      jmp  event_return
estage6:
; event returns here
event_return:
      call  ticker
        call  reset_psp
        call  reset_crit
        sti
        pop  es
        pop  ds
        pop  bp
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        mov  ss,cs:savessl
        mov  sp,cs:savespl
        ret
ticker:
; turn on tone
    push  ax
        in     al,61h
        or     al,3
        out    61h,al
        mov    al,255
        out    42h,al
        mov    al,0
        out    42h,al
        in  al,61h
        and al,11111100b
        out 61h,al
    pop  ax
        ret
timer:
       pushf
       call   cs:int1c
; here we do the lock stuff to keep everyone out while ticking
        sti
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int1c_check
        pop  ax
        iret
int1c_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int1c_check:
; check to see if we are working, once every 3 ticks
        cmp  cs:eventsw,0
        je   int1c_return
        inc  cs:ticks
        cmp  cs:ticks,2
        jle  int1c_return
; here we are
        mov  cs:ticks,0
; there is an event and we are in it, can we do anything?
;
        push  bx
        push  ds
        lds   bx,cs:indos
        cmp   byte ptr ds:[bx],0
        pop   ds
        pop   bx
        je    good_indos
        jmp  int1c_return
good_indos:
; we can do dos calls!!!
        call  do_event
        jmp   int1c_return
;
;
set_psp:
; this sets the current PSP so as not to screw up the application
; PSP.
        mov  ah,51h
        mov  al,0
        mov  bx,0
        int  21h
        mov  psp,bx
        mov  bx,cs
        mov  ah,50h  ; set psp
        mov  al,0
        int  21h
        ret
;
reset_psp:
        mov  bx,psp
        mov  ah,50h  ; set psp
        mov  al,0
        int  21h
     ret
;
;
;
set_crit:
; this routine sets the critical error guys
;
        push  es
        mov   ax,3523h
        int   21h
        mov   int23cs,es
        mov   int23ip,bx
        pop   es
        mov   ah,25h
        mov   al,23h
        lea   dx,int23_handler
        int   21h
;
;
        push  es
        mov   ax,3524h
        int   21h
        mov   int24cs,es
        mov   int24ip,bx
        pop   es
        mov   ah,25h
        mov   al,24h
        lea   dx,int24_handler
        int   21h
;
        ret
reset_crit:
; this guy resets critical errors until needed again
;
        push  ds
        lds   dx,int23
        mov   ah,25h
        mov   al,23h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int24
        mov   ah,25h
        mov   al,24h
        int   21h
        pop   ds
        ret
;
int23_handler:
; this is the critical error guy
; Interrupts 23 and 24 must be directed here only when the
; DOS operations are effective
; Otherwise they have no meaning
;
;   this guy means that we have to display an error and wait
; for a keystroke, clean up the stack, turn on semaphores
; and all of that other good stuff because the user
; took the disk out
; totally ignore until I figure things out
      iret
int24_handler:
; this is the ctrl break guy
; ctrl break is an ignore
      iret
keywait:
; int 28 is the dos wait for keystroke interrupt and it is only
; issued while dos is getting a keystroke and its state
; is saved. This prevents dos from locking up the machine
; and allows us to use the 28
       pushf
       call   cs:int28
; here we do the lock stuff to keep everyone out while ticking
        sti
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int28_check
        pop  ax
        iret
int28_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int28_check:
; check to see if we are working, once every 5 ticks
        cmp  cs:eventsw,0
        je   int28_return
; we can do dos calls!!!
        call  do_event
        jmp   int28_return
;
;
; this routine is the printer port control
got_sig:
     mov  ax,cs:sig3
     mov  dx,cs:sig4
     push cs
     pop  es
     iret
printer:
; check for signiture
     cmp   ax,cs:sig1
     jne   by_printer
     cmp   dx,cs:sig2
     jne   by_printer
     jmp   got_sig
by_printer:
; check to see if it is for us
     cmp  cs:printport,dl
     jne  do_printing
    cmp   cs:eventsw,0
    jne   print_error
; check to see if its to print
     cmp  ah,0
     jne  do_printing
; printer request, check for translation mode
     cmp  cs:translate,1
     jne  do_printing
     cmp  cs:tphase,0
     je   tphase0
     cmp   cs:tphase,1
     je    tphase1
     cmp  cs:tphase,2
     jne  bad_tphase
; have a tphase 2 here
; have the next guy
; al has everyting we need
     cmp   al,'0'
     jl    bad_tphase
     cmp   al,'9'
     jg    bad_tphase
     mov   cs:tphase,0
     call  switch_fonts
     jmp   good_print
tphase0:
     cmp  al,'/'
     jne  do_printing
; we have got the '/'
     mov   cs:tphase,1
     jmp   good_print
bad_tphase:
; screwed up
     mov   cs:tphase,0
;
     push   ax
     mov    al,'/'
     call   print_byte
     pop   ax
     push   ax
     mov    al,'S'
     call   print_byte
     pop   ax
     jmp    do_printing
;
tphase1:
; got the / see if this is an F
     mov   cs:tphase,2
     cmp   al,'S'
     je    good_print
; not an S so we did something wrong
     mov   cs:tphase,0
;
     push   ax
     mov    al,'/'
     call   print_byte
     pop   ax
     jmp    do_printing
do_printing:
     jmp  cs:int17
good_print:
; this fakes out a good print
     mov   ah,90h
     iret
print_error:
; here the printer is in an event and must return to others the
; fake message that the printer is not ready
;
    mov   ah,31h
    iret
switch_fonts:
; depending on the value of al we will switch fonts here
    push  ax
    push  bx
    push  dx
    push  si
    push  ds
    mov  bx,cs
    mov  ds,bx
    sub  al,30h
    mov  bl,al
    mov  bh,0
    shl  bx,1
    mov  si,fontcodes[bx]
    call print_string
exit_switch:
    pop   ds
    pop   si
    pop   dx
    pop   bx
    pop   ax
    ret
print_byte:
; prints a single byte
     push  dx
     push  cx
     mov   cx,64
bp_loop:
     push  cx
     mov   dh,0
     mov   dl,cs:printport
     mov   ah,0
     pushf
     call  cs:int17
     test  ah,25h
     pop   cx
     jz    ok_print
     loop  bp_loop
     pop   cx
     pop   dx
     stc
     ret
ok_print:
     pop   cx
     pop   dx
     clc
     ret
print_string:
; this routine prints a string using direct interrupt calls
;
     cld
     lodsb
     cmp   al,0
     je    end_prints
     call  print_byte
     jnc   print_string
     call  blop
     call  blop
     stc
     ret
end_prints:
     clc
     ret
keyboard:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are ppasssed
;
; first call the keyboard interrupt so that it can handle the
; keystroke
;
        pushf          ; fake the way an interrupt pushes flags
        cli
        call cs:int9
        sti
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int9_shift
        pop  ax
        iret
int9_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int9_shift:
; no one is using this guy so we will check out the shift state
; this uses two hot keys, one is Alt-Left Shift-B and the other
; is Alt-Ctrl-Equal.
;
        mov  ah,2   ; get shift status
        int  16h    ; get keyboard
; status returns in al
        and  al,0fh ; get rid of caps or num lock stuff
;
        cmp  al,cs:shift1 ; has the Alt and Left shift been pressed
        je   test_hot_1
        cmp  al,cs:shift2 ; has the Alt and Ctrl been pressed
        je   test_hot_2
        jmp  int9_return
test_hot_1:
; check to see if the next key to come in is B  scan 40h
        mov  ah,1
        int  16h
        jnz  check_key1
        jmp  int9_return
check_key1:
        cmp  ah,cs:scan1   ; Is the next character the "B" key?
        je   goforit
        jmp  int9_return
test_hot_2:
; check to see if the next key to come in is =  scan 83h
        mov  ah,1
        int  16h
        jnz  check_key2
        jmp  int9_return
check_key2:
        cmp  ah,cs:scan2  ; Is the next character the "=" key?
        je   goforit
        jmp  int9_return
goforit:
; save the world first switch to the local stack to save the
; actual stack.
; ax is the only thing in the local stack ( plus the interrupt ret)
        sti
        mov   cs:savessl,ss
        mov   cs:savespl,sp
        mov   ax,cs
        mov   ss,ax
        lea   sp,stack+510  ; double duty out of the local stack
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        push ds
        push es
; get the p so others won't be messed up
        mov  ah,0
        int  16h
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
;
;
;   the program goes here
         call  do_menu
;
;
;
exit_prog:
        pop  es
        pop  ds
        pop  bp
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        mov  ss,cs:savessl
        mov  sp,cs:savespl
        pop  ax
        mov   cs:semaphore,0
        iret
;
; do menu
do_menu:
          lea    si,jmp_line
          mov    window_off,si
          lea    si,menu
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu
          ret
; this getkey guy will help us use a generic getkey routine
bad_key:
          call   blop
; wait for keystroke
get_key:
          mov     ah,0
          int     16h
          cmp     al,27
          je      exit_esc
          cmp     al,0
          jne     bad_key
          cmp     ah,3bh
          jl      bad_key
          cmp     ah,44h
          jg      bad_key
          sub     ah,3bh
          mov     bl,ah
          mov    bh,0
          shl     bx,1
          push    ax
          push    bx
          call    restore_window
          call    restore_cursor
          pop     bx
          pop     ax
          mov     si,window_off
          call    word ptr ds:[si+bx]
          mov     al,0
          ret
exit_esc:
          call    restore_window
          call    restore_cursor
          mov   al,27
          ret
exit_w:
          mov   al,27
          ret
do_menu1:
; this is font control window
          lea    si,jmp_line1
          mov    window_off,si
          lea    si,menu1
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu1
          ret
do_menu11:
; this is font load
          lea    si,jmp_line11
          mov    window_off,si
          lea    si,menu11
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu11
          ret
do_menu13:
; this sends the string out to reset all fonts
      lea  si,font_delete
      call  print_string
; this is confirm on font kill
          lea    si,wind13x
;
display_w:
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          mov    ax,0
          int    16h
          call    restore_window
          call    restore_cursor
          ret
; these schedule the event to occur
do_menu14:
; unschedules all of the events
      mov eventsw,0
      mov   estage,0
      mov   efont,0
      mov   cx,10
      mov   al,0
      lea   di,event0
      cld
rep   stosb
; this is confirm on font reset
          lea    si,wind14x
;
          jmp    display_w
do_menu12:
      mov eventsw,1
      mov   cx,10
      mov   al,1
      lea   di,event0
      cld
rep   stosb
; this is confirm on font load
          lea    si,wind12x
;
          jmp    display_w
sched1:
      mov fontloadn,'1 '
      mov event1,1
      mov  ax,1
      call  move_dsfont
      jmp  do_wind11
sched2:
      mov fontloadn,'2 '
      mov event2,1
      mov  ax,2
      call  move_dsfont
      jmp  do_wind11
sched3:
      mov fontloadn,'3 '
      mov event3,1
      mov  ax,3
      call  move_dsfont
      jmp  do_wind11
sched4:
      mov fontloadn,'4 '
      mov event4,1
      mov  ax,4
      call  move_dsfont
      jmp  do_wind11
sched5:
      mov fontloadn,'5 '
      mov event5,1
      mov  ax,5
      call  move_dsfont
      jmp  do_wind11
sched6:
      mov fontloadn,'6 '
      mov event6,1
      mov  ax,6
      call  move_dsfont
      jmp  do_wind11
sched7:
      mov fontloadn,'7 '
      mov event7,1
      mov  ax,7
      call  move_dsfont
      jmp  do_wind11
sched8:
      mov fontloadn,'8 '
      mov event8,1
      mov  ax,8
      call  move_dsfont
      jmp  do_wind11
sched9:
      mov fontloadn,'9 '
      mov event9,1
      mov  ax,9
      call  move_dsfont
      jmp  do_wind11
sched10:
      mov word ptr fontloadn,'0 '
      mov event0,1
      mov  ax,0
      call  move_dsfont
;     jmp  do_wind11
do_wind11:
      mov eventsw,1
; this is confirm on font load
          lea    si,wind11x
;
          jmp    display_w
move_dsfont:
; this moves the fontname to dsfont
      lea  di,dsfont+1
      mov  cx,80
      mul  cx
      mov  bx,ax
      lea  si,fontnames
      add  si,bx
      mov  cx,63
      cld
ds_loop:
      lodsb
      cmp  al,0
      je   move_dspace
      stosb
      loop  ds_loop
      ret
move_dspace:
      mov  al,' '
rep   stosb
      ret
do_menu2:
; this is translation modes
          lea    si,jmp_line2
          mov    window_off,si
          lea    si,menu2
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu2
          ret
set_translate:
; this is confirm on the set translate mode
          mov    translate,1
          lea    si,wind21
;
          jmp    display_w
reset_translate:
; this is confirm on the set translate mode
          mov    translate,0
          lea    si,wind22
;
          jmp    display_w
do_menu3:
; this is paper options
          lea    si,jmp_line3
          mov    window_off,si
          lea    si,menu3
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu3
          ret
do_menu31:
; this is number of original pages
          lea    si,jmp_line31
          mov    window_off,si
          lea    si,menu31
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu31
          ret
; these are the options to set original copies
copy1:
      mov  word ptr orig_x,' 1'
      mov  esc3_1x,'1'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy2:
      mov  word ptr orig_x,' 2'
      mov  esc3_1x,'2'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy3:
      mov  word ptr orig_x,' 3'
      mov  esc3_1x,'3'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy4:
      mov  word ptr orig_x,' 4'
      mov  esc3_1x,'4'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy5:
      mov  word ptr orig_x,' 5'
      mov  esc3_1x,'5'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy6:
      mov  word ptr orig_x,' 6'
      mov  esc3_1x,'6'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy7:
      mov  word ptr orig_x,' 7'
      mov  esc3_1x,'7'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy8:
      mov  word ptr orig_x,' 8'
      mov  esc3_1x,'8'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy9:
      mov  word ptr orig_x,' 9'
      mov  esc3_1x,'9'
      lea  si,esc3_1
      call print_string
      jmp  do_wind31
copy10:
      mov  word ptr orig_x,'01'
      lea  si,esc3_10
      call print_string
;     jmp  do_wind31
do_wind31:
          lea    si,wind31
;
          jmp    display_w
page_eject:
          lea   si,esc3_2
          lea   di,wind32
wind_3_stuff:
          call  print_string
          mov   si,di
          jmp    display_w
tray_feed:
          lea   si,esc3_3
          lea   di,wind33
          jmp  wind_3_stuff
man_feed:
          lea   si,esc3_4
          lea   di,wind34
          jmp  wind_3_stuff
env_feed:
          lea   si,esc3_5
          lea   di,wind35
          jmp  wind_3_stuff
reset_print:
          lea   si,esc3_6
          lea   di,wind36
          jmp  wind_3_stuff
do_menu4:
; this is paper options
          lea    si,jmp_line4
          mov    window_off,si
          lea    si,menu4
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   hide_cursor
          call   get_key
          cmp    al,27
          jne    do_menu4
          ret
do_wind4:
; ax has the scan code of the key pressed
;
      mov  al,ah
      mov  ah,0
      add  ax,30h
      mov  soft_x,al
      call switch_fonts
      lea   si,wind4
      jmp    display_w
;
do_menu5:
; ax has the scan code of the key pressed
;
      lea   si,menu5
      jmp    display_w
;
;
;
save_si:
;
          mov    savesi,si
          cld
          lodsb
      mov     h,al
      dec     al
      dec     al
      mov     he,al
          lodsb
      mov     w,al
      dec     al
      dec     al
      mov     we,al
          lodsb
      mov     x,al
          dec al
          add al,w
      mov     xe,al
          lodsb
      mov     y,al
          dec al
          add al,h
      mov     xe,al
          lodsb
      mov     color,al
      mov     t,si
      ret
put_mess:
; puts a message to the screen
          cld
;         call   blip
          mov    si,t
          mov    dh,y
          mov    dl,x
          inc    dh
          inc    dl
          mov    cx,0     ; cl is column
mloop0:
          push   cx
          push   dx
mloop1:
          push   cx
          push   dx
          cmp    ch,he
          jge    end_put_mess
          lodsb
          cmp    al,0
          je     end_put_mess
          cmp    al,10
          je     ignore_char
          cmp    al,13
          je     new_line
          cmp    cl,we
          jge    ignore_char
; got the character put it on the screen
; locate the cursor
          push   ax
          mov    ah,2
          mov    bx,0
          int    10h
          pop    ax
          mov    ah,10
          mov    cx,1
          int    10h
          pop    dx
          pop    cx
          inc    dl
          inc    cl
          jmp    mloop1
new_line:
          pop    dx
          pop    cx
          pop    dx
          pop    cx
          inc    dh
          inc    ch
          jmp    mloop0
ignore_char:
          pop    dx
          pop    cx
          jmp    mloop1
end_put_mess:
          pop    dx
          pop    cx
          pop    dx
          pop    cx
          ret
restore_window:
; puts the old window back
;setup cursor at x,y
          mov    dh,y
          mov    dl,x
; set up save place
          lea    si,save
          cld
; the current cursor position is in dx
          mov    cl,h
          mov   ch,0
rloop1:
          push   cx
          push   dx
          mov    cl,w
          mov   ch,0
rloop2:
          push   cx
          push   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
          lodsw
; put stuff
          mov    bl,ah
          mov    ah,9
          mov    bh,0
          mov    cx,1
          int    10h
          pop    dx
          pop    cx
          inc    dl
          loop   rloop2
          pop    dx
          pop    cx
          inc    dh
          loop   rloop1
          ret
save_window:
;setup cursor at x,y
          mov    dh,y
          mov    dl,x
; set up save place
          lea    di,save
          cld
; the current cursor position is in dx
          mov    cl,h
          mov    ch,0
wloop1:
          push   cx
          push   dx
          mov    cl,w
          mov   ch,0
wloop2:
          push   cx
          push   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; ax has the attrib and byte
          stosw
; find out what to put in al
          push   dx
          mov    al,20h
          cmp    dh,y  ; row
          je     top_row
          inc    dh
          sub    dh,h
          cmp    dh,y
          je     bot_row
          cmp    dl,x
          je     left_col
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     right_col
          jmp    end_loop1
left_col:
right_col:
          mov    al,vert
          jmp    end_loop1
bot_row:
          mov    al,horiz
          cmp    dl,x
          je     bot_left
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     bot_right
          jmp    end_loop1
bot_right:
          mov    al,loright
          jmp    end_loop1
bot_left:
          mov    al,loleft
          jmp    end_loop1
top_row:
          mov    al,horiz
          cmp    dl,x
          je     top_left
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     top_right
          jmp    end_loop1
top_right:
          mov    al,upright
          jmp    end_loop1
top_left:
          mov    al,upleft
;          jmp    end_loop1
end_loop1:
          pop    dx
; place the correct character and attribute at the position
          mov    ah,9
          mov    bl,color
          mov    cx,1
          mov    bh,0
          int    10h
          pop    dx
          pop    cx
          inc    dl
          loop   jmp_wloop2
          jmp    by_wloop2
jmp_wloop2:
          jmp    wloop2
by_wloop2:
          pop    dx
          pop    cx
          inc    dh
          loop   jmp_wloop1
          jmp    by_wloop1
jmp_wloop1:
          jmp    wloop1
by_wloop1:
; have to hid the cursor
          dec    dh
          dec    dh
          add    dl,w
          dec   dl
          dec    dl
          mov    hide,dx
          ret
hide_cursor:
          mov    dx,hide
          mov    ah,2
          mov    bx,0
          int    10h
          mov    bl,color
          and    bl,0f0h
          mov    al,bl
          mov    cl,4
          shr    al,cl
          or     bl,al
          mov    al,0
          mov    ah,9
          mov    cx,1
          mov    bh,0
          int    10h
          ret
START        ENDP
getcurs   proc  near
save_cursor:
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
restore_cursor:
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
setpass  proc  near
     print hithere
; set up a local stack
        lea  sp,stack+510
; check and see if we are already in
     mov   ax,sig1
     mov   dx,sig2
     int   17h
     push  ax
     mov   ax,cs
     mov   ds,ax
     mov   es,ax
     pop   ax
     cmp  ax,sig3
     jne  do_getzep
     cmp  dx,sig4
     jne  do_getzep
     print err1
     int   20h
do_getzep:
; have to open the config.file
     lea  dx,inputfile
     mov  ah,3dh
     mov  al,0
     int  21h
     jnc  by_open
bad_open:
     print err2
     int   20h
by_open:
     mov   handle,ax
     mov   bx,ax
     mov   cx,512
     lea   dx,buffer
     mov   ah,3fh
     int   21h
     jc   bad_open
     cmp  ax,5
     jle  bad_open
; got a file
     mov  cx,ax
     print mess2
     lea  si,buffer
     cld
get_port:
     lodsb
     cmp  al,13
     je   bad_port
     cmp  al,1ah
     je   bad_port
     cmp  al,' '
     je   gp_endl
     cmp  al,'1'
     jl   bad_port
     cmp  al,'4'
     jg   bad_port
     sub  al,31h
     mov  printport,al
     jmp  run_line
gp_endl:
     loop get_port
bad_port:
     print err3
     int  20h
bad_name:
     print err4
     int  20h
run_line:
; have to run out the current line
     lodsb
     cmp   al,13
     je   ran_line
     cmp   al,1ah
     je   bad_name
     loop  run_line
     jmp   bad_name
ran_line:
; have a file name to find
     lea  di,fontnames
     mov  bx,cx
     mov  cx,10
fn_loop:
     push cx
     push di
     mov  cx,bx
space_loop:
     lodsb
     dec  bx
     cmp  al,1ah
     je   done_names
     cmp  al,13
     je   new_name
     cmp  al,10
     je   by_space_loop
     cmp  al,20h
     jne  store_byte
by_space_loop:
     loop  space_loop
     jmp   done_names
name_loop:
     lodsb
     dec  bx
     cmp  al,1ah
     je   done_names
     cmp  al,13
     je   new_name
     cmp  al,10
     je   by_store_byte
     cmp  al,20h
     je   by_store_byte
store_byte:
     stosb
by_store_byte:
     loop name_loop
     jmp  done_names
new_name:
     pop  di
     pop  cx
     add  di,80
     loop  fn_loop
done_names:
     pop  cx
     pop  si
; close the input file
     mov  ah,3eh
     mov  bx,handle
     int  21h
;
; check out the guys we have
     mov   ax,cs
     mov   ds,ax
     mov   es,ax
if passthru
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   jle   no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
endif
; check out these suckers
; set the DTA at 80h, This might not be set if we are passed through
;
;  set dta here
;
    mov   cx,10
    mov   bp,0
    mov   ax,0
    lea   di,ds0+4
fcheck_loop:
    push  ax
    push  cx
    push  di
; ax has the number we are working on
    mov   cx,80
    mul   cx
    lea   dx,fontnames
    add   dx,ax
    mov   bx,dx
    cmp   byte ptr ds:[bx],0
    je    next_fcheck
    mov   ah,4eh
    mov   cx,0
    int   21h
    jc    bad_fcheck
    inc  bp
; now move the guy in dx to the ds0 guy
    mov   si,dx
    mov   cx,60
mv_floop:
    lodsb
    cmp   al,0
    je next_fcheck
    stosb
    loop  mv_floop
    jmp   next_fcheck
bad_fcheck:
; print the error
    print err4
    int  20h
;
next_fcheck:
    pop   di
    pop   cx
    pop   ax
    add   di,65
    inc   ax
    loop  fcheck_loop
    cmp  bp,0
    jne  do_install
; error
    print err5
    int  20h
;
do_install:
; rest seg regs
     mov   ax,cs
     mov   ds,ax
     mov   es,ax
;
; redirect interrupts here
;
        push  es
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        pop   es
        mov   ah,25h
        mov   al,9h
        lea   dx,keyboard
        int   21h
;
        push  es
        mov   ax,351ch
        int   21h
        mov   int1ccs,es
        mov   int1cip,bx
        pop   es
        mov   ah,25h
        mov   al,1ch
        lea   dx,timer
        int   21h
;
        push  es
        mov   ax,3517h
        int   21h
        mov   int17cs,es
        mov   int17ip,bx
        pop   es
        mov   ah,25h
        mov   al,17h
        lea   dx,printer
        int   21h
;
        push  es
        mov   ax,3528h
        int   21h
        mov   int28cs,es
        mov   int28ip,bx
        pop   es
        mov   ah,25h
        mov   al,28h
        lea   dx,keywait
        int   21h
;
; get the INDOS flag
        push  es
        mov   ah,34h
        int   21h
        mov   indosip,bx
        mov   indoscs,es
        pop   es
;
;
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   cs:semaphore,1
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int9
        mov   ah,25h
        mov   al,9h
        int   21h
        pop   ds
        push  ds
        lds   dx,int17
        mov   ah,25h
        mov   al,17h
        int   21h
        pop   ds
        push  ds
        lds   dx,int1c
        mov   ah,25h
        mov   al,1ch
        int   21h
        pop   ds
        push  ds
        lds   dx,int28
        mov   ah,25h
        mov   al,28h
        int   21h
        pop   ds
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
last_byte equ this byte
err1   db 7,'This program has been previously installed.',13,10
       db 'Installation procedure aborted!',13,10,'$'
err2   db 7,'File CONFIG.ZEP not found.',13,10
       db 'Installation procedure aborted!',13,10,'$'
mess2  db 'Analyzing CONFIG.ZEP',13,10,'$'
hithere db 'ZEP.COM  resident soft font loader Version 1.00',13,10
       db  'Copyright November 20, 1987 by Keith P. Graham',13,10
       db  'Press Alt-Left Shift-Z to start ZEP',13,10
       db  'Registration required',13,10,'$'
err3   db 7,'Invalid or missing printer port number',13,10,'$'
err4   db 7,'Invalid Soft font name',13,10,'$'
err5   db 7,'No Soft fonts found',13,10,'$'
CSEG        ENDS
        END        ENTPT
