; this is the present routine
lineno  dw  0  ; current line
column  dw  0  ; current x offset
mmax    dw  0
nmax    dw  0
vwid    dw  512
vbuffer dw  0a000h
keys    db  47h,48h,50h,4bh,4dh,49h,51h,31h,31h
ckeys   dw  9
keyjmp  dw  home,up_key,dn_key,left_key,right_key,pgup,pgdn
        dw  n_key,n_key

n_key:
     xor  switchn,'n'
     jmp  top_control
control:
home:
      mov  lineno,0
      mov  column,0
top_control:
      cmp   lineno,0
      jge   ok_1
      mov   lineno,0
ok_1:
      mov   ax,height_pix
      sub   ax,lineno
      sub   ax,vid_len
      cmp   ax,0
      jge   ok_1a
      add   lineno,ax
      cmp   lineno,0
      jge   ok_1a
      mov   lineno,0
ok_1a:
      mov   ax,column
      cmp   ax,vwid
      jl    ok_2
      sub   ax,vwid
      mov   column,ax
ok_2:
      cmp  ax,0
      jg   ok_3
      mov  column,0
ok_3:
; check to see if pic is way off left
      mov  ax,width_pix
      sub  ax,column
      cmp  ax,vid_wid
      jge  ok_3a
      mov  ax,width_pix
      sub  ax,vid_wid
      mov  column,ax
      cmp  ax,0
      jg   ok_3a
      mov  column,0
ok_3a:
      mov  ax,height_pix
      sub  ax,vid_len
      cmp  lineno,ax
      jle  ok_4
      mov  lineno,0
ok_4:
      call present
; check to see if name is required
      cmp  switchn,'n'
      jne  top_key
; print the name
      mov  di,offset file1
      mov  cx,64
      cld
      mov al,0
repne scasb
      sub   cx,63
      neg   cx
      mov  dx,si
      mov  dl,0
      mov  dh,0
      mov  ah,13h
      mov  al,0
      mov  bp,offset file1
      mov  bx,7
      int  10h

top_key:
      mov   ah,0
      int   16h
      cmp   al,27
      je    escape
      cmp   ax,4400h
      je    escape
      xchg  al,ah
      lea   di,keys
      cld
      push  cs
      pop   es
      mov   cx,ckeys
repne  scasb
      jne  top_key
      inc  cx
      sub  cx,ckeys
      neg  cx
      mov  bx,cx
      shl  bx,1
      jmp  word ptr cs:keyjmp[bx]
escape:
      ret
left_key:
      sub   column,32
      jmp   top_control
right_key:
      add   column,32
      jmp   top_control
up_key:
      sub   lineno,16
      jmp   top_control
dn_key:
      add   lineno,16
      jmp   top_control
pgup:
      sub   lineno,64
      jmp   top_control
pgdn:
      add   lineno,64
      jmp   top_control

; present is actually puting an image to the screen
;
present:
; have to keep track of the max number of bytes in a vesa buffer
      push es
      mov  es,vbuffer
      mov  di,0
      mov  cline,-1
      mov  cx,vid_len
      mov  bp,lineno
pr_loop:
      push  cx
      push  bp

      mov   dx,0
      mov   ax,bp
      imul  vwid     ; giving bytes into vbuf
      mov   cx,SEGMENTSIZE  ; buffersize
      idiv   cx        ; which buffer
      mov   curr_mb,ax
;     call   set_curr_mb
      mov   si,dx     ; remaining bytes
      add   si,column
      mov   di,0
      mov   dx,0
      inc     cline
      call  calc_bank
; here do vid_wid suff
      mov   cx,width_bytes
      sub   cx,column
      cmp   cx,vid_wid
      jl    p_1
      mov   cx,vid_wid
p_1:
      mov   dx,vid_wid
      sub   dx,cx
;     mov   dx,0
;     mov   cx,vid_wid
; si has where from, bx has the bank, di has the screen offset
; cx has how much to send out, dx has the blank at the end of the
; line
      cmp   cx,0
      je    p_3
      push  ds
      call  get_curr_mb
      mov   ds,ax
      mov   ax,0
prs_loop:
      cmp   di,0
      jne   prs_0
; have to move to next bank
      push  dx
      push  ds
      push  cs
      pop   ds
      mov   di,0
      mov   dx,ax
      call  calc_bank
      pop   ds
      pop   dx
prs_0:
      cld
      movsb
      inc   ax
      loop   prs_loop
      pop   ds
; here we are going to move cx guys over to the screen, but....
; we may be near the end of a vesa buffer
p_3:
      cmp   dx,0
      je    p_4
      mov   di,0
      mov   dx,ax
      call  calc_bank
      mov   cx,dx
      push  ds
      call  get_curr_mb
      mov   ds,ax
      cld
      mov   al,0
;rep   stosb
      pop   ds
p_4:
      pop   bp
      inc   bp
      pop   cx
      loop  pr_loopb
      jmp   pr_loopx
pr_loopb:
      jmp   pr_loop
pr_loopx:
      pop   es
      ret
calc_bank	proc  near
; this procedure calculates bases on the values in bx,etc
; the new bank and places the result in di
        push    ax
        push    dx
        push    ds
        push    es
        mov     ax,cline
        mov     di,dx
	imul	vid_wid 		;640 bytes wide in most cases
        add     ax,di
        adc     dx,0
	mov	di,ax
	mov	ax,dx
	cmp	ax,curbk
	jz	nonew
	call    newbank         ;switch banks if a new bank entered
nonew:
        pop      es
        pop      ds
        pop      dx
        pop      ax
	clc
	ret

calc_bank	endp


newbank	proc near		;bank number is in AX
	cli
	mov	curbk,ax
	push	ax
	push	bx
	push	cx
	push	dx
;	mov	cl,vesashift
;	shl	ax,cl
	mov	dx,ax
	xor	bx,bx
	mov	ax,4f05h
	int	10h
	sti
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret


newbank	endp

