.MODEL TINY
.CODE
org 100h
entry_point:
	jmp install
; data
old_int  dd  0
      db 0
command_length dw 0
command_name db 9 dup(0)
new_21:
     cmp   ah,4bh
     jne   go_old_21
;    int 3
     cmp   si,'KG'
     jne   not_test
     cmp   di,'MW'
     jne   not_test
; this is a test to get the es:di to uninstall things
     mov  si,"WM"
     mov  di,"GK"
     mov  bx,cs
     iret
not_test:
     push  ax
     push  si
     push  di
     push  es
     push  cs
     pop   es
     mov   si,dx
looper:
     cld
; search forward for '.'
find_dot:
     lodsb
     cmp   al,13
     je    not_here
     cmp   al,0
     je    not_here
     cmp   al,'.'
     jne   find_dot
; got the dot work backwards
     mov   di,word ptr cs:command_length
     add   di,offset command_name
     dec   di
     dec   si
     dec   si
     std
matchum:
     lodsb
     cmp   byte ptr es:[di],0
     je    hit_command
     cmp   al,'a'
     ja    no_or
     or    al,32
no_or:
     cmp   al,byte ptr es:[di]
     jne   not_here
     dec   di
     jmp   matchum


hit_command:
     mov   byte ptr ds:[si+01],'*'
not_here:
     pop  es
     pop  di
     pop  si
     pop  ax
go_old_21:
     jmp   cs:old_int

;

install:
      mov  ah,9
      mov  dx,offset hello
      int  21h
      call check_line
      jnc  install2
      jmp  uninstall
install2:
      mov   ax,3521h
      int   21h
      mov   word ptr old_int,bx
      mov   word ptr old_int+2,es
      mov   dx,offset new_21
      mov   ax,2521h
      int   21h
      mov  ah,9
      mov  dx,offset hello1
      int  21h
      mov   dx,offset install
      int   27h
check_line:
      mov   cl,byte ptr ds:[80h]
      mov   ch,0
      cmp   cx,2
      ja    cont_line
bad_line:
      mov  ah,9
      mov  dx,offset err2
      int  21h
      int 20h
cont_line:
      mov  si,81h
      mov  di,offset command_name
      cld
      mov  bx,0
space_loop:
      lodsb
      cmp  al,13
      je   bad_line
      cmp  al,' '
      je   space_loop
      cmp  al,'/'
      je  got_sw
      cmp  al,'-'
      je  got_sw
      cmp  al,9
      je  space_loop
cont_loop:
      cmp   al,'a'
      ja    install4
      cmp   al,'.'
      je    bad_line
      cmp   al,':'
      je    bad_line
      cmp   al,'\'
      je    bad_line
      or    al,32
install4:
      stosb
      inc  bx
      cmp  bx,8
      jg   bad_line
      lodsb
      cmp  al,' '
      je   done_line
      cmp  al,9
      je   done_line
      cmp  al,13
      je   done_line
      jmp  cont_loop
got_sw:
      lodsb
      or   al,32
      cmp  al,'u'
      jne  bad_line
      mov  switch,al
      stc
      ret
done_line:
      mov   command_length,bx
      clc
      ret
bad_un:
      mov  ah,9
      mov  dx,offset err1
      int  21h
      int  20h

uninstall:
; get rid of settings

; get address of current install
     mov   si,'KG'
     mov   di,'MW'
     mov   ah,4bh
     mov   dx,0
     mov   cx,0
     mov   bx,0
     mov   bp,0
     mov   al,0
     int   21h
     cmp  si,"WM"
     jne  bad_un
     cmp  di,"GK"
     jne  bad_un
; reset interrupt
     mov  ds,bx
     mov  es,bx
     push ds
     push es
     lds  dx,dword ptr es:old_int
      mov   ax,2521h
      int   21h
     pop  es
     pop  ds
; free environment
     push  es
     mov   bx,word ptr ds:[2ch]
     mov   es,bx
     mov   ah,49h
     int   21h
     pop   es
; free memory
     mov   ah,49h
     int   21h
; say hi
      mov  ax,cs
      mov  ds,ax
      mov  es,ax
      mov  ah,9
      mov  dx,offset hello2
      int  21h
      int  20h

switch db 0
hello db 13,10,"XLOCK Copyright 1994 by Keith P. Graham",13,10
      db "BBS - (914) 623-0039",13,10,'$'
err1  db 13,10,"XLOCK not installed",13,10,'$'
err2  db 13,10,"Form of XLOCK command is:",13,10
      db "XLOCK program_name",13,10
      db "    OR to uninstall:",13,10
      db "XLOCK -U",13,10
      db 13,10,"EXAMPLES:",13,10
      db "XLOCK scan",13,10
      db "XLOCK format",13,10
      db 13,10,"Note: XLOCK does not stop internal commands such as",13,10
      db "erase, del and dir",13,10,"$"
hello1 db 13,10,"XLOCK installed",13,10,'$'
hello2 db 13,10,"XLOCK Uninstalled",13,10,'$'
     end entry_point
