print macro string
    lea dx,string
    mov ah,9
    int  21h
    endm
float struc
 fsign db ?
 fexp  dw ?
 fhigh dw ?
 fdech dw ?
 fdecl dw ?
float ends
cseg segment public 'CODE'
assume cs:cseg,ds:cseg
org 100h
entry: jmp start
; this is 32 bit floating point (integer for now
x1 float <1,0,123,0ffffh,0ff00h>
ent  db "?$"
wbuff db 63 dup(0),'$'
ibuff db 20,0,20 dup(0)
crlf  db 13,10,'$'
start:
      lea  di,x1
      call finput
      lea  si,x1
      call fout
      int  20h
;
;
;
;
finput:
; this reads the guy in
     print  ent
     mov    ah,10
     lea    dx,ibuff
     int    21h
     print crlf
     lea    si,ibuff+2
; up to decimal point
     mov    ds:[di].fsign,1
     mov    ds:[di].fexp,0
     mov    ds:[di].fhigh,0
     mov    ds:[di].fdecl,0
     mov    ds:[di].fdech,0
     cld
     mov    bp,0
     mov    bx,0
f1:
    lodsb
    cmp  al,20h
    je   f1
    cmp  al,'-'
    je   f2
    cmp  al,'+'
    je   f3
    cmp  al,'.'
    je   f4
    cmp  al,30h
    jl   f9
    cmp  al,39h
    jg   f9
    and  al,15
    mov  ah,0
    xchg ax,bx
    mov  cl,10
    mul  cl
    add  bx,ax
    adc  dx,0
    jmp  f1
f2:
    mov  ds:[di].fsign,-1
    jmp   f1
f3:
    mov  ds:[di].fsign,1
    jmp   f1
f4:
; decimal point
    mov   ds:[di].fhigh,bx
    jmp   ff0
f9:
;
    mov   ds:[di].fhigh,bx
    jmp   ff9
multp:
; bp,bx keep the current floater
; (a + b)*c = a*c + b*c
    and  al,15
    mov  ah,0
    push ax
    push bp
    mov  cx,10
; mult bx first as in integer
    mov  ax,bx
    mul   cx
    mov   bx,ax
    mov   bp,dx
    pop   ax  ; used to be bp
    mul   cx
    add   bp,ax
    pop   ax  ; our incoming guy
    add   bx,ax
    adc   bp,0
    ret
ff0:
; have the decimal point
    mov   ax,0
    mov   dx,0
    mov   bx,0
    mov   bp,0
    mov   cx,8
ff1:
    push  cx
    lodsb
    cmp  al,30h
    jl   ff3
    cmp  al,39h
    jg   ff3
    call multp
    pop  cx
    loop ff1
    jmp  ff4
ff2:
    push cx
ff3:
    mov  ax,0
    call multp
    pop  cx
    loop ff2
ff4:
; bp:bx has the number
;
;
; number has to be div by 100,000,000
; has to be mul by 1,00,00,00,00
;
    push  bp  ; high order
    push  bx
    mov   ax,bx
    mov   dx,0
    mov   bx,0
    mov   bp,0
    mov   cx,10000
; dx:ax is the bottom 8 bits of number
    mov   dx,ax  ; mul 1,00,00
    mov   ax,0
    mov   dh,0
    idiv   cx
    push  dx  ; never div, mul 2
     ; ax is div 1 mul 2
      mov  dh,0
      mov  dl,ah
      mov  ah,al
      mov  al,0  ; mul 3
      idiv  cx
      push  dx ; div 1 mul 3
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 4
        add  bx,ax
        adc  bp,dx  ; done here
      pop  dx  ; div 1 mul 3
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 4
      idiv cx
      adc  bx,ax
      adc  bp,0    ; discard remainder
    pop   dx  ; never div mul 2
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 3
    idiv cx
    push dx   ; 0 div mul 3
      mov  dh,0
      mov  dl,ah
      mov  ah,al
      mov  al,0   ; mul 4 div 1
      idiv cx
      add  bx,ax ; ax is div2 mul 4
      adc  bp,0
    pop  dx  ; 0 div 3 mul
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 4
    idiv cx
    add  bx,ax  ; throw out dx
;
;
    pop   ax
    pop   dx
    mov   al,ah
    mov   ah,dl
    mov   dl,dh
    mov   dh,0   ; mul -1
; dx:ax is mul 1 div 0
    idiv  cx
    push  dx    ; div 0 mul -1
      mov  dh,0
      mov  dl,ah
      mov  ah,al
      mov  al,0  ; mul 0
      idiv cx    ;
      ; ax is div 2 mul 0 ; discard
      add  ax,7fffh
      adc  bx,0
      adc  bp,0
      ; dx has div 1 mul 0
      mov   al,0
      mov   ah,dl
      mov   dl,dh
      mov   dh,0   ; mul 1 div 1
      idiv  cx
      push  dx    ; div 1 mul 1
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 2 div 2
        add  bp,ax ; mult quick 2 more
      pop   dx   ; div 1 mul 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 2
      idiv cx
      add  bp,ax  ; div 2 mul 2 quick mult
      ; dx has mul 2 div 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 3
      idiv  cx
      push  dx  ; div 1 mul 3
        ; ax is div 2 mul 3
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 4
        add  bx,ax
        adc  bp,dx
      pop  dx  ; div 1 mul 3
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 4
      idiv  cx
      ; ax is div 2 mul 4  ; dx is mul 4 div 1, discard?
      add  bx,ax
      adc  bp,0
;     mov  al,0
;     mov  ah,dl
;     mov  dl,dh
;     mov  dh,0   ; mul 5
;     idiv  cx
;     ; ax is mul 5 div 2
;     add  ax,7fh
;     mov  al,ah
;     mov  ah,0  ;mult -1
;     add  bx,ax
;     adc  bp,0
    pop   dx    ; div 0 mul -1
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 0
    idiv  cx
    push  dx    ; never div mul 0
      ; ax is div 1 mul 0
      mov  dh,0
      mov  dl,ah
      mov  ah,al
      mov  al,0  ; mul 1
      idiv cx
      push  dx   ; div 1 mul 1
        ; ax is div 2 mul 1
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 2
        add  bp,ax
      pop  dx  ; div 1 mul 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 2
      idiv cx
      add  bp,ax  ; div 2 mul 2 quick mult
      ; dx has mul 2 div 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 3
      idiv  cx
      push  dx  ; div 1 mul 3
        ; ax is div 2 mul 3
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 4
        add  bx,ax
        adc  bp,dx
      pop  dx  ; div 1 mul 3
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 4
      idiv  cx
      ; ax is div 2 mul 4  ; dx is mul 4 div 1, discard?
      add  bx,ax
      adc  bp,0
;     mov  al,0
;     mov  ah,dl
;     mov  dl,dh
;     mov  dh,0   ; mul 5
;     idiv  cx
;     ; ax is mul 5 div 2
;     add  ax,7fh
;     mov  al,ah
;     mov  ah,0  ;mult -1
;     add  bx,ax
;     adc  bp,0
;
    pop   dx  ; never div mul 0
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 1
    idiv cx
    push dx  ; div 0 mul 1
    ; ax is div 1 mul 1
      mov   dx,ax; div 1 mul 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 2
      idiv cx
      add  bp,ax
      ; dx has mul 2 div 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 3
      idiv  cx
      push  dx
        ; ax is div 2 mul 3
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 4
        add  bx,ax
        adc  bp,dx
      pop  dx  ; div 1 mul 3
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 4
      idiv  cx
      ; ax is div 2 mul 4
      add  bx,ax
      adc  bp,0
    pop  dx  ; div 0 mul 1
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 2
    idiv  cx
    push  dx    ; div 0 mul 2
      ; ax is div 1 mul 2
      mov  dx,ax
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 3
      idiv  cx
      push  dx  ;div 1 mul 3
        ; ax is div 2 mul 3
        mov  dh,0
        mov  dl,ah
        mov  ah,al
        mov  al,0  ; mul 4
        add  bx,ax
        adc  bp,dx
      pop  dx  ; div 1 mul 3
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 4
      idiv  cx
      ; ax is div 2 mul 4
      add  bx,ax
      adc  bp,0
    pop   dx    ; div 0 mul 2
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 3
    idiv  cx
    push  dx    ; div 0 mul 3
      mov   dx,ax
      ; dx is mul 3 div 1
      mov  al,0
      mov  ah,dl
      mov  dl,dh
      mov  dh,0   ; mul 4
      idiv  cx
      ; ax is div 2 mul 4
      add  bx,ax
      adc  bp,0
    pop  dx  ; div 0 mul 3
    mov  al,0
    mov  ah,dl
    mov  dl,dh
    mov  dh,0   ; mul 4
    idiv  cx
    add   bx,ax
    adc   bp,0
;
    mov   ds:[di].fdech,bp
    mov   ds:[di].fdecl,bx
;
;
ff9:
; go home
    ret
;
fout: ; prints a field
      lea   di,wbuff
      mov   dx,0
      mov   ax,ds:[si].fhigh
      call  bin2dec
      mov   al,'.'
      stosb
;
;
; strategy is to mult by 10000000 and divide by 1,00,00,00,00
;
      mov   ax,ds:[si].fdech   ; div by 1,00,00
      mov   cx,10000
      mul   cx
      push  ax    ; mul 1 div 1
        mov  ax,dx             ; div by 1,00,00
        mul  cx
        mov  bx,ax
        mov  bp,dx
      pop  ax     ; mul 1 div 1
      mul  cx
      add  ax,cx
      adc  bx,dx
      adc  bp,0    ; div by 2
      mov   ax,ds:[si].fdecl   ; low byte not div yet
      mul   cx
      add   ax,cx
      adc   dx,0
      mov   ax,dx   ; div 1
      mul   cx
      add   ax,cx
      adc   bx,dx   ; div 2
      adc   bp,0
      mov   ax,bx
      mov   dx,bp
      call  bin2dec
;
      print wbuff
      ret
bin2dec:
      mov   cx,10000
      idiv   cx
      push  dx
      mov   cx,100
      mov    dx,0
      idiv   cx
      mov   cl,10
      idiv   cl
      or    ax,3030h
      stosw
      mov   ax,dx
      idiv   cl
      or    ax,3030h
      stosw
      pop    ax
      mov   cx,100
      mov    dx,0
      idiv   cx
      mov   cl,10
      idiv   cl
      or    ax,3030h
      stosw
      mov   ax,dx
      idiv   cl
      or    ax,3030h
      stosw
      ret
cseg ends
     end  entry
