#include        <dos.h>
#include        <errno.h>
#include        <fcntl.h>
#include        <io.h>
#include        <sys\types.h>
#include        <sys\stat.h>
#include        <string.h>
#include        <stddef.h>
#include        <stdio.h>
#include        <stdlib.h>
#include        <malloc.h>
int canon(char *targ,char *src);
int getpath(char *t,char *s);


char inifile[128] = "";
char topic[64];
char item[256];
char value[128];

char t[64];

char newfile[128];

char work[256];
char work1[256];

FILE *infile;
FILE *outfile;

main(int argc,char *args[])
{
    int sp;
    int j;
    int eof;
    char c1,c2;
    int gottopic;
    int gotitem;
    char *s;
    /* get parms */
    sp=0;
    puts("\nINIFUP version 1.0 copyright 1993 by Keith P. Graham");
    puts("238 Germonds Road");
    puts("West Nyack, NY 10994");
    puts("Continued use requires $35.00 shareware fee.");
    puts("Contact Keith Graham Support BBS at (914) 623-0039 for more information.");
    for(j=1;j<argc;j++)
    {
	c1=args[j][0];
	c2=args[j][1];
	if((c1 == '-') || (c1 == '/'))
	{
	    /* got a switch */
	}
	else
	{
	    switch(sp)
	    {
	    case 0:
		canon(work,args[j]);
		strcpy(inifile,work);
		getpath(newfile,work);
		strcat(newfile,"\\~inifup.tmp");
		break;
	    case 1:
		strcpy(topic,args[j]);
		break;
	    case 2:
		strcpy(item,args[j]);
		break;
	    case 3:
		strcpy(value,args[j]);
		break;
	    }
	    sp++;
	}
    }
    if((sp != 4) || (inifile[0] == 0))
    {
	puts("\nFormat of INIFUP is:");
	puts("INIFUP file.ini topic item \"value\" ");
	exit(-1);
    }
    if((infile=fopen(inifile,"rt")) == NULL)
    {
	printf("\nError opening .INI file %s \n",inifile);
	exit(-1);
    }
    if((outfile=fopen(newfile,"wt")) == NULL)
    {
	printf("\nError opening temp file %s \n",newfile);
	exit(-1);
    }
    gottopic=0;
    gotitem=0;
    eof=0;
    if(topic[0] == '[')
	strcpy(t,topic);
    else
    {
	strcpy(t,"[");
	strcat(t,topic);
	strcat(t,"]");
    }
    if(fgets(work,255,infile) == NULL)
	eof=1;
    while((!eof) && (!gottopic))
    {
	fputs(work,outfile);
	s=strtok(work," \n");
	if(s != NULL)
	    if(!strcmpi(t,s))
		gottopic=1;
	if(fgets(work,255,infile) == NULL)
	    eof=1;
    }
    /* either end of file or got the topic */
    if(gottopic)
    {
	/* got the topic have to find the item */
	if(eof)
	{
	    strcat(item,"=");
	    strcat(item,value);
	    strcat(item,"\n");
	    fputs(item,outfile);
	    gotitem=1;
	}
	while((!eof) && (!gotitem))
	{
	    strcpy(work1,work);
	    s=strtok(work1,"= ");
	    if(s == NULL)
		fputs(work,outfile);
	    else
		if(s[0] == '[')
		{
		    /* new topic */
		    strcat(item,"=");
		    strcat(item,value);
		    strcat(item,"\n");
		    fputs(item,outfile);
		    gotitem=1;
		    fputs(work,outfile);
		}
		else
		    if(!strcmpi(item,s))
		    {
			/* hit the item */
			strcat(item,"=");
			strcat(item,value);
			strcat(item,"\n");
			fputs(item,outfile);
			gotitem=1;
		    }
		    else
		    {
			/* no match */
			fputs(work,outfile);
		    }
	    if(fgets(work,255,infile) == NULL)
		eof=1;
	    if((eof) && (!gotitem))
	    {
		strcat(item,"=");
		strcat(item,value);
		strcat(item,"\n");
		fputs(item,outfile);
		gotitem=1;
	    }
	}
    }
    /* append the reset of the file */
    /* got an eof or a gotitem */
    while(!eof)
    {
	fputs(work,outfile);
	if(fgets(work,255,infile) == NULL)
	    eof=1;
    }
    if(!gottopic)
    {
	strcat(t,"\n");
	fputs(t,outfile);
	strcat(item,"=");
	strcat(item,value);
	strcat(item,"\n");
	fputs(item,outfile);
    }
    fclose(infile);
    fclose(outfile);
    /* now we have to rename everybody */
    strcpy(work,inifile);
    for(j=strlen(work)-1;j>0;j--)
	if(work[j] == '.')
	    break;
    work[j]=0;
    strcat(work,".BAK");
    if(rename(inifile,work))
    {
	if(errno == 13)
	    printf("\nWARNING, %s is being copied over\n",work);
	remove(work);
	rename(inifile,work);
    }
    if(rename(newfile,inifile))
    {
	printf("\nError %d renaming %s to %s \n",errno,newfile,inifile);
	puts("\n\x07 !!!! WARNING !!!!! \x07 \n");
	puts("Error copying new file");
	puts("Check to see if original file exists!!");
	exit(-1);
    }
}
int canon(char *targ,char *src)
{
    int r;
    r=0;
    _asm {
	push ds;
	push es;
	mov ax,cs;
	mov ds,ax;
	mov es,ax;
	mov si,src;
	mov di,targ;
	mov ah,60h;
	int 21h;
	jnc good_ret;
	mov r,ax;
good_ret:
	pop es;
	pop ds;
    }
    return(r);
}
int getpath(char *t,char *s)
{
    int j;
    strcpy(t,s);
    /* have to check for a directory */
    for (j=strlen(t)-1;j>0;j--)
    {
	if(t[j] == '\\')
	    break;
    }
    t[j]=0;
    return(0);
}
