; this executes the command lines off of the menu items
; one at a time.
;
cseg segment para public 'CODE'
assume  cs:cseg,ds:cseg,es:cseg
extrn exec_command:near,lines:word,menu_item:word,command_line:byte
extrn command_file:byte,exec_file:near,do_back:near
extrn int_com:byte,fcheck:near,printat:near,blank_area:near
extrn blip:near,blop:near,vbuff:word,semaphore:byte
extrn getnextmenu:near,newmenu:byte,getkeys:near
extrn menu_item:word,break_off:near,break_on:near
extrn  thud:near,press:byte,showcurs:near
extrn  clearkey:near,getmenu:near,error_code:word

diskmess1 db 'Please place Disk with '
pcommand1 db 64 dup(0)
diskmess2 db '    in drive '
disk  db 'A:',13,10,'Press ENTER to continue or press ESC to exit',0
badmess1 db "Can't find file: "
pcommand2  db 64 dup(0)
badmess2 db '     Press ESC to Continue',0
crlf   db 13,10,'$'
pline  db 80,0,81 dup(0)
echo_line db 80 dup(0)
percline dw 11 dup(0)
public percline

change_disk:
    lodsb
    cmp   al,0
    je   end_chdsk
    cmp   al,20h
    je    change_disk
    cmp   al,9
    je    change_disk
; got a non space
    cmp   al,'A'
    jl    bad_chd
    cmp   al,'z'
    jg    bad_chd
    cmp   al,'Z'
    jle   good_chd
    cmp   al,'a'
    jl    bad_chd
good_chd:
    and   al,1fh
    mov   dl,al
    dec   dl
    mov   ah,0eh
    int   21h
bad_chd:
    lodsb
    cmp   al,0
    jne   bad_chd
end_chdsk:
    jmp  try_next
change_dir:
; set up the change
     mov  di,offset pcommand1
cd1:
     lodsb
     cmp  al,0
     je   cd_done
     cmp  al,20h
     je   cd1
     cmp  al,9
     je   cd1
     stosb
cd2:
     lodsb
     cmp  al,0
     je   cd_done
     cmp  al,20h
     je   cd3
     cmp  al,9
     je   cd3
     stosb
     jmp  cd2
cd3:
     lodsb
     cmp  al,0
     jne  cd3
cd_done:
     stosb
     mov  dx,offset pcommand1
     mov  ah,3bh
     int  21h
    jmp  try_next
;
pparse:
; this looks at pline to get the %1 etc
    push   si
    mov    di,offset percline
    mov    ax,0
    mov    cx,10
    cld
rep  stosw
    mov    cl,pline+1
    mov    ch,0
    cmp    cx,0
    je     no_pparse
    mov    si,offset pline+2
    mov    di,offset percline
pp_loop:
    lodsb
    cmp    al,13
    je     no_pparse
    cmp    al,20h
    je     bot_pparse
    cmp    al,9
    je     bot_pparse
    mov    ax,si
    dec    ax
    stosw
    loop   word_loop
    jmp    no_pparse
word_loop:
    lodsb
    cmp    al,20h
    je     bot_pparse
    cmp    al,13
    je     no_pparse
    cmp    al,9
    je     bot_pparse
    loop   word_loop
    jmp    no_pparse
bot_pparse:
    loop   pp_loop
no_pparse:
    pop    si
    ret
do_qu:
    cld
    lodsb
    cmp   al,0
    je    end_qu
    cmp   al,26
    je    end_qu
    mov   ah,14
    int   10h
    jmp   do_qu
end_qu:
; do echo of any messages
    mov   ah,14
    mov   al,20h
    int   10h
    mov   dx,offset pline
    mov   ah,10
    int   21h
    call  pparse
    jmp   try_next
do_wait:
    jmp   try_next
do_echo:
    mov   ah,14
    mov   al,13
    int   10h
    mov   ah,14
    mov   al,10
    int   10h
    cmp   byte ptr ds:[si],0
    jne   do_e2
    inc   si
    jmp   try_next
do_e2:
    mov   di,offset echo_line
    mov   cx,0
    call  transfer_parms
    mov   ax,0
    stosw
    push  si
    mov   si,offset echo_line
;
start_echo:
    cld
    lodsb
    cmp   al,0
    je    end_echo
    cmp   al,13
    je    end_echo
    cmp   al,10
    je    end_echo
    mov   ah,14
    int   10h
    jmp   start_echo
end_echo:
    pop   si
;
    jmp   try_next
do_pause:
    push si
    mov  dx,offset press
    mov  ah,9
    int  21h
    call clearkey
    mov  ah,0
    int  16h
    mov  dx,offset crlf
    mov  ah,9
    int  21h
    pop   si
    cmp   byte ptr ds:[si],0
    je    no_end_sc
    jmp   end_scan
no_end_sc:
    lodsb
    jmp   try_next
do_intl:
; have a list scan
extrn infile:byte
    inc   si
    mov   di,offset infile
    mov   cx,0
    call  transfer_parms
    dec   di
     mov  ax,0
     stosw
extrn nlist:near
    push  si
    call nlist
    pop   si
    jmp  try_next

do_intt:
; reloads top menu
    mov  menu_item,0
    mov  newmenu,0
    call getmenu
    jc   bad_new
    call getkeys
     call  thud

    clc
    ret
do_intm:
;   time to load a new menu
    mov   menu_item,0
    lea   di,newmenu
load_new:
    cld
    lodsb
    cmp   al,26h
    je    exit_load_new
    cmp   al,20h
    je    load_new
    cmp   al,9
    je   load_new
    stosb
    cmp   al,0
    jne  load_new
exit_load_new:
     mov  al,0
     stosb
; try loading a new menu
     call  getnextmenu
     jc    bad_new
     call  getkeys
     call  thud
     clc
     ret
bad_new:
    mov   error_code,10
    stc
    ret


doitem:
public doitem
; first scan the current menu item to find the thing to execute
    mov   si,menu_item
    inc   si
    shl   si,1
    mov   di,lines[si]
    mov   al,0
    mov   cx,255
    cld
repne scasb
    jne  done_item
    jmp  hit_zero
done_item:
    clc
    ret
internal_com:
    inc  si
    lodsb
    cmp   al,'a'
    jl    upper1
    cmp   al,'z'
    jg    upper1
    sub   al,20h
upper1:
    mov   int_com,al
; do internal commands
    cmp   al,'Q'
    je    internal_q
    cmp   al,'M'
    je    internal_m
    cmp   al,'P'
    je    internal_p
    cmp   al,'L'
    je    internal_l
    cmp   al,'W'
    je    internal_w
    cmp   al,'E'
    je    internal_e
    cmp   al,'?'
    je    internal_qu
    cmp   al,'B'
    je    internal_b
    cmp   al,'R'
    je    internal_r
    cmp   al,'D'
    je    internal_d
    cmp   al,'C'
    je    internal_c
    cmp   al,'T'
    je    internal_t
    jmp   end_scan
internal_b:
; beep
    call  blip
    jmp   end_scan
internal_qu:
    jmp   do_qu
internal_q:
    clc
    ret
internal_m:
      jmp    do_intm
internal_p:
      jmp    do_pause
internal_l:
      jmp    do_intl
internal_w:
      call   ncnt
      jmp    try_next
internal_e:
      jmp    do_echo
internal_x:
      jmp   end_scan
internal_r:
    ret
internal_c:
    jmp  change_dir
internal_d:
    jmp  change_disk
internal_t:
      jmp    do_intt
do_end_scan:
; scan to rest of line
    cld
    lodsb
    cmp  al,26
    je   exit_end_scan
    cmp  al,0
    jne  do_end_scan
exit_end_scan:
    clc
    ret
end_scan:
    call do_end_scan
; decide what to do with the gu in int_com
    jmp  try_next  ; ignore it
hit_zero:
    mov si,di
try_next:
; here we have to figure out how to execute the command
    cmp  byte ptr ds:[si],0
    jne  tn_2
    jmp  done_item
tn_2:
    cmp  byte ptr ds:[si],'&'
    jne  not_internal
    jmp  internal_com
not_internal:
; here we have to find if there is a KEEN!
    push  si
keen_loop:
    lodsb
    cmp   al,0
    je    keen_exit
    cmp   al,'K'
    je    check_k
    cmp   al,'k'
    je    check_k
keen_loope:
    loop  keen_loop
keen_exit:
    pop   si
    jmp   by_keen
check_k:
    lodsb
    cmp   al,'e'
    je    got_e1
    cmp   al,'E'
    jne   keen_loope
got_e1:
    lodsb
    cmp   al,'e'
    je    got_e2
    cmp   al,'E'
    jne   keen_loope
got_e2:
    lodsb
    cmp   al,'N'
    je    got_keen
    cmp   al,'n'
    jne   keen_loope
got_keen:
    mov   semaphore,1
    pop   si
    jmp   by_keen
by_keen1:
    pop   si
by_keen:
    mov  di,si
; scan for .EXE or .COM before space
    push si
    push di
    call break_off
    pop  di
    pop  si
dot_look:
    cmp  byte ptr ds:[di],0
    je   use_command
    cmp  byte ptr ds:[di],' '
    je   use_command
    cmp  byte ptr ds:[di],'.'
    je   hit_dot
    inc  di
    jmp  dot_look
hit_dot:
    mov  ax,word ptr ds:[di]+1
    cmp  al,'c'
    je   check2
    cmp  al,'C'
    je   check2
    cmp  al,'e'
    je   check2
    cmp  al,'E'
    je   check2
    jmp  use_command
check2:
    cmp  ah,'o'
    je   check3
    cmp  ah,'O'
    je   check3
    cmp  ah,'x'
    je   check3
    cmp  ah,'X'
    je   check3
    jmp  use_command
check3:
    mov  al,byte ptr ds:[di]+3
    cmp  al,'m'
    je   check4
    cmp  al,'M'
    je   check4
    cmp  al,'e'
    je   check4
    cmp  al,'E'
    je   check4
    jmp  use_command
check4:
    jmp  use_file
use_command:
; using command.com to execute here
    mov  di,offset command_line+1
    mov  ax,'C/'
    stosw
    mov  ax,'  '
    stosw
    cmp  byte ptr ds:[si],0
    je   done_items
    mov  cx,4
extrn transfer_parms:near
    call transfer_parms
    jmp  do_exec
done_items:
    clc
 jmp done_item
do_exec:
; here we do out exec stuff
    push  si
    call  exec_command
    call  break_on
    mov   semaphore,0
    pop   si
    jmp   try_next
use_file:
; here we will use the file name
    mov   di,offset command_file
uf_loop1:
    cld
    lodsb
    cmp   al,' '
    je    uf_loop1e
    cmp   al,0
    je    uf_loop1e
    stosb
    jmp   uf_loop1
uf_loop1e:
    mov   al,0
    stosb
; set up store of command.line
    dec  si
    mov  di,offset command_line+1
    mov  cx,2
    call transfer_parms
    push  si
; here check for presence
try_file_exec:
    mov   dx,offset command_file
    call  fcheck
    jc    bad_file
    call  exec_file
    call  break_on
    mov   semaphore,0
    pop   si
    jmp   try_next
bad_file:
; two choices. If current disk is one of first byte of command is A:
; we can prompt for new disk
    mov   ax,word ptr command_file
    cmp   ah,':'
    jne   try_curr
    cmp   al,'a'
    je    promptaf
    cmp   al,'A'
    je    promptaf
    cmp   al,'b'
    je    promptbf
    cmp   al,'B'
    je    promptbf
    jmp   bad_file_name
try_curr:
    mov   ah,19h
    int   21h
    cmp   al,0
    je    promptaf
    cmp   al,1
    je    promptbf
bad_file_name:
; issue warning and exit
    mov   si,offset command_file
    mov   di,offset pcommand2
    mov   cx,64
    cld
rep  movsb
    call do_back
    push  es
    mov   es,vbuff
    mov   di,5*160+50
        mov     bp,30
        mov     cx,2
        push    di
        call    blank_area
        pop     di
        inc     di
        inc     di
	mov	si,offset badmess1
        push    di
	call	printat
        pop     di
        add     di,160
	mov	si,offset badmess2
	call	printat
        pop     es
kloop2:
        call    blop
        call    clearkey
        mov     ah,0
        int     16h
        cmp     al,27
        jne     kloop2
do_esc:
      pop   si
      ret
promptaf:
    mov   disk,'A'
    jmp   prompter
promptbf:
    mov   disk,'B'
prompter:
    mov   si,offset command_file
    mov   di,offset pcommand1
    mov   cx,64
    cld
rep  movsb
    call do_back
    push  es
    mov   es,vbuff
    mov   di,5*160+30
        mov     bp,50
        mov     cx,3
        push    di
        call    blank_area
        pop     di
        inc     di
        inc     di
	mov	si,offset diskmess1
        push    di
	call	printat
        pop     di
        add     di,160
	mov	si,offset diskmess2
	call	printat
        pop     es
kloop1:
        call    blop
    call clearkey
        mov     ah,0
        int     16h
        cmp     al,27
        je      do_esc
        cmp     al,13
        je      try_again
        jmp     kloop1
try_again:
        jmp     try_file_exec
ncnt:
; si points to byte after &W
      call   parse
      jnc    count_down
      mov    bx,10
count_down:
      push  cx
      call  wait_tick
      mov   cx,18  ; times to go
sec_loop:
     push   cx
      call  wait_tick
     pop    cx
     jc     exit_wait1
     loop   sec_loop
     pop    cx
     loop   count_down

exit_sec:
      ret
exit_wait1:
      pop  cx
      ret
exit_wait2:
    call clearkey
      stc
      ret
wait_tick:
; get current time until it changes
      mov  ah,1
      int  16h
      jnz  exit_wait2
      mov  ax,0
      int  1ah
; cx has ticks
      mov  bp,dx
do_it_again:
; do it again
      mov  ax,0
      int  1ah
      cmp  dx,bp
      je   do_it_again
      clc
      ret
parse:
; this takes the command line and finds a number
     mov  cx,0
p1:
     lodsb
     cmp al,0
     je  p9
     cmp  al,20h
     je   p1
     cmp al,'0'
     jl   p5
     cmp  al,'9'
     jg   p5
     and  al,0fh
     mov  dl,al
     mov  cl,10
     mul  cl
     mov  bx,ax
p2:
     lodsb
     cmp  al,0
     je   p4a
     cmp  al,'0'
     jl   p4
     cmp  al,'9'
     jg   p4
     and  ax,15
     add  bx,ax
     jmp  p5
p4a:
     mov  bl,dl
     mov  bh,0
     jmp  p9
p4:
     mov  bl,dl
     mov  bh,0
p5:
     lodsb
     cmp   al,0
     jne   p5
p9:
     cmp   bx,0
     jle   p10
     mov   cx,bx
     clc
     ret
p10:
     mov  cx,0
     stc
     ret

cseg	ends
     end
;
