dseg     segment para public 'data'
;
;
;
; windows start here
;  menu structure is:
;    db height
;    db width
;    db x loc
;    db y loc
;    db color
;    db lines of data
;    db 0
;
error0  db 03,22,30,06,0f1h
        db  ' Field is in error',0
;
;
wait0   db 03,36,22,06,0f1h
        db  'Please wait while file is created  ',0
;
errorsave dw 5*40 dup(0)
;
helpsave  dw 20*40 dup(0) ; for all helps

help0   db 06,55,10,15,07h
 db  ' To create a macro overlay file from a graphics image',13,10
 db  ' file, fill in all of the fields. Press F1 for help.',13,10
 db  ' Press F10 when you are ready to create the overlay.',13,10
 db  '      Press the ESC key if you wish to quit.',0
help1   db 11,40,20,13,70h
     db  ' Image File is the file name of the  ',13,10
     db  ' graphics file which will be used in',13,10
     db  ' the OVERLAY. The file must have one',13,10
     db  ' of the following DOS extensions:',13,10
     db  ' .PDA - Palantir scanned images',13,10
     db  ' .TIF - Aldus Microsoft TIFF files',13,10
     db  ' .PCX - ZSoft PC Paintbrush files',13,10
     db  ' .IMG - GEM Paint images',13,10
     db  '     press any key to continue',0
;
help2   db 08,40,20,15,70h
     db  ' Macro File is name of a file which  ',13,10
     db  ' will be created that has the overlay',13,10
     db  ' macro in it. This file will be used',13,10
     db  ' to setup the LaserJet II to do the',13,10
     db  ' overlay.',13,10
     db  '     press any key to continue',0
;
;
help3   db 06,40,20,15,70h
     db  ' Printer Density is the DOTS PER INCH',13,10
     db  ' which will be used in the Macro.',13,10
     db  ' The choices are 075, 150 or 300.   ',13,10
     db  '     press any key to continue',0
;
;
;
help4   db 06,40,20,15,70h
     db  ' There can be up to 32 macros active ',13,10
     db  ' at a time in the LaserJet II. This',13,10
     db  ' Macro must be numbered from 01 to 32. ',13,10
     db  '     press any key to continue',0
;
;
;
help5   db 07,40,20,15,70h
     db  ' X position is the starting position ',13,10
     db  ' on the paper where a graphics will',13,10
     db  ' be printed. This is measured in  ',13,10
     db  ' inches from left to right',13,10
     db  '     press any key to continue',0
;
;
;
help6   db 08,40,20,15,70h
     db  ' Y position is the starting position ',13,10
     db  ' on the paper where a graphics will',13,10
     db  ' be printed. This is measured in inches',13,10
     db  ' measured from the top of the page',13,10
     db  ' to the bottom of the page.',13,10
     db  '     press any key to continue',0
;
;
help7   db 09,40,20,15,70h
     db  ' Inverse determines if dots print as ',13,10
     db  ' bloack dots or white dots. Y means',13,10
     db  ' dots will print as white, N is dots   ',13,10
     db  ' print black. Some graphics images',13,10
     db  ' must have Inverse = Y to print',13,10
     db  ' correctly. You must enter Y or N.',13,10
     db  '     press any key to continue',0
;
;
;
; fl types
fl1    db "D",46,0,16,1,071h,017h,' '
     dw  head1
head1     db 'OV.EXE Overlay Utility For the HP LaserJet II  '
fl2    db "D",44,0,17,2,071h,017h,' '
     dw  head2
head2     db "Vers 1.03 Copyright 1988 by Keith P. Graham   "
fl3    db "D",16,0,05,06,041h,017h,' '
     dw  title1
title1    db "Image file:     "
fl4    db "C",48,0,21,06,70h,07h,' '
     dw  pcxfile
pcxfile   db 50 dup(20h)
fl5    db "D",16,0,05,08,41h,17h,' '
     dw  title2
title2    db "Macro file:     "
fl6    db "C",48,0,21,08,70h,07h,' '
     dw  prtfile
prtfile   db 50 dup(20h)
fl7    db "D",16,0,05,10,41h,17h,' '
     dw  title3
title3    db "Printer Density: "
fl8    db "N",3,0,21,10,70h,07h,'0'
     dw  prtdens
prtdens   db 4 dup('0')
fl9    db "D",16,0,28,10,41h,17h,' '
     dw  title4
title4    db "Macro Number:    "
fl10   db "N",2,0,41,10,70h,07h,'0'
     dw  macrono
macrono   db 3 dup('0')
fl9a   db "D",10,0,49,10,41h,17h,' '
     dw  title4a
title4a   db "Inverse:  "
fl10a  db 'C',1,0,57,10,70h,07h,'N'
     dw  xor_print
xor_print db 3 dup('N')
fl11   db "D",16,0,05,12,41h,17h,' '
     dw  title5
title5    db "Page X location: "
fl12   db "N",5,0,21,12,70h,07h,'0'
     dw  xpos
xpos     db 7 dup('0')
fl13   db "D",16,0,32,12,41h,17h,' '
     dw  title6
title6    db "Page Y Position: "
fl14   db "N",5,0,48,12,70h,07h,'0'
     dw  ypos
ypos     db 7 dup('0')
;
; structure for fl stuff
;
enterline  dw  (end_tst-$-2)/2
     dw  fl1,fl2,fl3,fl4,fl5,fl6,fl7
     dw  fl8,fl9,fl10,fl9a,fl10a,fl11,fl12,fl13,fl14
end_tst equ this byte
clearscreen dw 1,cls
cls    db "D",1,0,16,1,070h,007h,' '
     dw  cls1
cls1      db ' '
;
;
eflag  db  0
handlei dw 0
handleo dw 0
public handleo,handlei,pcxfile,xpos,ypos,macrono,prtdens,xor_print
;
extrn exit_phase:word
dseg ends
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:dseg,es:dseg
extrn forms:near,reset_segs:near
main     proc     near
overlay:
public overlay
;
;  ah has the attribute if we clear screen
;  al has the fl to get if we want to get just 1 fl
;  al has a 0ffh if we want to get all fls
;  al is 0 if we just want to display
;  bx has the fl to start phase cronology from
     lea     si,enterline
     mov     ax,1700h
     mov     bx,0
     call     forms
     lea   si,help0
     lea   di,helpsave
     call  do_window
     mov     bx,3   ; start with field 4
enter_loop:
     lea     si,enterline
     mov     ax,0ffh
     call     forms
     cmp     al,3bh     ; F1
     je     help_fields
     cmp     al,44h     ; F10
     je     check_fields
     cmp     ah,27
     je     exit_prog
     lea     si,enterline
     mov     ax,0ffh
     mov     bx,exit_phase
     jmp     enter_loop
exit_prog:
; clear the screen
     jmp   go_home
check_fields:
    jmp  check_fields0
help_fields:
extrn  do_window:near,undo_window:near

     mov     bx,exit_phase
     sub   bx,3
     jmp   cs:helps[bx]
helps dw do_help1,do_help2,do_help3,do_help4,do_help7
      dw do_help5,do_help6,do_help8
set_window:
     cmp   eflag,1
     jne   no_error_check
     push  si
     push  di
     mov   bx,exit_phase
     inc   bx
     shl   bx,1
     mov   si,word ptr enterline[bx]
     mov   al,byte ptr ds:[si]+4
     inc   al
     mov   error0+3,al
     mov   al,byte ptr ds:[si]+3
     mov   error0+2,al
     lea   si,error0
     lea   di,errorsave
     call  do_window
     pop   di
     pop   si
no_error_check:
     push  si
     push  di
     call  do_window
     mov   ah,0
     int   16h
     pop   di
     pop   si
     call  undo_window
     cmp   eflag,1
     jne   exit_help
     mov   eflag,0
     lea   si,error0
     lea   di,errorsave
     call  undo_window
exit_help:
     mov     bx,exit_phase
     jmp     enter_loop
do_help1:
     lea   si,help1
     lea   di,helpsave
     jmp   set_window
do_help2:
     lea   si,help2
     lea   di,helpsave
     jmp   set_window
do_help3:
     lea   si,help3
     lea   di,helpsave
     jmp   set_window
do_help4:
     lea   si,help4
     lea   di,helpsave
     jmp   set_window
do_help5:
     lea   si,help5
     lea   di,helpsave
     jmp   set_window
do_help6:
     lea   si,help6
     lea   di,helpsave
     jmp   set_window
do_help7:
     lea   si,help7
     lea   di,helpsave
     jmp   set_window
do_help8:
     jmp   exit_help
check_fields0:
; check each field
; check field 3, density first
     mov    ax,word ptr prtdens
     cmp    ax,'70'
     je     check1_1
     cmp    ax,'51'
     je     check1_2
     cmp    ax,'03'
     je     check1_2
     jmp    bad_c1
check1_1:
     cmp    prtdens+2,'5'
     je     good_field1
     jmp    bad_c1
check1_2:
     cmp    prtdens+2,'0'
     je     good_field1
bad_c1:
     mov    eflag,1
     mov    exit_phase,7
     jmp    do_help3
good_field1:
     mov    ax,word ptr macrono
     cmp    ax,'00'
     je    bad_c2
     cmp    al,'3'
     jl     good_field2
     jg     bad_c2
     cmp    ah,'2'
     jle    good_field2
;    jmp    bad_c2
bad_c2:
     mov    eflag,1
     mov    exit_phase,9
     jmp    do_help4
good_field2:
; check for Y or N in xor_print
     or   xor_print,60h
     cmp  xor_print,'y'
     je   good_field2a
     cmp  xor_print,'n'
     je   good_field2a
     mov    eflag,1
     mov    exit_phase,11
     jmp    do_help7
good_field2a:
; here we have to open the input file
     lea   di,pcxfile
     cld
     mov   al,20h
     mov   cx,55
repne  scasb
    jne   bad_c3
     dec  di
     mov  al,0
     stosb
; have the ned of the guy
    lea   cx,pcxfile
    sub   cx,di
    neg   cx
    dec   cx
; cx has the length of the file name
    cmp   cx,0
    jle   bad_c3
; scan for '.'
    lea   di,pcxfile
    mov   al,'.'
repne scasb
    jne   bad_c3
; have to determine if it is one of us
    mov   si,di
    lodsw
    or   ax,6060h
    cmp  ax,'it'
    je   do_open_in
    cmp  ax,'cp'
    je   do_open_in
    cmp  ax,'dp'
    je   do_open_in
    cmp  ax,'mi'
    je   do_open_in
do_open_in:
    lea   dx,pcxfile
    call  open_input
    jnc   good_field3
bad_c3:
; had a bad open
     mov    eflag,1
     mov    exit_phase,3
     jmp    do_help1
good_field3:
; time to create the output file
;
     lea   di,prtfile
     cld
     mov   al,20h
     mov   cx,55
repne  scasb
    jne   bad_c4
     dec  di
     mov  al,0
     stosb
; have the ned of the guy
;
    lea   dx,prtfile
    call  open_output
    jnc   good_field4
bad_c4:
; had a bad open
     mov    eflag,1
     mov    exit_phase,5
     jmp    do_help1
good_field4:
;
     lea   si,wait0
     lea   di,errorsave
     call  do_window
;
extrn  get_file:near
     call   get_file
     call   reset_segs
go_home:
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
     ret
;
open_input:
; open a file for read
     mov   cx,0
     mov   ax,3d00h
     int   21h
     jnc   good_open_in
     stc
     ret
good_open_in:
     mov   handlei,ax
     clc
     ret
;
open_output:
; open a file for read
     mov   cx,0
     mov   ax,3c00h
     int   21h
     jnc   good_open_out
     stc
     ret
good_open_out:
     mov   handleo,ax
     clc
     ret
main  endp
cseg     ends
     end
