.MODEL MEDIUM, C
xx macro
local y
  cmp  vlen,23
  je   y
  int 3
y:
endm
bpmov macro t
mov  t,bp
endm
bpget macro t
mov  bp,t
endm
intern equ 1
buffersize=8000h
buffermax = 24
	MOUSEMOVE	=	1
	LEFTBPRESS	=	2
	LEFTBRELEASE = 4
	RIGHTBPRESS	= 8
	RIGHTBRELEASE=16

	LEFTBDOWN =1
	RIGHTBDOWN=2
; d9 is a good base character
BASECHAR equ 128 ; 0d9h

;* Shift states for byte a 0:417h
;	bit 7 =1 INSert active
;	bit 6 =1 Caps Lock active
;	bit 5 =1 Num Lock active
;	bit 4 =1 Scroll Lock active
;	bit 3 =1 either Alt pressed
;	bit 2 =1 either Ctrl pressed
;	bit 1 =1 Left Shift pressed
;	bit 0 =1 Right Shift pressed

	SHIFT_RIGHTSHIFT=001h
	SHIFT_LEFTSHIFT =002h
	SHIFT_SHIFT	=003h;/* Either shift key. */
	SHIFT_CTRL	=004h
	SHIFT_ALT	=008h
	SHIFT_SCROLLLOCK=010h
	SHIFT_NUMLOCK	=020h
	SHIFT_CAPSLOCK	=040h
	SHIFT_INS	=080h

;* Mouse information record */
;truct minforectype {
; word buttonstat;
; int	cx, cy;
;	byte shiftstate;
;};

.DATA
c1	db	32 dup(0)
c2	db	32 dup(0)
c3	db	32 dup(0)
c4	db	32 dup(0)
savef	db	32*4 dup(0)	; area for 4	characters
mousec	dw	1100000000000000b
	dw	1010000000000000b
	dw	1001000000000000b
	dw	1000100000000000b
	dw	1000010000000000b
	dw	1000001000000000b
	dw	1000000100000000b
	dw	1000000110000000b
	dw	1000011000000000b
	dw	1011001000000000b
	dw	1101000100000000b
	dw	0000100100000000b
	dw	0000111000000000b
	dw	0000000000000000b
	dw	0000000000000000b
	dw	0000000000000000b

mousem	dw	1100000000000000b
	dw	1110000000000000b
	dw	1111000000000000b
	dw	1111100000000000b
	dw	1111110000000000b
	dw	1111111000000000b
	dw	1111111100000000b
	dw	1111111110000000b
	dw	1111111000000000b
	dw	1111111000000000b
	dw	1101111100000000b
	dw	0000111100000000b
	dw	0000111000000000b
	dw	0000000000000000b
	dw	0000000000000000b
	dw	0000000000000000b
char1	db	0
char2	db	0
char3	db	0
char4	db	0
mousex	dw	100
mousey	dw	100
mousecx	dw	0
mousecy	dw	0
start_mode	dw	0
my	dw	0
mx	dw	0
xshift	dw	0
yshift	dw	0
char_off	dw 0
a000	dw	0a000h
vbuff	dw	0b800h
cheight	db	16	; cell height
mousefreeze	db	0
egavga	db	0
savestart_mode	db	0
saved	db	0
mouseinstalled	dw	0
savetext	dw	0
text_loc	dw	0
button	db	0
buttons	dw	0
doubleclick db 0
oldticks	dw 0
public button,buttons,doubleclick,oldticks,mouseinstalled
mouse_on	dw 0
mouse_init db 0 ; 1 if mouse has been initted
oswitch db 0
gswitch db 1
deskv	db 0
akeys	db 'PCFUDTB',13,27,'EQ'
bpreg  dw 0

;
;
;
fstring db 64,0,65 dup(0)
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
findwhat db ' Find what?',55 dup(20h),0
cursor	dw 0
handle	dw 0
buffcount	dw	0
buffers dw buffermax*2 dup(0)
	dw 0,0,0,0,0,0,0
file_size dw 0,0
color2	db	17h
color1	db	17h
color3	db	70h
color4	db	74h
; vwid and vlen are the size of the current panel
vwid	dw	80
vlen	dw	23	; virtual length of page
; ux and uy are the screen cordinates of the first print area
ux	db	0
uy	db	1
; x and y are the current location?
x	db	0
y	db	0	; screen line number
curline	dw	0,0
topline	dw	0,0
lastfind	dw	0,0
bot_line db 'Esc=Quit,P=Print,F=Find,C=Cont,F3F4=Colors'
	db ',Keys=PgUp,PgDn,Home,End'
	db '	Down'
	db 0
bline	dw 0
finder	dw 0
found	db 0
mode	db	0
top_line db 'PLIST v2.1 - '
infile	db 128 dup(0)
upx	db ' Line='
lineno	db '0000'
	db '	Up'
	db	0
error_code	dw 0
firster db 0
oldbline dw 0
.CODE

include plist2.asm

putlist	proc far str:FAR PTR BYTE
	push	ds
;	mov	ax,SEG c1
;	mov	ds,ax
;	mov	es,ax
	push  ds
	pop   es
        push    ds
        lds     si,str
	mov	di,offset infile
	mov	cx,128
	cld
	rep	movsb
        pop     ds
;	call	far ptr hidecurs
	call    far ptr getmouse
	mov	bline,0
	call	far ptr getmode	; get video segment,etc
	call	far ptr glist
	pop	ds
	ret
putlist	endp
hidecurs proc far
; set the cursor to a position off the screen
	mov	ah,2
	mov	bx,0
	mov	ch,25
	mov	cl,0
	mov	dh,25
	mov	dl,0
	int	10h
	ret
hidecurs endp
showcurs proc far
	mov	ah,7
	mov	bh,17h
	mov	al,0
	mov	bl,0
	mov	cx,1800h
	mov	dx,184fh
	int	10h
	mov ah,2
	mov	dh,24
	mov	dl,0
	mov bx,0
	int	10h
	ret
showcurs endp
hidemouse proc far
	mov	ax,mouseinstalled
	or	ax,mouse_on
	cmp	ax,0
	jne	hidemouse2
	ret
hidemouse2:
; this hides the cursor if its saved and makes it unsaved
	cmp	saved,0	; zero means that mouse is hidden
	je	no_mhide
	push	es
	mov	ax,ds
	mov	es,ax
	call	far ptr unset_char
	mov	saved,0
	pop	es
no_mhide:
	ret
hidemouse endp
showmouse proc far
	mov	ax,mouseinstalled
	or	ax,mouse_on
	cmp	ax,0
	jne	showmouse2
	ret
showmouse2:
	cmp	saved,0
	je	showmouse3
	call hidemouse
showmouse3:
	push	es
	mov	ax,ds
	mov	es,ax
	mov	saved,1
	cmp	egavga,0
	jne	show_vcurs
; show the text cursor
	mov	ax,mousecy
	mov	cx,80
	mul	cx
	add	ax,mousecx
	shl	ax,1
	mov	di,ax
	mov	text_loc,di
	mov	es,vbuff
	mov	al,byte ptr es:[di]+1
	mov	savetext,ax
	and al, 0f7h	; Clear high bit */
	clc
	mov cl, 4	; We want to rotate 4 bits */
	rol al, cl	; Rotate it */
	mov	byte ptr es:[di]+1,al
	pop	es
	ret

show_vcurs:
; call the vga display
	call	far ptr create_newchar
	pop	es
	ret
showmouse endp

minstall proc far
	; installs a mouse
	mov	saved,0
	cmp	mouseinstalled,0
	jne	cont_mins
	ret
cont_mins:
	cmp	mouse_init,1
	jne	cont_m2
	cmp	egavga,1
	je	cont_m2
	jmp	char_cursor
cont_m2:
	mov	mouse_on,0
	mov	dx,0
	mov	cx,0
	mov	bx,0
	mov ax,21h	; Mouse driver function 0 -- reset and detect */
	int	33h
	inc	mousefreeze	; don't move mouse
	mov	egavga,0
	; we have to determine if we are real mouse or character one
	cmp	start_mode,7
	je	char_cursor1
	cmp	oswitch,1
	je	char_cursor1
	cmp	gswitch,0
	je	char_cursor1
 	cmp	deskv,0
 	je	check_vga
char_cursor1:
	jmp	char_cursor
check_vga:
	mov ax, 1a00h	; ROM BIOS video function 1ah -- Read Display Code */
	int	10h	; 
	cmp ah, 1ah	; Is this call supported? */
	je checkega	; Not supported */
	cmp bl, 7	; VGA w/monochrome display? */
	je	isvga	; Yup. */
	cmp bl, 8	; VGA w/color display? */
	jne checkega	; Nope */
isvga:
	mov	egavga,1
	jmp	vga_test_done
checkega:
;	jmp	char_cursor
	mov ah, 12h	; EGA BIOS function */
	mov bl, 10h	; 
	int	10h	; 
	cmp bl, 10h	; Is EGA BIOS present? */
	jne isvga	; There is an EGA in the system. */
not_egavga:
 	jmp	char_cursor
vga_test_done:
	cmp	mouse_init,1
	je	vga_curs
	mov	mouse_init,1
	call	far ptr save_fchar
	cmp	word ptr savef,0
	jne	not_egavga
	cmp	byte ptr savef+2,0
	je	not_egavga

; We are going to use our 'true' mouse cursor and we need pixel
; resolution, not character resolution from the mouse driver
; (In text start_mode, the mouse driver only returns coordinates in multiples
; of 8, which we don't want.	We want multiples of 1, i.e. pixel
; resolution).	To get the mouse driver to return coordinates in pixel
; resolution, we 'trick' it into thinking it's in graphics start_mode by
; setting the low memory byte indicating start_mode to start_mode 6 (CGA 640x200x2).
; Then we reset the mouse driver.	The mouse driver will get the video
; start_mode then act as if it was in graphics start_mode, not text start_mode. */
	push es
	mov	ax,40h
	mov	es,ax
	mov	bl,6
	xchg	byte ptr es:[49h],bl

	; Reset driver for change in video start_mode to take effect. */
	push bx
	mov	dx,0
	mov	cx,0
	mov	bx,0
	mov ax,21h
	int	33h
	pop	bx

	; Now that we've tricked the mouse driver into a grapics start_mode thereby
	; causing it to give us pixel resolutions, put the old start_mode back. */
	mov	byte ptr es:[49h],bl
	pop	es

; Set up max x and y ranges. */

; maxx = mcols * 8 - 1	; Pixels horizontally */
; maxy = mrows * points - 1	; Pixels vertically */
	jmp	vga_curs
char_cursor:
	mov	egavga,0
	mov	dx,0
	mov	cx,0
	mov	bx,0
	mov ax,21h
	int	33h

;	mov dx,79 	; Pixels horizontally */
;	mov ax,7	; mouse driver function 7 -- set max x range */
;	sub cx,cx	; Minimum range */
;	int	33h

;	mov dx,24	; Pixels veritcally */
;	mov ax,8	; mouse driver function 8 -- set max y range */
;	sub cx,cx	; Minimum range */
;	int	33h
	jmp	install_ourm
vga_curs:
;	mov	mouse_init,1

install_ourm:
	; Now install user routine */

;	mov dx, offset mousehandler
;	; Setup up bits for calling routine */
;	mov cx,7	; BPRESS | LEFTBRELEASE | RIGHTBPRESS | RIGHTBRELEASE | MOUSEMOVE	;
;	mov ax,12	; Function 12 -- set user routine */
;	int	33h
	mov	mouse_init,1
	mov dx,639	; Pixels horizontally */
	mov ax,7	; mouse driver function 7 -- set max x range */
	sub cx,cx	; Minimum range */
	int	33h

	mov	al,cheight
	mov	ah,0
	mov	cx,25
	mul	cx
	mov dx,ax	; Pixels veritcally */
	dec	dx
	mov ax,8	; mouse driver function 8 -- set max y range */
	sub cx,cx	; Minimum range */
	int	33h

	mov cx,mousex	; xcoord */
	mov dx,mousey	; ycoord */
	mov ax,4	; mouse driver function 4 -- set mouse position */
	int	33h

	dec	mousefreeze
;	call	showmouse
	ret

minstall endp


unset_char proc far
	cmp	saved,1
	je	unset1
	ret
unset1:
	mov	saved,0
	cmp	egavga,0
	jne	unset2
	mov	di,text_loc
	push es
	mov	es,vbuff
	mov	ax,savetext
	mov	byte ptr es:[di]+1,al
	pop	es
	ret
unset2:
	push	es
	mov	es,vbuff
	mov	si,char_off
	mov	al,char1
	mov	byte ptr es:[si],al
	mov	al,char2
	mov	byte ptr es:[si]+2,al
	mov	al,char3
	mov	byte ptr es:[si]+160,al
	mov	al,char4
	mov	byte ptr es:[si]+162,al
	pop	es
	ret

unset_char endp

doublecheck proc far
	mov	ax,mouseinstalled
	or	ax,mouse_on
	cmp	ax,0
	jne	db_0
	mov	ax,0
	mov	bx,0
	ret
db_0:
	mov	ax,0
	mov	bx,0
	cmp	doubleclick,0
	je	db_1
	ret
db_1:
	mov	ax,5
	mov	bx,0
	int	33h
	cmp	bx,0
	jne	db_2
	ret
db_2:
	push	ax
	push	bx
	mov	ax,0
	int	1ah
; cx:dx has ticks
	mov	ax,dx
	xchg	dx,oldticks
	sub	ax,dx
	cmp	ax,7
	pop	bx
	pop	ax
	jb	got_double
	ret
got_double:
	mov	doubleclick,1
	ret
doublecheck endp


mdeinstall proc far
	mov	ax,mouseinstalled
	or	ax,mouse_on
	cmp	ax,0
	jne	mdeinstal2
	ret
mdeinstal2:
	mov	buttons,0
	mov	doubleclick,0
	mov	oldticks,0
	mov	button,0
	call	unset_char
	call	far ptr restore_fchar
	mov	dx,0
	mov	cx,0
	mov	bx,0
	mov	ax,021h
	int	33h
	mov	saved,0
	ret
	; 
mdeinstall endp


getmouse proc far
; checks for mousiness
	push es
	mov	ax,40h
	mov	es,ax
	mov	bl,6
	xchg	byte ptr es:[49h],bl

	push bx
	mov ax,0	; Mouse driver function 0 -- reset and detect */
	int	33h
	pop	bx
	mov	byte ptr es:[49h],bl
	pop	es

	mov mouseinstalled, AX	; 
	ret
getmouse endp

move_mouse proc far
; this routine gets the current mouse position
; and moves the mouse
	mov	ax,mouseinstalled
	or	ax,mouse_on
	cmp	ax,0
	jne	movemouse2
	clc
	ret
movemouse2:
	mov	ax,3
	int	33h
	cmp	buttons,bx
	je	no_buttons
	mov	button,1
	mov	buttons,bx
	push	cx
	push	dx
	call	doublecheck
	pop	dx
	pop	cx
no_buttons:
	cmp	mousex,cx
	jne	movemouse3
	cmp	mousey,dx
	jne	movemouse3
	ret
movemouse3:
	push	cx
	push	dx
	call	hidemouse
	pop	dx
	pop	cx
	mov	mousex,cx
	mov	mousey,dx
	mov	ax,mousey
	mov	cl,cheight
	mov	ch,0
	mov	dx,0
	div	cx
	mov	mousecy,ax
	mov	ax,mousex
	shr	ax,1
	shr	ax,1
	shr	ax,1
	mov	mousecx,ax
	call	showmouse
;
;
	ret
move_mouse endp



setup_char proc far
	; this sets up the mouse information, byt getting chars from screen
	; and	stuff,
	mov	ax,mousey	; in lines
	mov	dx,0
	mov	cl,cheight
	mov	ch,0
	div	cx	; ax has line number
	mov	my,ax	; line number
	mov	yshift,dx
	mov	ax,mousex
	mov	dx,0
	mov	cx,8
	div	cx
	mov	mx,ax
	mov	xshift,dx
	; now write the BASECHAR characters to current x and y
	mov	cx,80
	mov	ax,my
	mul	cx
	add	ax,mx

	push	es
	mov	es,vbuff
	mov	si,ax
	shl	si,1
	mov	char_off,si
	mov	al,BASECHAR
	xchg	byte ptr es:[si],al
	mov	char1,al
	mov	al,BASECHAR+1
	xchg	byte ptr es:[si]+2,al
	mov	char2,al
	mov	al,BASECHAR+2
	xchg	byte ptr es:[si]+160,al
	mov	char3,al
	mov	al,BASECHAR+3
	xchg	byte ptr es:[si]+162,al
	mov	char4,al
	pop	es
	ret
setup_char endp



create_newchar proc far
	call	setup_char	; get x,y and put new chars on screen
	; this takes the characters and masks the new characters onto it
	call	far ptr set_vid1
	; read the 4 characters from the video area and save them in
	; c1, c2 c3 c4
	mov	di,offset c1
	mov	bx,offset char1
	mov	cx,4
gc_loop0:
	push	cx
	mov	al,byte ptr ds:[bx]
	inc	bx
	mov	ah,0
	mov	cl,5	; 32
	shl	ax,cl
	mov	si,ax
	push	ds
	mov	ds,a000
	mov	cx,32
	cld
rep	movsb
	pop	ds
	pop	cx
	loop	gc_loop0
	call	far ptr set_vid2
	; now and the mousem guy to the letters
	push	es
	mov	es,a000
	mov	cl,cheight	; number of lines in letter
	mov	ch,0
	cmp	cx,0
	jle	bad_h
	cmp	cx,16
	jle	good_h
bad_h:
	mov	cx,16
good_h:
	mov	si,yshift	; lines to shift down
	sub	cx,si
	; cx is the number of guys to shift on first 2
	mov	di,0
sh_loop0:
	push	cx
	; how much to shift to right
	mov	cx,xshift
	mov	ax,word ptr mousem[di]
	shr	ax,cl
	xor	ax,0ffffh
	and	c1[si],ah
	and	c2[si],al
	mov	ax,word ptr mousec[di]
	shr	ax,cl
	or	c1[si],ah
	or	c2[si],al
	pop	cx
	add	di,2
	inc	si
	loop	sh_loop0
	; now c3 c4
	mov	cx,yshift	; number of lines in 2nd row
	cmp	cx,0
	jle	sh_loop2
	mov	si,0	; lines to shift down
	; cx is the number of guys to shift on first 2
	; use the di left over from above
sh_loop1:
	push	cx
	; how much to shift to right
	mov	cx,xshift
	mov	ax,word ptr mousem[di]
	shr	ax,cl
	xor	ax,0ffffh
	and	c3[si],ah
	and	c4[si],al
	mov	ax,word ptr mousec[di]
	shr	ax,cl
	or	c3[si],ah
	or	c4[si],al
	pop	cx
	add	di,2
	inc	si
	loop	sh_loop1
sh_loop2:
	; 
	; copy the altered characters
	mov	di,BASECHAR*32
	mov	si,offset c1
	mov	cx,4*32
	cld
rep	movsb
	pop	es
	; 
	call	far ptr set_vid3
	ret
create_newchar endp



restore_fchar proc far
	cmp	egavga,1
	je	rest_fvchar
	ret
rest_fvchar:
	; put back the characters
	; 
	call	far ptr set_vid1
	call	far ptr set_vid2

	; 
	mov	di,BASECHAR*32	; 32 bytes per character
	mov	si,offset savef
	push	es
	mov	es,a000
	mov	cx,32*4
rep	movsb
	pop	es
	; restore video stuff
	; 
	call	far ptr set_vid3
	ret

restore_fchar endp



save_fchar proc far
	; this saves the characters that we are altering
	; these characters are seldom used characters at BASECHAR
	; 
	; set up video stuff to access fonts
	; 
	cmp	egavga,1
	je	save_fvchar
	ret
save_fvchar:
	call	far ptr set_vid1

	; 
	mov	si,BASECHAR*32	; 32 bytes per character
	mov	di,offset savef
	push	ds
	mov	ds,a000
	mov	cx,32*4
rep	movsb
	pop	ds
	; restore video stuff
	; 
	call	far ptr set_vid3
	; this also gets the height of a character cell
 	push	es
 	mov	ax,40h
 	mov	es,ax
 	mov	al,byte ptr es:[85h]
 	pop	es
 	mov	cheight,al
 	ret
save_fchar endp



set_vid2	proc far
	; 
	; this sets up writes (used to restore old stuff and copy new)
	mov dx,3c4h	; Sequencer port address	; 
	mov ax,0402h	; CPU writes only to map 2	; 
	out dx,ax	; 
	ret
set_vid2	endp



set_vid1 proc far
	; sets up read start_mode
	cli
	mov dx,3c4h	; Sequencer port address	; 
	mov ax,0704h	; Sequential addressing	; 
	out dx,ax	; 

	; Program the Graphics Controller	; 
	mov dx,3ceh	; Graphics Controller port address	; 
	mov ax,0204h	; Select map 2 for CPU reads	; 
	out dx,ax	; 
	mov ax,0005h	; Disable odd-even addressing	; 
	out dx,ax	; 
	mov ax,0406h	; Map starts at A000:0000 (64K start_mode)	; 
	out dx,ax	; 
	sti	; 
	ret
set_vid1 endp


set_vid3 proc far
	; Ok, put the Sequencer and Graphics Controller back to normal	; 
	; Program the Sequencer	; 
	cli
	mov dx, 3c4h	; Sequencer port address	; 
	mov ax, 0302h	; CPU writes to maps 0 and 1	; 
	out dx, ax	; 
	mov ax, 0304h	; Odd-even addressing	; 
	out dx, ax	; 

	; Program the Graphics Controller	; 
	mov dx, 3ceh	; Graphics Controller port address	; 
	mov ax, 0004h	; Select map 0 for CPU reads	; 
	out dx, ax	; 
	mov ax, 1005h	; Enable odd-even addressing	; 
	out dx, ax	; 
	mov ax, 0e06h	; Map starts at B800:0000	; 
	cmp start_mode,7
	jne notmono	; 
	mov ax, 0806h	; Map starts at B000:0000	; 
notmono:
	out dx, ax	; 
	sti
	ret
set_vid3 endp

getmode proc far
	mov	deskv,0
	mov	ax,2b01h
	mov	cx,4445h
	mov	dx,5351h
	int	21h
	cmp	al,0ffh
	je	check_mouse
is_deskv:
	mov	deskv,1
check_mouse:
	mov	color2,1fh
	mov	color1,70h
	mov	color4,70h
	cmp	mouseinstalled,0
	je	nomouse
	mov	color4,74h
nomouse:
	mov	ah,15
	int	10h
	mov	mode,al
	mov	vbuff,0b800h
	cmp	al,7
	je	mono
	ret
mono:
	mov	vbuff,0b000h
	mov	color1,70h
	mov	color2,07h
	ret
getmode endp


; the tone routines produce glisandos based on the value of si
thud proc far
; turn on tone
	mov	bx,200	; starting freq
	in	al,61h
	or	al,3
	out	61h,al
; loop parameters
	mov	cx,bx
 ; set frequency
	mov	dx,12h
	mov	ax,34deh
	div	cx
	mov	cx,ax
; set tone
	mov	al,cl
	out	42h,al
	mov	al,ch
	out	42h,al
	mov	cx,8000h
t2:
	loop t2
 ;turn off tone
	in	al,61h
	and al,11111100b
	out 61h,al
	ret
thud	endp
blip	proc	far
	push	si
	mov	si,20
	call	far ptr tone
	pop	si
	ret
blip	endp
blop	proc	far
public blop
	push	si
	mov	si,-20
	call	far ptr tone
	pop	si
	ret
blop	endp
tone	proc	far
	push	ax
	push	bx
	push	cx
	push	dx
	mov	dx,3	; tone rate
	mov	bx,100	; starting freq
	mov	cx,900	; ending frequency
	cmp	si,0
	jg	do_blip
; here we do blop
	mov	bx,900	; starting freq
	mov	cx,100	; ending frequency
do_blip:
; turn on tone
i0:
	push	cx
	push	bx
	in	al,61h
	or	al,3
	out	61h,al
; loop parameters
	mov	cx,bx
 ; set frequency
	mov	dx,12h
	mov	ax,34deh
	div	cx
	mov	cx,ax
; set tone
	mov	al,cl
	out	42h,al
	mov	al,ch
	out	42h,al
i2:
	nop
	nop
	nop
	loop i2
	pop	bx
	pop	cx
	cmp	bx,cx
	je	ip3
	add	bx,si
	jmp	i0
ip3:
 ;turn off tone
	in	al,61h
	and al,11111100b
	out 61h,al
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
tone	endp
getstring proc far
	mov	fstring,63
; clear the bottom line
; relocate the cursor
	mov	ah,2
	mov	bx,0
	mov	ch,24
	mov	cl,12
	mov	dh,24
	mov	dl,12
	int	10h
; set the message
	mov	di,24*2*80
	mov	si,offset findwhat
	call printat
;	mov	fstring+1,0
	mov	dx,offset fstring
	mov	ah,10
	int	21h
	cmp	fstring+1,1
	jle	no_string
	clc
	ret
no_string:
	stc
	ret
getstring endp




glist proc far
 	call showcurs	; if debugging
	mov	error_code,0
	mov	cursor,0
	mov	handle,0
	mov	buffcount,0
	mov	bline,0
	mov	doubleclick,0
xx
	mov	cx,buffermax*2
	mov	di,offset buffers
	cld
	rep	stosw
	mov	file_size,0
	mov	file_size+2,0
	mov	x,0
	mov	y,0
	mov	curline,0
	mov	topline,0
	mov	curline+2,0
	mov	topline+2,0
	mov	bline,0
	mov	lastfind,0
	mov	lastfind+2,0
xx
	call	openfile	; opens input file
	jc	error_cond2
xx
	call	read_file	; reads file (up to 64k) into buffer
	jc	error_cond2
xx
	mov	curline,0
	mov	curline+2,0
	mov	topline,0
	mov	topline+2,0
	mov	ah,ux
	mov	x,ah
	mov	ah,uy
	mov	y,ah
	call	setup_screen
xx
	call	do_line_no
xx
	call	minstall
xx
	jmp	dloop
error_cond2: jmp error_cond
show_error:
	mov	dx,error_code
	mov	ah,9
	int	21h
	mov	si,offset infile
se_loop:
	lodsb
	cmp	al,0
	je	se_exit
	mov	ah,14
	int	10h
	jmp	se_loop
se_exit:
	mov	ah,0
	int	16h
	ret
error_cond:
	mov	bline,0
	call showcurs
	call unallocate
	call mdeinstall
	cmp	error_code,0
	jne	show_error
	ret
;
;
error_loop:

	call	showmouse
	jmp	dloop2
;
dloop:
xx
	call	hidemouse
xx
	call	do_line_no
xx
	call	display_page ; show a page
xx
	call	do_line_no
xx
	call	showmouse
xx
dloop2:
	mov	ah,1
	int	16h	; check for key
	jnz	got_key
	call	move_mouse
; mousey stuff
	call	doublecheck
	cmp	doubleclick,1
	je	mouse_dcl
	test	ax,1
	jnz	check_mouseb
	jmp	dloop2
check_mouseb:
	cmp	mousecy,0
	je	mouse_up
	cmp	mousecy,24
	je	mouse_down
	jmp	dloop2
mouse_up:
	mov	ax,4800h
	jmp	mouse_key
mouse_down:
	cmp	mousecx,29
	jle	dloop2
	mov	ax,5000h
	jmp	mouse_key
mouse_dcl:
	mov	doubleclick,0
	cmp	mousecy,24
	jne	dloop2
; double clicked on bottom line
	mov	ah,0
	cmp	mousecx,29
	jg	dloop2
	mov	al,'C'
	cmp	mousecx,23
	jg	mouse_key
	mov	al,'F'
	cmp	mousecx,16
	jg	mouse_key
	mov	al,'P'
	cmp	mousecx,8
	jg	mouse_key
	mov	ax,011bh
	jmp	mouse_key
got_key:
	mov	ah,0
	int	16h	; wait for key
mouse_key:
	push	ax
	call	hidemouse
	pop	ax
	cmp	found,0
	je	dloop3
	mov	found,0
	push	ax
	call	setup_screen
	call	display_page ; show a page
	call	do_line_no
	pop	ax
dloop3:
; first the function stuff
	cmp	ah,47h
	jl	do_letters
	cmp	ah,51h
	jg	do_letters
	mov	bl,ah
	mov	bh,0
	sub	bx,47h
	shl	bx,1
	jmp	cs:kkeys[bx]
do_letters:
	cmp	al,'a'
	jl	is_upper
	cmp	al,'z'
	jg	is_upper
	sub	al,20h
is_upper:
; process non keypad keys
	cmp	ah,3dh
	je	f3
	cmp	ah,3eh
	je	f4
	mov	di,offset akeys
	mov	cx,11
	mov	bx,0
ak_loop:
	cmp	byte ptr ds:[di],al
	je	do_alpha
	inc	bx
	inc	bx
	inc	di
	loop	ak_loop
	jmp	error_loop
do_alpha:
	jmp	cs:akey[bx]
akey	dw printit,findmore,findit,pgup,pgdn,home,endk,down,error_cond
	dw error_cond,error_cond
	dw error_loop,error_loop
;
f3:
	mov	ah,color2 ; text color
	mov	al,ah
	and	ah,0f0h
f32:
	inc	al
	and	al,0fh
	mov	bl,ah
	mov	cl,4
	shr	bl,cl
	cmp	al,bl
	je	f32
	or	al,ah
	mov	color2,al
	call	setup_screen
	jmp	dloop
f4:
	mov	ah,color2 ; text color
	mov	al,ah
	and	al,0fh
f42:
	add	ah,10h
	and	ah,070h
	mov	bl,ah
	mov	cl,4
	shr	bl,cl
	cmp	al,bl
	je	f42
	or	al,ah
	mov	color2,al
	call	setup_screen
	jmp	dloop
printit:
	call showcurs
; this prints the whole document
;
; check the printer status
;
	call	prtstat
	jnc	ok_pstart
	call	hidecurs
	call	blop
	call	blip
	call	blop
	jmp	dloop
ok_pstart:
	mov	curline,0
	mov	curline+2,0
print_loop:
	call	get_byte
	push	ax
	jc	done_print
	mov	ah,1
	int	16h	; get a key
	jz	cont_p
	mov	ah,0
	int	16h	; get a key
	cmp	al,27
	je	done_print
cont_p:
	pop	ax
	call	print_byte
	jnc	print_loop
	push	ax
done_print:
	pop	ax
	call	hidecurs
;
	jmp	dloop
find_exit1:
; finder has the guy
	call	setup_screen
	mov	found,1
	mov	cx,finder	; bytes past the guy
	mov	bx,topline ; segment number of current line
	mov	si,topline+2
	shl	bx,1
	shl	bx,1
	mov	ax,buffers[bx]
	mov	bx,1
	push	ds
	mov	ds,ax
fe_loop:
	cld
	lodsb
	cmp	al,9 ; tab character
	jne	fe_notab
fe_loop1:
	inc	bx
	test	bx,7
	jz	fe_notab
	jmp	fe_loop1
fe_notab:
	inc	bx
	loop	fe_loop
	pop	ds
; bx has how many to go over
	push	es
	dec	bx
	dec	bx
	mov	di,bx
	shl	di,1
	add	di,161
	mov	cl,fstring+1
	mov	ch,0
	mov	es,vbuff
fe_1:
	mov	byte ptr es:[di],74h
	inc	di
	inc	di
	loop	fe_1
	pop	es
	mov	ax,curline
	mov	topline,ax
	mov	ax,curline+2
	mov	topline+2,ax
	jmp	dloop
find_exit:
	call	setup_screen
	mov	ax,curline
	mov	topline,ax
	mov	ax,curline+2
	mov	topline+2,ax
find_exitn:
	call	setup_screen
	jmp	dloop
no_find:
	if intern
	call	thud
	endif
	cmp	firster,0
	je	find_exitn
	mov	finder,0
	mov	ax,oldbline
	mov	bline,ax
	jmp	find_exitn
findmore:
findmore1:
	mov	ax,bline
	mov	oldbline,ax
	cmp	fstring+1,1
	jle	no_find
	bpget	bline
	mov	bx,lastfind
	mov	di,lastfind+2
	shl	bx,1
	shl	bx,1
find_loop:
	mov	cx,buffers[bx]+2
	sub	cx,di
	cmp	cx,0
	jle	no_find
	mov	dl,fstring+1
	mov	dh,0
	dec	dx
	cld
	push	es
	mov	es,buffers[bx]
fl_2:
	push	cx
	push	di
	inc	finder
	mov	ah,fstring+2
	mov	al,byte ptr es:[di]
	cmp	al,10
	jne	nota10
	inc	bp
	mov	finder,0
nota10:
	cmp	al,ah
	je	hit_one
	cmp	al,'a'
	jl	no_hit
	cmp	al,'z'
	jg	no_hit
	sub	al,20h
	cmp	al,ah
	je	hit_one
no_hit:
	pop	di
	pop	cx
	inc	di
	loop	fl_2
	jmp	next_fseg
hit_one:
	mov	si,offset fstring+3
	mov	cx,dx
	inc	di
	cmp	cx,0
	je	got_hit
hit_test:
	cld
	lodsb
	mov	ah,byte ptr es:[di]
	cmp	ah,'a'
	jl	checkf
	cmp	ah,'z'
	jg	checkf
	sub	ah,20h
checkf:
	cmp	ah,al
	jne	no_hit
	inc	di
	loop	hit_test
got_hit:
; hit the guy
	pop	di
	pop	cx
	shr	bx,1
	shr	bx,1
	mov	lastfind,bx
	inc	di
	mov	lastfind+2,di
	mov	ax,lastfind
	mov	curline,ax
	mov	ax,lastfind+2
	mov	curline+2,ax
	inc	bp
	bpmov	bline
	call find_prev
	mov	ax,curline
	mov	topline,ax
	mov	ax,curline+2
	mov	topline+2,ax
	pop	es
	mov	firster,1
	jmp	find_exit1
next_fseg:
	add	bx,4
	pop	es
	mov	di,0
	jmp	find_loop
findit:
	mov	finder,0
	mov	firster,0
	call	showcurs
	call	getstring
	jnc	setup_find
	call	setup_screen
	call	hidecurs
	jmp	dloop
setup_find:
	call	hidecurs
; convert the finder to upper case
	mov	cl,fstring+1
	mov	ch,0
;	dec	cx
	mov	si,offset fstring+2
	cld
su_loop:
	cmp	byte ptr ds:[si],'a'
	jl	su_upper
	cmp	byte ptr ds:[si],'z'
	jg	su_upper
	sub	byte ptr ds:[si],20h
su_upper:
	inc	si
	loop	su_loop
; this sets up from the current topline
	mov	bx,topline
	mov	lastfind,bx
	mov	si,topline+2
	mov	lastfind+2,si
	jmp	findmore1
down:
	mov	ax,topline
	mov	curline,ax
	mov	ax,topline+2
	mov	curline+2,ax
	call find_next
leave_move:
	mov	finder,0
	mov	ax,curline
	mov	topline,ax
	mov	lastfind,ax
	mov	ax,curline+2
	mov	topline+2,ax
	mov	lastfind+2,ax
	jmp	dloop
up:
	mov	ax,topline
	mov	curline,ax
	mov	ax,topline+2
	mov	curline+2,ax
	call find_prev
	jmp	leave_move
pgdn:
	mov	ax,topline
	mov	curline,ax
	mov	ax,topline+2
	mov	curline+2,ax
	mov	cx,23
pd_loop:
	push	cx
	call find_next
	pop	cx
	loop	pd_loop
	jmp	leave_move
pgup:
	mov	ax,topline
	mov	curline,ax
	mov	ax,topline+2
	mov	curline+2,ax
	mov	cx,23
pu_loop:
	push	cx
	call find_prev
	pop	cx
	loop	pu_loop
	jmp	leave_move
home:
	mov	curline,0
	mov	curline+2,0
	mov	bline,0
	jmp	leave_move
endk:
	mov	ax,topline
	mov	curline,ax
	mov	ax,topline+2
	mov	curline+2,ax
endk1:
	call find_next
	jnc	endk1
	mov	ax,curline
	mov	topline,ax
	mov	ax,curline+2
	mov	topline+2,ax
	jmp	pgup
kkeys dw	home,up,pgup,error_loop
	dw	up,error_loop,down,error_loop
	dw endk,down,pgdn
;
glist	endp







;**************************************************************
	end

