print macro string
lea dx,string
mov ah,9
int 21h
endm
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
mess0   db 'Application Menu Copyright 1988 by Keith P. Graham',13,10
        db 'Version 1.00',13,10
        db 'Installing.....',13,10
        db 'Press the RETURN key twice at any DOS prompt for Menu',13,10,'$'
; this area is used by the resident and passthrough versions
;
first_time db 0
echoon db 'echo on',0
pline10 db 255
pline  db  0
       db  256 dup(0)
istack   dw   256  dup(0)
istackl  dw   256  dup(0)
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
semaphore db  0
handle  dw 0
ds10       dw  0
mess1    db  "Exit Menu.....",13,10,10,'$'
eof  db 1ah
qline  db 80,0,81 dup(0)
bcursor  dw  0
save dw 45*25 dup(0)
new_menu dw 0
;
; this data is used by the passthru program only
;
command_line db 1
             db " ",13,0
;ommand_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
pcount   db  0
inbatch  dw  0
batchloc dw  0
perc     dw 10 dup(0)
         dw  0ffffh
percs   db 256 dup(0)
services proc near
upper1:
        cmp   al,'a'
        jl    up1
        cmp   al,'z'
        jg    up1
        sub   al,32
up1:
        ret
parse_p:
; this routine puts the contents of qline into %1 etc
        lea  di,perc
        mov  cx,9
        cld
        mov  ax,0
rep     stosb
        lea  di,percs
        mov  cl,qline+1
        mov  ch,0
        cmp  cx,0
        jg   ok_perc
exit_perc:
        mov  al,0
        stosb
        ret
ok_perc:
        lea  si,qline+2
        lea  bx,perc
; get leading spaces
pc1:
         lodsb
         cmp  al,13
         je   exit_perc
         cmp  al,32
         jne  pc2
         loop pc1
         jmp  exit_perc
pc2:
; got the first non_blank character
          mov  es:[bx],di
          inc  bx
          inc  bx
          cmp  word ptr es:[bx],0
          jne  exit_perc
          stosb
pc3:
          lodsb
         cmp  al,13
         je   exit_perc
         cmp  al,32
         je   pc4
         stosb
         loop pc3
         jmp  exit_perc
pc4:
          mov   al,0
          stosb
          jmp   pc1
;
blank_line:
; here the blank line was pressed, do something
; print out the menu
        inc  pcount
        cmp  pcount,1
        jg   do_bl
        stc
        ret
do_bl:
        call  do_menu
;
        ret
services endp
START        PROC        far
dosint:
        cmp   ah,10
        je    got_10
        jmp   cs:int21
got_10:
; first time through check out the current cs and save it
        cmp   cs:semaphore,0
        jne   not_first
        mov   cs:ds10,ds
        mov   cs:semaphore,1
not_first:
; we are at int21 10, it is time to replace it with our own
        push  ax
        mov   ax,ds
        cmp   cs:ds10,ax
        je    got_dosp
        pop   ax
        jmp   cs:int21
got_dosp:
        mov   cs:savessl,ss
        mov   cs:savespl,sp
        mov   ax,cs
        mov   ss,ax
        lea   sp,istackl+510
        push  bx
        push  cx
        push  dx
        push  si
        push  di
        push  bp
        push  ds
        push  es
; ds:dx points to the
        push  dx
        push  ds
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
re_enter:
        cmp   batchloc,0
        je    not_running_batch
        jmp   run_batch
not_running_batch:
; get the cursor start position
          mov   ah,3
          mov   bx,0
          int   10h
          mov   bcursor,dx
        cmp  first_time,0
        jne  not_first_time
        jmp  got_star
not_first_time:
clear_dline:
          mov   dx,bcursor
          mov   ah,2
          mov   bx,0
          int   10h
do_gl:  ; do the getline
        lea   dx,pline10
        mov   ah,10
        int   21h
do_normal_enter:
; get rid of leading spaces
; here we save the current line
; check to see if return is pressed at a blank line
        lea   si,pline+1
        cmp   pline,0
        jne   no_blank
; blank line pressed
do_blank:
         mov  first_time,1
        call  blank_line
        jnc   do_batch
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
        lea   si,echoon
      jmp  no_blank2
        jmp   clear_dline
got_star:
        inc  pcount
        mov  pline,0
        jmp  do_blank
got_colon:
        mov  pcount,0
        mov  pline,0
        jmp  re_enter
got_q:
      mov  pcount,0
      mov  pline,0
      lea  dx,qline
      mov  ah,10
      int  21h
      call  parse_p
      lea   si,pline+1
      jmp  no_blank2
do_batch:
; this is new method stuff
        jmp   run_batch
no_blank:
        lea   si,pline+1
proc_blank:
; get rid of leading spaces
        push  si
        mov   di,si
        mov   cl,0
pbl1:
        lodsb
        cmp   al,0
        je   pbl3
        cmp   al,13
        je   pbl3
        je   pbl3
        cmp   al,20h
        jne  pbl2
        cmp  cl,0
        je   pbl1
pbl2:
        mov  cl,1
        stosb
        jmp  pbl1
its_echo:
        pop   si
        mov   pcount,0
        cmp   byte ptr [si],'*'
        je    got_star
        cmp   byte ptr [si],'?'
        je    got_q
        cmp   byte ptr [si],':'
        je    got_colon
        jmp   no_blank2
pbl3:
        stosb
        pop   si
; convert to upper case
        push  si
        mov   di,si
        lodsb
        call  upper1
        stosb
        cmp   al,'E'
        jne   finish_upper
        lodsb
        call  upper1
        stosb
        cmp   al,'C'
        jne   finish_upper
        lodsb
        call  upper1
        stosb
        cmp   al,'H'
        jne   finish_upper
        lodsb
        call  upper1
        stosb
        cmp   al,'O'
        jne   finish_upper
        lodsb
        call  upper1
        stosb
        cmp   al,' '
        jne   finish_upper
        jmp   its_echo
finish_upper:
        lodsb
        call  upper1
        stosb
        cmp   al,0
        je    its_echo
        cmp   al,13
        je    its_echo
        jmp   finish_upper
no_blank2:
; here si points to a source and di points to a target
        pop   es
        pop   di
; here si points to a source and di points to a target
; here we have to transfer the stuff back to where it goes
        mov   cl,byte ptr es:[di]
        mov   ch,0
        inc   di
        mov   byte ptr es:[di],0
        mov   bx,di
        inc   di
        cld
ploop:
       lodsb
       cmp   al,0
       je    done_p
       cmp   al,13
       je    done_p
       cmp   al,'%'
       jne   no_replace
       lodsb
       cmp   al,'1'
       jl    no_replace
       cmp   al,'9'
       jg    no_replace
       push  si
       push  bx
       mov   bl,al
       mov   bh,0
       and   bl,0fh
       dec   bx
       shl   bx,1
       mov   si,perc[bx]
       pop   bx
       cmp   si,0
       je    done_replace
pr_loop:
       lodsb
       cmp   al,0
       je    done_replace
       stosb
       inc   byte ptr es:[bx]
       loop  pr_loop
done_replace:
       pop   si
       cmp   cx,0
       jle   done_p
       jmp   end_ploop
no_replace:
       stosb
       inc   byte ptr es:[bx]
end_ploop:
       loop  ploop
done_p:
       inc   byte ptr es:[bx]
       mov   al,13
       stosb
;
       pop  es
       pop  ds
       pop  bp
       pop  di
       pop  si
       pop  dx
       pop  cx
       pop  bx
       mov  ss,cs:savessl
       mov  sp,cs:savespl
       pop  ax
       iret
run_batch:
; here we load up the line with the next load of batch info
     mov  di,batchloc ; line
     mov  si,di
     cld
     mov  cx,512
rl_loop:
     cmp  byte ptr ds:[di],0
     je   rl_last
     cmp  byte ptr ds:[di],10
     je   rl_line
     cmp  byte ptr ds:[di],13
     je   rl_linea
     inc  di
     loop rl_loop
rl_last:
     mov  batchloc,0
        jmp   proc_blank
rl_linea:
     inc  di
rl_line:
; di points to the location of the next guy
     inc   di
     mov  batchloc,di
; si points to the line to transfer to the batch
        jmp   proc_blank
START        ENDP
upleft  equ  201
upright equ  187
loleft  equ  200
loright equ  188
horiz   equ  205
vert    equ  186
;
color1  db   17h  ; color
color2  db   4fh  ; color
cursor  dw   0
menu    db   20  ;height
wwidth  db   40   ;width
wx      db   20   ;x location
wy      db   1     ;y location
dcolor  db   17h  ; color
; menu text
menuline1 db ' Application Menu -- Control Panel',13,10
          db ' Copyright 1988 by Keith P. Graham',13,10
          db 40 dup("")
          db 13,10
menutext db  45*25 dup(0)
h       db  0
w       db  0
he      db  0
we      db  0
x       db  0
xe      db  0
y       db  0
ye      db  0
color   db  0
hide    dw  0
savesi  dw  0
t       dw  0
;
; do menu
do_menu:
          lea    si,menu
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          mov    ccline,0
          mov    ocline,0
          jmp    get_key
ccline   dw 0
ocline  dw 0
bad_key:
          call   blop
; wait for keystroke
get_key:
; normalize the line pointed to by ocline
          mov     cl,wwidth
          mov     ch,0
          dec     cx
          dec     cx
          mov     dh,byte ptr ocline
          add     dh,4    ; 0 is border,1,2 are title, 3 blank
          add     dh,wy
          mov    dl,wx
          inc    dl
wwloop:
         push  cx
         push  dx
          mov    ah,2
          mov    bx,0
          int    10h      ; locate
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; fix attribute
          mov    ah,9
          mov    cx,1
          mov    bl,color1
          int    10h
         pop   dx
         inc   dl
         pop  cx
         loop  wwloop
; highlight the menu menu bar pointed to cline
          mov     cl,wwidth
          mov     ch,0
          dec     cx
          dec     cx
          mov     dh,byte ptr ccline
          add     dh,4    ; 0 is border,1,2 are title, 3 blank
          add     dh,wy
          mov    dl,wx
          inc    dl
w2loop:
         push  cx
         push  dx
          mov    ah,2
          mov    bx,0
          int    10h      ; locate
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; fix attribute
          mov    ah,9
          mov    cx,1
          mov    bl,78h
          int    10h
         pop   dx
         inc   dl
         pop  cx
         loop  w2loop
         mov   ax,ccline
         mov   ocline,ax
          call   hide_cursor
;
;
          mov     ax,bp
          mov     ah,0
          int     16h
          cmp     al,27
          je      exit_w
          cmp     ax,4800h
          je      move_up
          cmp     ax,5000h
          je      move_down
          cmp     al,13
          je      do_it
; check for first letter of each menu line
          cmp     al,30h
          jl     gbad_key
          cmp     al,'z'
          jg     gbad_key
          cmp     al,'Z'
          jle     is_upper
          sub     al,32
is_upper:
; al has a character to check the first byte of each command
          mov      cx,16
          mov      bx,0
fc_loop:
          cmp      items[bx],0
          je      gbad_key
          cmp      items[bx],0ffffh
          je      gbad_key
          mov     si,items[bx]
          cmp     byte ptr ds:[si],al
          je      got_fb
          inc     bx
          inc    bx
          loop   fc_loop
gbad_key:
          jmp     bad_key
got_fb:
          shr     bx,1  ; divide by 2
          mov     ccline,bx
          jmp     do_it
exit_w:
        mov  pcount,0
          call    restore_window
          call    restore_cursor
          stc
          ret
move_up:
       dec  ccline
       cmp  ccline,0
       jge  move_ret
       mov  al,menu
       mov  ah,0
       sub  ax,6
       mov  ccline,ax
move_ret:
     jmp  get_key
move_down:
     inc  ccline
     mov  al,menu
     mov  ah,0
     sub  ax,6
     cmp  ccline,ax
     jle  move_ret
     mov  ccline,0
     jmp  get_key
do_it:
; this is the new way where we set up batchloc info
     mov  bx,ccline
     shl  bx,1
     mov  di,word ptr ds:items[bx]  ; line
     cld
     mov  cx,512
     mov  al,10
repne scasb
; di points to the location of the next guy
     mov  batchloc,di
          call    restore_window
          call    restore_cursor
     clc
     ret
; loop through to find the first line of the command
save_si:
;
          mov    savesi,si
          cld
          lodsb
      mov     h,al
      dec     al
      dec     al
      mov     he,al
          lodsb
      mov     w,al
      dec     al
      dec     al
      mov     we,al
          lodsb
      mov     x,al
          dec al
          add al,w
      mov     xe,al
          lodsb
      mov     y,al
          dec al
          add al,h
      mov     xe,al
          lodsb
      mov     color,al
      mov     t,si
      ret
put_mess:
; puts a message to the screen
          cld
          call   blip
          mov    si,t
          mov    dh,y
          mov    dl,x
          inc    dh
          inc    dl
          mov    cx,0     ; cl is column
mloop0:
          push   cx
          push   dx
mloop1:
          push   cx
          push   dx
          cmp    ch,he
          jge    end_put_mess
          lodsb
          cmp    al,0
          je     end_put_mess
          cmp    al,10
          je     ignore_char
          cmp    al,13
          je     new_line
          cmp    cl,we
          jge    ignore_char
; got the character put it on the screen
; locate the cursor
          push   ax
          mov    ah,2
          mov    bx,0
          int    10h
          pop    ax
          mov    ah,10
          mov    cx,1
          int    10h
          pop    dx
          pop    cx
          inc    dl
          inc    cl
          jmp    mloop1
new_line:
          pop    dx
          pop    cx
          pop    dx
          pop    cx
          inc    dh
          inc    ch
          jmp    mloop0
ignore_char:
          pop    dx
          pop    cx
          jmp    mloop1
end_put_mess:
          pop    dx
          pop    cx
          pop    dx
          pop    cx
          ret
restore_window:
; puts the old window back
;setup cursor at x,y
          mov    dh,y
          mov    dl,x
; set up save place
          lea    si,save
          cld
; the current cursor position is in dx
          mov    cl,h
          mov   ch,0
rloop1:
          push   cx
          push   dx
          mov    cl,w
          mov   ch,0
rloop2:
          push   cx
          push   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
          lodsw
; put stuff
          mov    bl,ah
          mov    ah,9
          mov    bh,0
          mov    cx,1
          int    10h
          pop    dx
          pop    cx
          inc    dl
          loop   rloop2
          pop    dx
          pop    cx
          inc    dh
          loop   rloop1
          ret
restore_cursor:
; restore cursor
          mov     dx,cursor
          mov     ah,2
          mov     bx,0
          int     10h
save_cursor:
; get and save current x,y position
          mov   ah,3
          mov   bx,0
          int   10h
          mov   cursor,dx
          ret
save_window:
;setup cursor at x,y
          mov    dh,y
          mov    dl,x
; set up save place
          lea    di,save
          cld
; the current cursor position is in dx
          mov    cl,h
          mov    ch,0
wloop1:
          push   cx
          push   dx
          mov    cl,w
          mov   ch,0
wloop2:
          push   cx
          push   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; ax has the attrib and byte
          stosw
; find out what to put in al
          mov   al,color2
          mov   color,al
          push   dx
          mov    al,20h
          cmp    dh,y  ; row
          je     top_row
          inc    dh
          sub    dh,h
          cmp    dh,y
          je     bot_row
          cmp    dl,x
          je     left_col
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     right_col
          pop    dx
          push   dx
          sub    dh,3
          cmp    dh,y
          jle    bot_color
          mov    ah,color1
          mov    color,ah
bot_color:
          jmp    end_loop1
left_col:
right_col:
          mov    al,vert
          jmp    end_loop1
bot_row:
          mov    al,horiz
          cmp    dl,x
          je     bot_left
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     bot_right
          jmp    end_loop1
bot_right:
          mov    al,loright
          jmp    end_loop1
bot_left:
          mov    al,loleft
          jmp    end_loop1
top_row:
          mov    al,horiz
          cmp    dl,x
          je     top_left
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     top_right
          jmp    end_loop1
top_right:
          mov    al,upright
          jmp    end_loop1
top_left:
          mov    al,upleft
;          jmp    end_loop1
end_loop1:
          pop    dx
; place the correct character and attribute at the position
          mov    ah,9
          mov    bl,color
          mov    cx,1
          mov    bh,0
          int    10h
          pop    dx
          pop    cx
          inc    dl
          loop   jmp_wloop2
          jmp    by_wloop2
jmp_wloop2:
          jmp    wloop2
by_wloop2:
          pop    dx
          pop    cx
          inc    dh
          loop   jmp_wloop1
          jmp    by_wloop1
jmp_wloop1:
          jmp    wloop1
by_wloop1:
; have to hid the cursor
          dec    dh
          dec    dh
          add    dl,w
          dec   dl
          dec    dl
          mov    hide,dx
          ret
hide_cursor:
          mov    dx,hide
          mov    ah,2
          mov    bx,0
          int    10h
          mov    bl,color1
          and    bl,0f0h
          mov    al,bl
          mov    cl,4
          shr    al,cl
          or     bl,al
          mov    al,0
          mov    ah,9
          mov    cx,1
          mov    bh,0
          int    10h
          ret
tone:
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blip:
        push  ax
        push  bx
        push  cx
        push  dx
        push  si
        push  di
        mov   si,30
        call  tone
        pop   di
        pop   si
        pop   dx
        pop   cx
        pop   bx
        pop   ax
        ret
blop:
        push  ax
        push  bx
        push  cx
        push  dx
        push  si
        push  di
        mov   si,-30
        call  tone
        pop   di
        pop   si
        pop   dx
        pop   cx
        pop   bx
        pop   ax
        ret
;;nclude c:gline.asm
setpass  proc  near
; set up a local istack
        lea  sp,istack+510
; check out the menu config file
        mov  cl,byte ptr ds:[80h]
        mov  ch,0
        cmp  cx,1
        jle  nnc
        mov  si,81h
        lea  di,menun
        cld
; first check for leading spaces and find first comma
gc0:
        lodsb
        cmp  al,13
        je   nnc
        cmp  al,','
        je   gc0b
        cmp  al,20h
        jne   gc0a
        loop  gc0
        jmp  no_new_con
gc0a:
        cmp  al,'A'
        je   good_form
        cmp  al,'a'
        je   good_form
        mov  first_time,1
        cmp  al,'n'
        je   good_form
        cmp  al,'N'
        jne  bad_forma
good_form:
; look for a comma
       dec   cx
       cmp   cx,0
       jle  nnc
       lodsb
       cmp   al,13
       je   nnc
       cmp   al,','
       je   gc0b
       cmp   al,20h
       je   good_form
bad_forma:
       jmp  bad_form
gc0b:
; have a comma
       dec   cx
       cmp   cx,0
       jle  nnc

get_config:
        lodsb
        cmp  al,13
        je   nnc
        cmp  al,','
        je   gc4
        cmp  al,20h
        jne   gc1
        loop  get_config
        jmp  no_new_con
gc1:
        stosb
gc2:
        lodsb
        cmp  al,13
        je   gc3a
        cmp  al,','
        je   gc3b
        cmp  al,20h
         je   gc3c
        stosb
        loop  gc2
        mov  al,0
        stosb
nnc:
        jmp   no_new_con
gc3a:
        mov  al,0
        stosb
        jmp   no_new_con
gc3b:
        mov  al,0
        stosb
        jmp   gc4
gc3c:
        mov  al,0
        stosb
gc3:
; look for next comma
        lodsb
        cmp  al,13
        je   nnc
        cmp  al,','
        jne  bad_form
        cmp  al,','
        je   gc4
        loop  gc3
        jmp   nnc
gc4:
       dec   cx
       cmp   cx,0
       jle  no_new_con
       dec  si
       inc  cx
       mov  byte ptr ds:[si],cl
       lea  di,qline+1
       inc   cx
       cld
rep    movsb
      call  parse_p
; got the comma
no_new_con:
; get the menu configuration
        lea  dx,menun
        mov  ah,3dh
        mov  al,0
        int  21h
        jnc  good_open
bad_file:
        print emess2
        int  20h
bad_form:
        print emess3
        int  20h
good_open:
        mov  handle,ax
        mov  bx,ax
        lea  dx,buffer
        mov  cx,2000h ; biggest file
        mov  ah,3fh
; read in the configuration file
        int  21h
        jc   bad_file
        cmp  ax,cx
        je   bad_file
        cmp  ax,0
        je   bad_file
; ax has the size of the file
        push ax
; close the file
        mov  bx,handle
        mov  ah,3eh
        int  21h
        pop  cx
; set up the command menu
        lea  di,menutext
        mov  new_menu,di
        lea  si,buffer
        lea  bx,items
        mov  di,ds:[bx]
; find the first tilde
search_t:
        lodsb
        cmp  al,'~'
        je   first_t
        cmp  al,'#'
        je   secret
        loop search_t
bad_filex:
        jmp  bad_file
secret:
; have to save the start of the menu heading
        mov  cx,3  ; number of cr line feeds to look for
        push di
        lea  di,menuline1
secret1:
        lodsb
secret1a:
        cmp  al,1ah  ; eof
        je   bad_file
        cmp  al,0  ; eof
        je   bad_file
        cmp  al,10
        je   secret2
        stosb
        jmp  secret1
secret2:
; got a line feed
        stosb
        dec  cx
        cmp  cx,0
        jle  secret9
        lodsb
        cmp  al,'~'
        je   secret8
        jmp  secret1a
secret8:
; got a tilde after a lf
secret8a:
        mov  ax,0a0dh
        stosw
        loop  secret8a
        mov  new_menu,di
        pop  di
        jmp  first_t
secret9:
; got three line feeds no tilde
        mov  new_menu,di
        pop  di
        jmp  search_t
first_t:
        mov  al,0
        stosb
        mov  ds:[bx],di
        inc  bx
        inc  bx
        cmp  byte ptr ds:[di],0
        jne  bad_filex
next_char:
        lodsb
        cmp  al,'~'
        je   first_t
        cmp  al,1ah  ; eof
        je   end_st_loop
        cmp  al,0  ; eof
        je   end_st_loop
n_store:
        stosb
        loop next_char
end_st_loop:
        mov  last_guy,di
; this sets up the internal screen so the menu will work
        mov  cx,21  ; max lines
        lea  bx,items ; list of items
        mov  menu,5
        mov  di,new_menu
bl_loop:
        push cx
        cmp  word ptr ds:[bx],0
        jne  disp_bl
exit_bl:
        pop  cx
        jmp  end_bl
disp_bl:
        mov  si,word ptr ds:[bx]  ; line
        cmp  si,0ffffh
        je   exit_bl
        inc  bx
        inc  bx
        inc  menu
        mov  al,20h
        stosb
bl_loop1:
        cld
        lodsb
        cmp  al,0
        je   end_item
        cmp  al,13
        je   end_item
        stosb
        jmp  bl_loop1
end_item:
        mov  ax,0a0dh
        stosw
        pop  cx
        loop bl_loop
end_bl:
     print mess0
do_redirects:
;
; redirect interrupts here
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ah,25h
        mov   al,21h
        lea   dx,dosint
        int   21h
;
;  prepare for the exec function
; shrink memory
   mov   bx,last_guy     ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the istack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int21
        mov   ah,25h
        mov   al,21h
        int   21h
        pop   ds
        int   20h
setpass  endp
items    dw   item1
         dw   17 dup(0)
         dw   0ffffh
item1    db   2000h dup(0)
menun    db 'config.mn'
         db  80 dup(0)
emess2  db 'Menu configuration file not present or invalid',13,10
        db 'Job Aborting',13,10,'$'
emess3  db 'Error in command line. Please refer to Documentation',13,10,'$'
last_guy dw  0 ;length of tsr area
buffer equ this byte
CSEG        ENDS
        END        ENTPT
