if1
  include c:cf.asm
endif
print macro string
      lea  dx,string
      mov  ah,9
      int  21h
      endm
input macro string
      lea  dx,input&string
      mov  ah,0ah
      int  21h
      PRINT CRLF
      endm
cSEG        SEGMENT PARA PUBLIC 'CODE'
        assume cs:cseg,ds:cseg,es:cseg
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        main                         ;COM FILE ENTRY ALWAYS AT 100H
; data areas
         db 'Copyright 1987 by',13,10
Signature db 'Keith P. Graham',13,10,'238 Germonds Rd.',13,10
         db 'W. Nyack, NY 10994',13,10
         db '(914) 623-4161',13,10
;
;
; begin the font window
;
;
rows2    equ 19
cols2    equ 29
; window is 19*29 + 2 + 12 + 24*32  = ???? bytes
wtable   dw  windowa
         dw  windowb
         dw  Windowc
         dw  Windowd
         dw  Windowe
         dw  Windowf
         dw  Windowg
         dw  Windowh
         dw 0
         dw  Windowj
         dw 0
         dw  Windowl
         dw  Windowm
         dw  Windown
         dw  0
         dw  Windowp
         dw  Windowq
         dw 0
         dw 0
         dw  Windowt
         dw 10 dup(0)
makewind    A,P1,P2,P3,L1,L4
ptx           1,2,3,101,104
makewind    B,P1,P5,P6,P7,P8,L1,L4
ptx           1,5,6,7,8,101,104
makewind    C,P1,P2,P3,P4,L1,L4
ptx           1,2,3,4,101,104
makewind    D,P1,P10,P11,P12,L1
ptx           1,10,11,2,101
makewind    E,P1,P13,P14,P15,L1,L4
ptx           1,13,14,15,101,104
makewind    F,P1,P4,P5,P6,P7,P8,P9,L1
ptx           1,4,5,6,7,8,9,101
makewind    G,P1,P10,P11,P12,P19,P20,P21,P22,P23,L1,L22,L23
ptx           1,10,11,12,19,20,21,22,23,101,122,123
makewind    H,P1,P2,P3,P16,P17,P18,P22,P23,P24,L1,L22,L23
ptx           1,2,3,16,17,18,22,23,24,101,122,123
makewind    J,P1,P10,P11,P12,P22,P26,P27,P28,L1
ptx           1,10,11,12,22,26,27,28,101
makewind    L,P1,P2,P3,P4,L1,L2,L3,L4
ptx           1,2,3,4,101,102,103,104
makewind    M,P1,P10,P11,P12,L1,L10,L11,L12
ptx           1,10,11,12,101,110,111,112
makewind    N,P1,P13,P14,P15,L1,L13,L14,L15
ptx           1,13,14,15,101,113,114,115
makewind    P,P1,P6,P7,P8,L1,L6,L7,L8
ptx           1,6,7,8,101,106,107,108
makewind    Q,P1,P2,P3,P13,P14,L1,L2,L3
ptx           1,2,3,13,14,101,102,103
makewind    T,P1,P23,P29,P30,P31,P32,P33,P34,L1
ptx           1,23,29,30,31,32,33,34,101
;
;
;  end of font window
;
;
; messages
CRLF     DB 13,10,'$'
mess1    db 'CLFONT.COM Laserjet font installation',13,10
         db 'Version 1.0 October 27, 1987',13,10
         db 'Copyright 1985 by',13,10
         db 'Keith P. Graham',13,10
         db 10,10,'$'
mess2    db 'ENTER PROGRAM TO MODIFY [CLASER.COM]:$'
mess3    db 'ENTER FONT LETTER [A-T]:$'
mess4    db 'ENTER PROGRAM TO BE CREATED ['
file1    db 'CLASER$                                  '
append   db 'B.COM]:$'
mess5    db 'CLFONT COMPLETE, PROGRAM SUCCESSFULLY CREATED',13,10,'$'
err1     db 7,'FILE NOT FOUND',13,10,'$'
err2     db 7,'FONT LETTER MUST BE A,B,C,D,E,F,G,H,J,L,M,N,P,Q, OR T',13,10,'$'
err3     db 7,'ERROR OPENING NEW FILE',13,10,'$'
err4     db 7,'FILE IS NOT A COPY OF CLASER.COM',13
         db 10,'$'
err5     db 7,'ERROR READING INPUT FILE',13,10
err6     db 7,'ERROR WRITING OUTPUT FILE',13,10
default1 db 32,11,'CLASER.COM',13
default2 db 2,2,'B',13
default3 db 32,12,'CLASERB.COM',13
input1   db 32,0,
         db 32 dup(0)
input2   db 2,0,0,0
input3   db 32,0,
         db 32 dup(0)
buffer1  db 40 dup(0)
buffer2  db 40 dup(0)
handle1  dw 0
handle2  dw 0
buffer   db 2048 dup(0)
main    proc   near
        print  mess1
top:
        print  mess2
        input  1
        lea    si,input1+2
        mov    cl,input1+1
        mov    ch,0
        lea    di,buffer1
        cmp    cx,0
        jne    move1
        mov    cx,10
        lea    si,default1+2
move1:
        cld
rep     movsb
        mov  al,0
        stosb
        lea    dx,buffer1
        mov    al,0
        mov    ah,3dh
        int    21h
        jnc    goodopen1
        print  err1
        jmp    top
goodopen1:
        mov    handle1,ax
getfont:
        print  mess3
        input  2
        cmp    input2+1,1
        je     gotfont
        mov    input2+1,2
        mov    input2+2,'B'
gotfont:
        cmp    input2+2,'a'
        jl     nolower
        cmp    input2+2,'t'
        jg     badfont
        sub    input2+2,32
nolower:
        cmp    input2+2,'A'
        jl     badfont
        cmp    input2+2,'T'
        jg     badfont
        cmp    input2+2,'I'
        je     badfont
        cmp    input2+2,'O'
        je     badfont
        cmp    input2+2,'R'
        je     badfont
        cmp    input2+2,'S'
        je     badfont
        jmp    goodfont
badfont:
        print err2
        jmp    getfont
goodfont:
        lea    si,buffer1
        lea    di,file1
        mov    cx,32
        cld
dofile1:
        lodsb
        cmp    al,0
        je    dodollar
        cmp    al,'.'
        je    dodollar
        stosb
        loop  dofile1
dodollar:
        mov  al,'$'
        stosb
        mov   al,input2+2
        mov   append,al
prompt3:
        print mess4
        print append
        input  3
        cmp   input3+1,0
        jg    do3
        lea   si,file1
        lea   di,buffer2
        mov   cx,31
do_3_def:
        cld
        lodsb
        cmp   al,'$'
        je    next3
        cmp   al,0dh
        je    next3
        cmp   al,']'
        je    done_3_def
        stosb
        loop  do_3_def
        jmp   done_3_def
next3:
        lea   si,append
        loop  do_3_def
done_3_def:
        mov   al,0
        stosb
        jmp   open_file2
do3:
        lea   si,input3+2
        mov   cl,input3+1
        mov   ch,0
        lea   di,buffer2
        jmp   do_3_def
open_file2:
; creat the output file
        lea   dx,buffer2
        mov   cx,0
        mov   ah,3ch
        int   21h
        jnc   good_open2
        print err3
        jmp   prompt3
good_open2:
        mov    handle2,ax
; read first 2048 bytes
        lea   dx,buffer
        mov   cx,2048
        mov   bx,handle1
        mov   ah,3fh
        int   21h
        jnc   goodread1
        print err5
        jmp   end_prog
        db  'xyzzy'
goodread1:
        mov   si,104h
        lea   di,buffer+4
        mov   cx,16
        cld
repe    cmpsw
        je  foundcl
        print  err4
        jmp   end_prog
foundcl:
; move the screen in place
;
        mov   bl,byte ptr input2+2
        mov   bh,0
        sub   bx,41h
        add   bx,bx
; bx has the offset of address into windowtab
        mov   si,wtable[bx]
        lea   ax,wtable   ; the wtable happens to be the address in
;                           claser where the window goes
        lea   di,buffer
        add   di,ax
        sub   di,100h
; window is 19*29 + 2 + 12 + 24*32  = ???? bytes
        mov   cx,2+12+(24*32)+(19*29)
        cld
rep     movsb
; begin write-read loop
        mov   cx,2048
topwrite:
 ;      write the file
        mov   bx,handle2
        lea   dx,buffer
        mov   ah,40h
        int   21h
        cmp   ax,cx
        jne   write_err
        jmp   read_next
write_err:
        print err6
        jmp   end_prog
read_next:
        mov   cx,2048
        lea   dx,buffer
        mov   bx,handle1
        mov   ah,3fh
        int   21h
        cmp   ax,0
        je    end_rw
        mov   cx,ax
        jmp   topwrite
end_rw:
        print  mess5
end_prog:
        int   20h
main    endp
CSEG        ENDS
        END        ENTPT
