print macro string
      lea  dx,string
      mov  ah,9
      int  21h
      endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org      100h     ;end of program segment prefix
enter:    jmp      main     ;skip over data
envcount dw  0
dosbase  dw  0
dsenv    dw  0
nextload dw  0
lastlook dw  0
envs     dw  128 dup(0)
mess1     db 'MMAP memory mapper, Copyright 1987 by Keith P. Graham'
          db  13,10,10,'$'
mess2    db 'DOS appears to be loaded at Paragraph: '
dlh      db '    h',13,10,10,'$'
mess3    db 'An application is loaded at Paragraph: '
elh      db '    h'
         db ' size ='
esh      db '       bytes',13,10,'$'
mess3a   db 'There is a free block at Paragraph: '
elha     db '    h'
         db ' size ='
esha     db '       bytes',13,10,'$'
Mess4    db 13,10,'Next load point is at Paragraph:       '
nlh      db '    h',13,10,'$'
main      proc     near
          print mess1
          push   es
          mov    ah,35h
          mov    al,20h
          int    21h
          mov    dosbase,es
          mov    dx,es
          pop    es
; search for the envirnoment
; dx has the segment address of the dos area
          mov    bx,ds:[2ch]
          mov    dsenv,bx
          dec    bx
          mov    ax,es
          mov    nextload,ax
          mov    lastlook,bx
          mov    cx,bx
          sub    cx,dosbase
; cx has the number of segments to search
          lea    di,envs
searchloop:
          push   cx
          push   dx
          push   di
          push   es
          push   ds
          mov    cx,5  ; number of compares to find an environment
          cld
          mov    di,0
          mov    si,0
          mov    ax,dsenv
          mov    ds,ax
          mov    es,dx
repe      cmpsw
          pop    ds
          pop    es
          pop    di
          pop    dx
          pop    cx
          jne    noenv
; got that environment match
          mov     ax,dx
          stosw
          inc     envcount
noenv:
          inc    dx
          loop   searchloop
; we have finished our race
; now we have to print the results
          mov    ax,dosbase
          call   dohex
          mov    dlh,dh
          mov    dlh+1,dl
          mov    dlh+2,ah
          mov    dlh+3,al
          print mess2
; now do the memory resident functions
          cmp    envcount,0
          jg     doenvs
          jmp    donextl
doenvs:
          mov    cx,envcount
;         dec    cx
          lea    si,envs
envloop:
          push   es
          push   cx
          lodsw
          push   si
; ax has the location of the environment
          dec    ax
          mov    es,ax
          mov    ax,es:[1]
          call   dohex
          mov    elh,dh
          mov    elh+1,dl
          mov    elh+2,ah
          mov    elh+3,al
          mov    ax,ds:[si]
          cmp    ax,0
          je     dnl0
          dec    ax
          mov    es,ax
          mov    bx,es:[1]
          cmp    bx,0
          jne    dnl1
dnl0:
          mov    bx,nextload
dnl1:
          dec    si
          dec    si
          lodsw
          dec    ax
          mov    es,ax
          mov    ax,es:[1]
          sub    bx,ax
          mov    ax,bx
          call   dodec
          print  mess3
          pop    si
          pop    cx
          pop    es
          loop   envloop
donextl:
          mov    ax,nextload
          call   dohex
          mov    nlh,dh
          mov    nlh+1,dl
          mov    nlh+2,ah
          mov    nlh+3,al
          print mess4
          int      20h      ; back to dos
main      endp
dodec     proc   near
; takes the number of paragraphs in ax and converts it to
; decimal in esh
          push  ax
          mov   al,ah
          mov   cx,4
          shr   ax,cl
          and   ax,0fh
          mov   dx,ax
          pop   ax
          shl   ax,cl
          mov   cx,10000 ; divide dx:ax into 9999:9999
          div   cx
          push  ax
          mov   ax,dx
          call  dhex1
          mov    esh+2,dh
          mov    esh+3,dl
          mov    esh+4,ah
          mov    esh+5,al
          pop    ax
          call  dhex1
          mov    esh+0,ah
          mov    esh+1,al
; clean up the line
          lea   bx,esh
          mov   cx,5
cleanloop:
          cmp   byte ptr ds:[bx],'0'
          jne   cleanend
          mov   byte ptr ds:[bx],' '
          inc   bx
          loop  cleanloop
cleanend:
          ret
dhex1:
  ; ax will be converted to 9999
          call  dhex2
          mov   bl,dl
          call  dhex2
          mov   bh,dl
          call  dhex2
          or    al,30h
          mov   dh,al
          mov   ax,bx
          ret
dhex2:
          mov   dx,0
          mov   cx,10
          div   cx
          or    dl,30h
          ret
dodec     endp
dohex     proc   near
    ; ax has a hex word to convert to display in dx:ax
          push   ax
          mov    al,ah
          mov    cx,4
          shr    ax,cl
          and    ax,0fh
          add    ax,30h
          cmp    ax,39h
          jle    nh1
          add    ax,7
nh1:
          mov    dh,al
          pop    ax
          push   ax
          mov    al,ah
          and    ax,0fh
          add    ax,30h
          cmp    ax,39h
          jle    nh2
          add    ax,7
nh2:
          mov    dl,al
          pop    ax
          push   ax
          mov    cx,4
          shr    ax,cl
          and    ax,0fh
          add    ax,30h
          cmp    ax,39h
          jle    nh3
          add    ax,7
nh3:
          mov    bh,al
          pop    ax
          and    ax,0fh
          add    ax,30h
          cmp    ax,39h
          jle    nh4
          add    ax,7
nh4:
          mov    ah,bh
          ret
dohex     endp
cseg      ends
          end      enter
