print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
SEGMENTSIZE equ 4000h
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
entry:
        jmp   start
hello    db 'Copyright 1992 by Keith P. Graham',13,10,'$'
goodbye db 'FG.COM (Fast GIF) vers. 2.04 copyright 1992 by Keith P. Graham',13,10
        db 'For the latest version of FG.COM and other neat software',13,10
        db 'Call the Keith Graham Support BBS at (914) 623-0039',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error6 db 'This program needs VGA to work',13,10,'$'
file1     db   '*.gif',65  dup(0)
bytes_read dw 0
;file2     db   65  dup(0)
handlei dw 0
ibuffer dw 0
hash_segment    dw 0
buffero dw 0
inloc   dw 0
last_line dw 0
cmode  db 0
vmode  db 0
vid_wid  dw 320
vid_len  dw 200
switches equ this byte
switchx db 0
switchv db 0
switchn db 0
        db  0
switchlist  db 'xvn',0,0,0
switchlen   equ 4
;
;
vesablock db 'XXXX'
vversion  dw 0
oemstring dd 0
cap       db 0,0,0,0
vidmodes  dd 0
vesamode  dw 0
curbk    dw 0
;
vesashift db 0
cline    dw  0

dta  db  15h dup(0)
attrib db 0
ftime  dw 0
fdate  dw 0
fsize  dd 0
fname  db 20 dup(0)
;filler db 80



include fgread.asm
include fgpres.asm
include fgvirt.asm

start:
    print hello
; get current mode
   mov   ah,15
   int   10h
   mov   cmode,al
; detect VGA and VESA
    call  parse_line
    jc    error_exit
    push  es
    call detect
    pop   es
    jc   error_exit
; have to list though the files here
;
    call  memory_alloc
    jc    error_exit
    call  fix_name
    call  state_file
    jc    error_exit
    call  set_mode
files_loop:
    call  open_file
    jc    bot_loop
    call  clean_mem
    call  gif_in
    push  cs
    pop   ds
    push  cs
    pop   es
    jc    bot_loop
    call  gif_read
    push  cs
    pop   ds
    push  cs
    pop   es
    mov   bx,handlei
    mov   ah,3eh
    int   21h
    call  set_palette
    call  control
    cmp   ax,4400h
    je    done_loop
bot_loop:
    push  cs
    pop   ds
    push  cs
    pop   es
    call  find_next
    jnc   files_loop
done_loop:
    mov   ah,0
    mov   al,cmode
    int   10h
good_exit:
    lea   dx,goodbye
    jmp   do_exit
error_exit:
    mov   ah,0
    mov   al,cmode
    int   10h
;   lea   dx,goodbye
do_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    call  xms_deallocate
    int   20h
;
;
read_file:
    mov   bytes_read,0
    push  bx
    push  cx
    push  dx
; get the file into memory
    mov   inloc,0
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,04000h   ; 16k at a time
    mov   ds,ibuffer
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    pop    dx
    pop    cx
    pop    bx
    stc
    ret
good_read:
    mov   bytes_read,ax
    cmp    ax,0
    je     bad_read
    pop    dx
    pop    cx
    pop    bx
    clc
    ret
find_next:
; this finds the next file
   mov  ah,4fh
   int  21h
   ret
state_file:
; this gets the first guy into the dta

; set the dta
  push  cs
  pop   ds
  push  cs
  pop   es
  mov  ah,1ah
  mov  dx,offset dta
  int  21h
   mov  ah,4eh
   mov  cx,0  ; normal only
   mov  dx,offset file1
   int  21h
   jnc  sf_1
   mov  dx,offset error1
   stc
sf_1:
   ret
fix_name:
; fixes the filename
  push  cs
  pop   ds
  push  cs
  pop   es
    lea  si,file1
fn_1:
    cmp  byte ptr ds:[si],0
    je   add_gif
    cmp  byte ptr ds:[si],'.'
    je   got_ext
    inc  si
    jmp  fn_1
add_gif:
    mov  di,si
    mov  ax,'G.'
    stosw
    mov  ax,'FI'
    stosw
    mov  al,0
    stosb
got_ext:
    clc
    ret



open_file:
; opens the file for reading
;
; add the filename to the path
    mov  si,offset file1
    mov  di,offset file1
of_1:
    cld
    lodsb
    cmp  al,0
    je   of_3
    cmp  al,'\'
    je   of_2
    cmp  al,':'
    jne  of_1
of_2:
    mov  di,si
    jmp  of_1
of_3:
    mov  si,offset fname
    mov  cx,13
    cld
 rep movsb
    mov  cx,0
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
clean_mem:
    push  es
    mov   cx,tot_mem
    mov   curr_mb,0
cm_loop:
    push  cx
    call  get_curr_mb
    mov   es,ax
    mov   cx,SEGMENTSIZE/2
    mov   ax,0
    mov   di,0
    cld
rep stosw
    call  get_next_mb
    pop   cx
    loop  cm_loop
    mov   curr_mb,0
;
    pop   es
;
;
;===================================================================
    ret
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    cmp  cx,1
    jge  pl0
    clc
    ret
pl0:
    mov  al,'/'
    cld
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    push cx
    push di
    mov  di,0
    mov  si,0
    mov  cx,switchlen
sw_loop:
    cmp  al,byte ptr switchlist[di]
    jne  sw_bot_loop
    mov  switches[si],al
    jmp  done_switch
sw_bot_loop:
    inc  si
    inc  di
    loop  sw_loop
done_switch:
    pop  di
    pop  cx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    clc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    ret
detect:
; checks for a valid monitor
    mov    vmode,13h

	mov	ax,1a00h
	int	10h
	cmp	al,1ah
	jne	aint_vga
	mov	ax,1a01h
	int	10h
	cmp	al,1ah
	jne	aint_vga
	jmp	its_vga
aint_vga:
     mov  dx,offset error6
     stc
     ret
its_vga:
;
; check for VESA
;
;
        cmp   switchv,'v'
        je    no_vesa2
        mov   ah,4fh
        mov   al,0
        mov   di,offset vesablock
        int   10h
;
        cmp   word ptr vesablock,'EV'
        je   vesa1
no_vesa2:
        jmp   no_vesa
vesa1:
        cmp   word ptr vesablock+2,'AS'
        je   vesa2
        jmp   no_vesa
vesa2:
; have to find the best mode for us.
; 1) try 1280, 1024, 800 and 640
;        107h, 105h, 103h    100 or 101
;
         mov   ax,107h
         call  get_vimode
         jc    try_105
         mov   vesamode,107h
	MOV	vid_wid,1280
	MOV	vid_len,1024
         jmp   done_vesa
try_105:
         mov   ax,105h
         call  get_vimode
         jc    try_103
         mov   vesamode,105h
	MOV	vid_wid,1024
	MOV	vid_len,768
         jmp   done_vesa
try_103:
         mov   ax,103h
         call  get_vimode
         jc    try_101
         mov   vesamode,103h
	MOV	vid_wid,800
	MOV	vid_len,600
         jmp   done_vesa
try_101:
         mov   ax,101h
         call  get_vimode
         jc    try_100
         mov   vesamode,101h
	MOV	vid_wid,640
	MOV	vid_len,480
         jmp   done_vesa
try_100:
         mov   ax,100h
         call  get_vimode
         jc    no_vesa
         mov   vesamode,100h
	MOV	vid_wid,640
	MOV	vid_len,480
         jmp   done_vesa
done_vesa:
; got the vesa mode
         mov vmode,-1
no_vesa:
         clc
         ret

get_vimode:
         push  es
         les   di,vidmodes
         mov   cx,64
loop_vi:
         cmp   word ptr es:[di],0ffffh
         je    no_vi
         cmp   word ptr es:[di],ax
         je    got_vi
         inc   di
         inc   di
         loop  loop_vi
no_vi:
         pop  es
         stc
         ret
got_vi:
         pop   es
         clc
         ret
set_mode:
setup_vesa:
     cmp  vmode,-1
     jne  do_13
; set mode using VESA
        mov  ah,4fh
        mov  al,2
        mov  bx,vesamode
        int  10h
	CLC
	RET
; this sets up the vesa stuff


do_13:
    mov   ax,13h
    int   10h
    clc
     ret

     ret
cseg ends
    end entry

