cseg segment para public 'CODE'
assume  cs:cseg,ds:cseg,es:cseg
; this is the allocation stuff for DS. Does a shrink etc
extrn  direct:word,mswitch:byte,bswitch:byte,dswitch:byte,nswitch:byte
extrn  error_code:word,oswitch:byte,gswitch:byte
last_byte equ this byte
menu equ this byte
screen equ byte ptr menu+2048
istack equ word ptr screen+4000
lstack equ word ptr istack+512
sstack equ word ptr lstack+512
allints equ word ptr sstack+512
oldints equ word ptr allints+1024
fontsave equ word ptr oldints+1024
public menu,screen,istack,lstack,allints,oldints,fontsave
public sstack
shrink:
public shrink
; allocates memory
; shrink
;
     mov  ah,4ah
     lea  bx,last_byte
     add  bx,2048 ; menu
     add  bx,4080; screensave
     add  bx,8400; fontsave
     add  bx,512  ; istack
     add  bx,512  ; lstack
     add  bx,1024 ; allints
     add  bx,1024 ; oldints
     add  bx,512  ; stack
     shr  bx,1
     shr  bx,1
     shr  bx,1
     shr  bx,1
     inc  bx   ; for safety
     int  21h
     jnc  good_shrink
bad_mem:
     mov   error_code,2
     stc
     ret
good_shrink:
     clc
     ret
parse:
public parse
; this gets the command line, looking for a menu or a command
    mov   si,81h
    mov   cl,byte ptr ds:[80h]
    mov   ch,0
    cmp   cx,1
    jg    find_sw
no_sw:
    dec   si
    clc
    ret
find_sw:
    cld
    lodsb
    cmp   al,'/'
    je    got_sw
    cmp   al,' '
    je    find_sw
    cmp   al,9  ; tab
    je    find_sw
    jmp   no_sw
got_sw:
    lodsb
    cmp   al,'a'
    jl    upper
    cmp   al,'z'
    jg    upper
    sub   al,20h
upper:
    cmp   al,'B'
    je    gotb
    cmp   al,'M'
    je    gotm
    cmp   al,'D'
    je    gotd
    cmp   al,'N'
    je    gotn
    cmp   al,'O'
    je    got0
    cmp   al,'G'
    je    gotg
    jmp   find_sw
gotm:
    mov   mswitch,al
    mov   direct,si ; points to command or menu
    jmp   find_sw
gotd:
    mov   dswitch,al
    mov   direct,si ; points to command or menu
    jmp   find_sw
gotn:
    mov   nswitch,al
    mov   direct,si ; points to command or menu
    jmp   find_sw
gotb:
    mov   bswitch,al
    mov   direct,si ; points to command or menu
    jmp   find_sw
got0:
    mov   oswitch,1
    mov   direct,si ; points to command or menu
    jmp   find_sw
gotg:
    mov   gswitch,1
    mov   direct,si ; points to command or menu
    jmp   find_sw
cseg	ends
     end
