cseg segment para public 'CODE'
assume cs:cseg,ds:cseg,es:cseg
extrn do_window:near
extrn undo_window:near
extrn int9:near,int21:near,int17:near,int14:near,int28:near
extrn oint9:word,oint21:word,oint17:word,oint14:word,oint28:word
last_byte equ this byte
;
errorsave dw 40*25 dup(0)
;
cursor  dw 0
copyr   db 22,06,071h
    dw  errorsave
    db  '   IV LaserJet Survival System ',10
    db  ' Copyright 1989 By Keith P. Graham',10
    db  '    System now installing.',10,0
inste   db 22,12,04fh
    dw  errorsave
    db  ' IV System already installed.',10
    db  ' Installation procedure ended.',10,0
setres:
public setres
    call  save_cursor
    lea  si,copyr
    call  do_window
; check to see if the program ahs been previously installed
    mov   ax,'KG'
    int   17h
    cmp   ax,'EC'
    jne   cont_install
    call  undo_window
    lea  si,inste
    call  do_window
    call restore_cursor
    int  20h
cont_install:
; set up interrupts
;    int  9
    mov   ax,3509h  ; kbd interrup
    int   21h
    mov   oint9,bx
    mov   oint9+2,es
    mov   ax,2509h
    lea   dx,int9
    int   21h
;    int  17
    mov   ax,3509h  ; prt interrup
    int   21h
    mov   oint17,bx
    mov   oint17+2,es
    mov   ax,2517h
    lea   dx,int17
    int   21h
;    int  21
    mov   ax,3521h  ; dos interrup
    int   21h
    mov   oint21,bx
    mov   oint21+2,es
    mov   ax,2521h
    lea   dx,int21
    int   21h
    call  undo_window
    call restore_cursor
    lea   dx,last_byte
    int  27h
restore_cursor:
; restore cursor
    mov    dx,cursor
    mov    ah,2
    mov    bx,0
    int    10h
save_cursor:
; get and save current x,y position
    mov   ah,3
    mov   bx,0
    int   10h
    mov   cursor,dx
    ret
cseg ends
    end
