;
follows  db 4*tablesize+1 dup(0)
;
     dw   10 dup(0)
last_code  dw  0
;
byte_no  dw 0
;
fill_follow:
     lea   di,follows
     cld
     mov   cx,tablesize+1
     mov   al,13
     mov   ah,' '
ff1:
     stosw
     loop  ff1
     ret
follower:
; this takes a byte in al and converts it to a follower
    mov  bx,last_code
    mov  bh,0
    shl  bx,1
    mov  cx,word ptr follows[bx]
    mov  last_code,ax
    mov  si,home.child
    mov  dl,home[si].who
    mov  si,home[si].child
    mov  dh,home[si].who
    mov  si,home[si].child
    mov  ah,home[si].who
; check first byte for translation
    cmp  dh,cl   ; see if translation could result in error
    je   no_follow
    cmp  cl,al     ; candidate for follower?
    je   follow1
    cmp  al,dl     ; is it a low
    je   ferr1
    cmp  dl,ch     ; could this cause confusion?
    je   no_follow
    cmp  ch,al     ; could be a follower?
    je   follow2
    cmp  al,dh     ; is it a low2
    je   ferr2
no_follow2:
    jmp  no_follow
follow1:
    mov  al,dl    ; relace follower with low
    mov  ah,0
    jmp  replace_f
follow2:
; we have a match on second, but must also update the followers
    mov  al,dh
    xchg  cl,ch  ; already match on ch so make that most important
    jmp   rf2
replace_f:
    cmp   cl,ch
    jne  rf2
    mov  ch,dh
    cmp   cl,ch
    jne   rf2
    mov   cl,dl
rf2:
    cmp   cl,dh
    jne   rf3
    xchg  cl,ch
    cmp   cl,dh
    jne   rf3
    mov   cl,dl
rf3:
    cmp   ch,dl
    jne   rf4
    xchg  cl,ch
    cmp   ch,dl
    jne   rf4
    jmp   replace_f
rf4:
    mov   word ptr follows[bx],cx
    mov  ah,0
    ret
;
ferr1:
; force error because al did not match but is a low guy
; if forcing an error would cause the other low then we can't do it

    xchg  cl,al
    jmp   replace_f
ferr2:
; force error
    xchg  ch,al
    xchg  cl,ch
    jmp   replace_f
no_follow:
; this adjusts the follower table
    mov  ch,cl
    mov  cl,al
    jmp   replace_f
;
