check_weight:
   cmp   dx,0
   jne   rank_hi
   cmp   ds:home[bx].weight,turnpoint
   jbe   rank_hi
   mov   cx,tablesize+1
   mov   si,0
w_loop:
   mov   si,home[si].child
   mov   ax,home[si].weight
   mov   bx,ax
   dec   bx
   cmp   bx,0
   jle   rank_hi
   shr   bx,1
   cmp   bx,0
   jle   rank_hi
   shr   bx,1
   cmp   bx,0
   jle   rank_hi
   cmp   bx,0
   jle   rank_hi
   sub   ax,bx
   shr   bx,1
   add   ax,bx
   mov   home[si].weight,ax
   loop  w_loop
rank_hi:
   ret
;


fix_weight:
   add   cx,ds:home[bx].weight  ; out_byte returns weight in cx
   mov   ds:home[bx].weight,cx  ; change our current weight
   mov   dx,ds:home[bx].rank    ; keep our current rank
   cmp   dx,0                   ; are we already at top?
   jbe   no_swap                ; if yes we are done
   mov   si,ds:home[bx].parent  ; get out parents address
;
;
   cmp   ds:home[si].weight,cx  ; are we heavier than our parents?
   jae   no_swap                ; if not then no swap
   mov   di,ds:home[bx].child   ; get out child's address
;  first thing to do is remove our node
;  this is done by making the parent of or child our parent
;  and the child of our parent our child
   mov   ds:home[si].child,di  ; our parent's child is now our child
   mov   ds:home[di].parent,si ; our child's parent is now our parent
   mov   ds:home[si].rank,dx   ; our parent now replaces us in rank
;  now look for a parent that has a weight greater than our weight
check_again:
; no swap so we dec the parents dx
   dec   dx                    ; reduce our rank
   mov   di,si                 ; save child of prospective parent
   mov   si,ds:home[si].parent  ; we look at parent's parents
   cmp   ds:home[si].weight,cx  ; are they heavier than us?
   ja    do_swap                ; if they are we swap
   cmp   dx,0                   ; are we now at zero rank?
   jbe   do_swap                ; if we are then we're done
   mov   ds:home[si].rank,dx   ; our parent now replaces us in rank
   jmp   check_again            ; check the next parent
do_swap:
; we set up our rank
   mov   ds:home[bx].rank,dx    ; we have now a new rank
;  our new child must be the parents child
;  our parent's child is in di
   mov   ds:home[bx].child,di ; make our parents child our child
; parents child must be us
   mov   ds:home[si].child,bx ; mom and dad have little old me
; our parent must be parent
   mov   ds:home[bx].parent,si ; claim our parents
; our child must have us for a parent
   mov   ds:home[di].parent,bx ; claim our new children
;  jmp   no_swap
;
;
no_swap:
   ret
