
;
method = 1
;
nodes struc
who	db ?
ind	db ?
first	dw ?
next	dw ?
dad	dw ?
nodes	ends
;
;
;
tail	dw 0
free_count dw 0
;
;
;
;
;
compress:
	cld
	call	get_byte
	jnc	trace0
	clc
	ret
trace0:
;
; al has the character to decode ; es has the node space
	mov	di,ax
	shl	di,1	; x 2
	shl	di,1	; x 4
	shl	di,1	; x 8
; di has the root of a problem and it is undestood that
; al matches
; have to get the next guy to see if he is involved here
	cmp	free_count,4
	jbe	got_hit0
	cmp	free,-1
	jne	got_hit
	mov	bx,free_count
	int 3
got_hit0:
	call	init_nodes
got_hit:
	call	get_byte
	jnc	tr1
; no bytes left, get rid of current guy and scram
	call	out_code
	stc
	ret
errorx4:
	mov	al,'4'
        jmp     errorl
errorx3:
	mov	al,'3'
        jmp     errorl
errorx2:
	mov	al,'2'
        jmp     errorl
errorx1:
	mov	al,'1'
        jmp     errorl
errorx:
	mov	al,'x'
        jmp     errorl
errorl:
        mov     ah,14
	int	10h
	int	20h
tr1:
; have a matched di and an al looking for a home
	mov	dx,di	; last hit
	mov	bl,es:[di].ind
	mov	bh,0
	jmp	stages[bx]
stages	dw	root,root2,add_first4,add_first6
	dw	root2,root2,add_first12,add_first14
move_next10:
	mov	di,es:[di].next
	jmp	check_who
root2:
; match on root, move up
	mov	di,es:[di].first
check_who:
	cmp	es:[di].who,al
	je	got_hit
; we are at a no match situation
	mov	bl,es:[di].ind
	mov	bh,0
	jmp	stage2[bx]
stage2	dw	errorx,errorx,add_next4,add_next6
	dw	add_next8,move_next10,move_next10,add_next14
root:
	mov	cl,2
	jmp	add_first
add_first14:
	mov	cl,8
	jmp	add_first
add_first12:
	mov	cl,10
	jmp	add_first
; adding a first to a guy with 4 or 6, need to fix free string
add_first4:
	call	free_node 	; commits current di
	mov	cl,8
 	jmp	add_first
add_first6:
	call	free_node 	; commits current di
	mov	cl,8
;	jmp	add_first
add_first:
	mov	es:[di].ind,cl
; free
	call	get_free
;
	mov	es:[di].first,si
	mov	es:[si].ind,4
;
add_node:
	call	out_code
; set up next
	call	append_node
	mov	es:[si].dad,di
	mov	es:[si].who,al
	jmp	trace0
;
;
append_node:
; this adds the guy in si to the end of the chain
        mov   bx,tail
        mov   tail,si
        mov   es:[si].next,-1
        mov   es:[bx].next,si
        mov   es:[si].first,bx
;
	ret
;
;
free_node:
; freeing a node occurs when a 4 or a 6 is hit.
;
        push  bx
        push  si
        dec   free_count
        mov   bx,es:[di].first
        mov   si,es:[di].next
        cmp   bx,-1
        jne   fn_1
        mov   free,si
        jmp   fn_2
fn_1:
        mov   es:[bx].next,si
fn_2:
        cmp   si,-1
        jne   fn_3
        mov   tail,bx
        jmp   fn_4
fn_3:
        mov   es:[si].first,bx
fn_4:
        mov   es:[di].ind,16
        pop   si
        pop   bx
        ret
;
;
;
;
;
gf_x:
        dec     free_count
        mov     bx,es:[si].next
        mov     es:[bx].first,-1
get_free:
	mov	si,free
	mov	bx,es:[si].next
	mov	free,bx
        mov     es:[si].first,-1
        cmp     si,di
        je      gf_x
;
; now have to see if this node needs committing
gf_0:
        mov     bl,es:[si].ind
        cmp     bl,0
        je      gf_1
        cmp     bl,4
        je      commit_node4
        cmp     bl,6
        je      commit_node6
gf_1:
        ret
;
;
commit_node4:
; committing a node means that a node is being reused so
; anyone who is using the node has to be fixed
; these take a 4/6 and makes the guy pointing to it a loner
; di is current node.
        push  bx
        push  cx
        mov   bx,es:[si].dad
        mov   cl,0
        cmp   es:[bx].ind,2
        je    cn_2
        mov   cl,12
        cmp   es:[bx].ind,10
        je    cn_2
        mov   cl,14
        cmp   es:[bx].ind,8
        je    cn_2
        mov   ah,es:[bx].ind
        mov   cx,free_count
        int 3
        jmp   errorx1
cn_2:
        mov   es:[bx].ind,cl
        pop   cx
        pop   bx
	ret
;
commit_node6:
        push  bx
        push  cx
        mov   bx,es:[si].dad
        mov   cl,14
        cmp   es:[bx].ind,12
        je    cn_2
        mov   cl,8
        cmp   es:[bx].ind,10
        je    cn_2
        mov   ah,es:[bx].ind
        mov   cx,free_count
        int 3
        jmp   errorx2
;
;
;
add_next4:
	call	free_node
	mov	cl,12
	jmp	add_next
add_next6:
	call	free_node
	mov	cl,12
	jmp	add_next
add_next14:
	mov	cl,12
	jmp	add_next
add_next8:
	mov	cl,10
	jmp	add_next
add_next:
	mov	es:[di].ind,cl
; free
	call	get_free
;
	mov	es:[di].next,si
	mov	es:[si].ind,6
	jmp	add_node
;
out_code:
	push	ax
	push	cx
	push	dx
	mov	ax,dx
	shr	ax,1
	shr	ax,1
	shr	ax,1
	call	put_byte
	pop	dx
	pop	cx
	pop	ax
	ret
;
;
;
;
;
;
;
;
init_nodes:
; output the clear charater
	push	ax
	mov	ax,'C'
	int	10h
	pop	ax
	mov	bits,9
	mov	bitsize,512
	push	ax
	push	di
	mov	di,0
	mov	bp,es
	mov	es,nodespace
	mov	cx,256
	mov	ax,0
	mov	bx,8
in1:
	mov	es:[di].next,bx
	mov	es:[di].first,-1
	mov	es:[di].who,al
	mov	es:[di].ind,0	; taken, not free
	mov	es:[di].dad,-1
	add	di,8
	add	bx,8
	inc	al
	loop	in1
	mov	free,di
; set up the free chain
	mov	cx,(0ffffh/8)-259
;	mov	cx,4096-258
;	mov	cx,8192-257
;	mov	cx,512
;	mov	cx,2048-257
	mov	free_count,cx
	mov	bx,di
	mov	bx,-1
in2:
	mov	ax,di
	add	ax,8
	mov	es:[di].next,ax	; contains the free chain
	mov	es:[di].dad,-1
	mov	es:[di].first,bx
	mov	es:[di].ind,0
	mov	bx,di
	mov	di,ax
	loop	in2
        mov     di,bx
	mov	tail,di
	mov	es:[di].next,-1
	mov	es,bp
	pop	di
	call	put_clear ; puts a clear character
	pop	ax
	ret
;
put_clear:
	push	ax
	push	bx
	push	di
	mov	ax,100h
	mov	cx,bits
	inc	cx
	jmp	clear
;
put_byte:
	push	ax
	push	bx
	push	di
	mov	cx,bits
	cmp	ax,100h
	jae	pb_2
	add	buck2,1
	adc	buck2+2,0
	add	buck4,9
	adc	buck4+2,0
	jmp	pb_3
pb_2:
	inc	ax
	add	buck3,1
	adc	buck3+2,0
	mov	cx,bits
	inc	cx
	add	buck4,cx
	adc	buck4+2,0
        cmp     ax,bitsize
        jbe     pb_8
	shl	bitsize,1
	inc	bits
pb_3:
	jmp	pb_8
clear:
	add	buck4,cx
	adc	buck4+2,0
pb_8:
	mov	di,outloc
	mov	bp,es
	mov	es,buffero
	stosw
	mov	es,bp
	mov	outloc,di
; adjust bits
pb_9:
	cmp	di,07ff0h
	ja	full_buff
	pop	di
	pop	bx
	pop	ax
	clc
	ret
full_buff:
	mov	cx,di
	call	write_file
	mov	outloc,0
	pop	di
	pop	bx
	pop	ax
	clc
	ret
;
; this gets the next byte out of the buffer
get_byte:
	push	bx
	push	cx
	push	si
	push	di
	mov	si,bufferloc
	cmp	si,file_size
	jb	got_byte
	call	read_file
	mov	si,bufferloc
	cmp	ax,0
	jne	got_byte
	pop	di
	pop	si
	pop	cx
	pop	bx
	stc
	ret
got_byte:
	mov	bp,ds
	mov	ds,bufferi
	lodsb
	mov	ah,0
	mov	ds,bp
	mov	bufferloc,si
	pop	di
	pop	si
	pop	cx
	pop	bx
	clc
	ret
